[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://juliageo.github.io/GeoInterface.jl/stable)
[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://juliageo.github.io/GeoInterface.jl/dev)
[![CI](https://github.com/JuliaGeo/GeoInterface.jl/actions/workflows/CI.yml/badge.svg)](https://github.com/JuliaGeo/GeoInterface.jl/actions/workflows/CI.yml)
[![deps](https://juliahub.com/docs/GeoInterface/deps.svg)](https://juliahub.com/ui/Packages/GeoInterface/GJg1M?t=2)
[![codecov](https://codecov.io/gh/JuliaGeo/GeoInterface.jl/branch/master/graph/badge.svg?token=ccpOaPSi08)](https://codecov.io/gh/JuliaGeo/GeoInterface.jl)

# GeoInterface
An interface for geospatial vector data in [Julia](https://julialang.org/).

This Package describe a set of traits based on the [Simple Features standard
(SF)](https://www.opengeospatial.org/standards/sfa) for geospatial vector data, including
the SQL/MM extension with support for circular geometry. Using these traits, it should be
easy to parse, serialize and use different geometries in the Julia ecosystem, without
knowing the specifics of each individual package. In that regard it is similar to
[Tables.jl](https://github.com/JuliaData/Tables.jl), but for geometries instead of tables.

Packages which support the GeoInterface.jl interface can be found in
[INTEGRATIONS.md](INTEGRATIONS.md).

# GeoInterfaceRecipes.jl

**This package is deprecated.**

Plotting recipes for GeoInterface geometries are now built directly into [GeoInterface.jl](https://github.com/JuliaGeo/GeoInterface.jl) as package extensions:

- **Plots.jl support**: Load `GeoInterface` with `Plots` and recipes work automatically
- **Makie.jl support**: Load `GeoInterface` with `Makie` and `GeometryBasics` for Makie plotting

## Migration

No action is needed. Simply remove `GeoInterfaceRecipes` from your dependencies and use `GeoInterface` directly with your preferred plotting package.

```julia
using GeoInterface
using Plots  # or using Makie

# Plotting just works
plot(my_geometry)
```

This empty package exists only to provide a smooth upgrade path for users who had GeoInterfaceRecipes.jl in their dependencies.

# Implementation of GeoInterface for Base Types


# AbstractVector{<:Real} length 2 - 4 (where length checking is possible and efficient)

GeoInterface.isgeometry(::Type{<:AbstractVector{<:Real}}) = true
GeoInterface.geomtrait(::AbstractVector{<:Real}) = PointTrait()
GeoInterface.ncoord(::PointTrait, geom::AbstractVector{<:Real}) = Base.length(geom) # TODO should this error for length > 4 ?
GeoInterface.getcoord(::PointTrait, geom::AbstractVector{<:Real}, i) = getindex(geom, i)
GeoInterface.is3d(::PointTrait, geom::AbstractVector{<:Real}) = Base.length(geom) in (3, 4)
GeoInterface.ismeasured(::PointTrait, geom::AbstractVector{<:Real}) = Base.length(geom) == 4 # for vectors, we assume the 3rd element is always Z, so a vector can only have M if it is length 4.
# x/y/z/m methods were 100x slower without these custom definitions
# Also allow @inbounds to make them slightly faster when you know the sizes
Base.@propagate_inbounds function GeoInterface.x(::PointTrait, geom::AbstractVector{<:Real})
    @boundscheck Base.length(geom) in (2, 3, 4) || _xy_error(Base.length(geom))
    @inbounds geom[begin]
end
Base.@propagate_inbounds function GeoInterface.y(::PointTrait, geom::AbstractVector{<:Real})
    @boundscheck Base.length(geom) in (2, 3, 4) || _xy_error(Base.length(geom))
    @inbounds geom[begin + 1]
end
Base.@propagate_inbounds function GeoInterface.z(::PointTrait, geom::AbstractVector{<:Real})
    @boundscheck Base.length(geom) in (3, 4) || _z_error(Base.length(geom))
    @inbounds geom[begin + 2]
end
Base.@propagate_inbounds function GeoInterface.m(::PointTrait, geom::AbstractVector{<:Real})
    @boundscheck Base.length(geom) == 4 || _m_error(Base.length(geom))
    @inbounds geom[end]
end

@noinline _xy_error(l) = throw(ArgumentError("Length of point must be 2, 3 or 4 to use `GeoInterface.x(point)` or `GeoInterface.y(point)`, got $l"))
@noinline _z_error(l) = throw(ArgumentError("Length of point must be 3 or 4 to use `GeoInterface.z(point)`, got $l"))
@noinline _m_error(l) = throw(ArgumentError("Length of point must be 4 to use `GeoInterface.m(point)`, got $l"))


# Tuple length 2 - 4

const PointTuple2 = Tuple{<:Real,<:Real}
const PointTuple3 = Tuple{<:Real,<:Real,<:Real}
const PointTuple4 = Tuple{<:Real,<:Real,<:Real,<:Real}
const PointTuple = Union{PointTuple2,PointTuple3,PointTuple4}

GeoInterface.isgeometry(::Type{<:PointTuple}) = true
GeoInterface.geomtrait(::PointTuple) = PointTrait()
GeoInterface.ncoord(::PointTrait, geom::PointTuple) = Base.length(geom)
GeoInterface.getcoord(::PointTrait, geom::PointTuple, i) = getindex(geom, i)
GeoInterface.is3d(::PointTrait, geom::PointTuple2) = false
GeoInterface.is3d(::PointTrait, geom::Union{PointTuple3,PointTuple4}) = true
GeoInterface.ismeasured(::PointTrait, geom::Union{PointTuple2,PointTuple3}) = false
GeoInterface.ismeasured(::PointTrait, geom::PointTuple4) = true

GeoInterface.x(::PointTrait, geom::PointTuple) = geom[1]
GeoInterface.y(::PointTrait, geom::PointTuple) = geom[2]
GeoInterface.z(::PointTrait, geom::PointTuple2) = _z_error(Base.length(geom))
GeoInterface.z(::PointTrait, geom::Union{PointTuple3,PointTuple4}) = geom[3]
GeoInterface.m(::PointTrait, geom::PointTuple4) = geom[4]
GeoInterface.m(::PointTrait, geom::Union{PointTuple2,PointTuple3}) = _m_error(Base.length(geom))


# NamedTuple 
# with X/Y/Z/M names in any order

# Define all possible NamedTuple points
const NamedTuplePointXY = Union{
    NamedTuple{(:X, :Y),<:PointTuple2},
    NamedTuple{(:Y, :X),<:PointTuple2},
}

const NamedTuplePointZ = Union{
    NamedTuple{(:X, :Y, :Z),<:PointTuple3},
    NamedTuple{(:X, :Z, :Y),<:PointTuple3},
    NamedTuple{(:Z, :Y, :X),<:PointTuple3},
    NamedTuple{(:Z, :X, :Y),<:PointTuple3},
    NamedTuple{(:Y, :X, :Z),<:PointTuple3},
    NamedTuple{(:Y, :Z, :X),<:PointTuple3},
}
const NamedTuplePointM = Union{
    NamedTuple{(:X, :Y, :M),<:PointTuple3},
    NamedTuple{(:X, :M, :Y),<:PointTuple3},
    NamedTuple{(:M, :Y, :X),<:PointTuple3},
    NamedTuple{(:M, :X, :Y),<:PointTuple3},
    NamedTuple{(:Y, :X, :Z),<:PointTuple3},
    NamedTuple{(:Y, :Z, :X),<:PointTuple3},
}
const NamedTuplePointZM = Union{
    NamedTuple{(:X, :Y, :Z, :M),<:PointTuple4},
    NamedTuple{(:X, :Y, :M, :Z),<:PointTuple4},
    NamedTuple{(:X, :Z, :Y, :M),<:PointTuple4},
    NamedTuple{(:X, :Z, :M, :Y),<:PointTuple4},
    NamedTuple{(:X, :M, :Z, :Y),<:PointTuple4},
    NamedTuple{(:X, :M, :Y, :Z),<:PointTuple4},
    NamedTuple{(:Y, :X, :Z, :M),<:PointTuple4},
    NamedTuple{(:Y, :X, :M, :Z),<:PointTuple4},
    NamedTuple{(:Y, :Z, :X, :M),<:PointTuple4},
    NamedTuple{(:Y, :Z, :M, :X),<:PointTuple4},
    NamedTuple{(:Y, :M, :Z, :X),<:PointTuple4},
    NamedTuple{(:Y, :M, :X, :Z),<:PointTuple4},
    NamedTuple{(:Z, :Y, :X, :M),<:PointTuple4},
    NamedTuple{(:Z, :Y, :M, :X),<:PointTuple4},
    NamedTuple{(:Z, :X, :Y, :M),<:PointTuple4},
    NamedTuple{(:Z, :X, :M, :Y),<:PointTuple4},
    NamedTuple{(:Z, :M, :X, :Y),<:PointTuple4},
    NamedTuple{(:Z, :M, :Y, :X),<:PointTuple4},
    NamedTuple{(:M, :Y, :Z, :X),<:PointTuple4},
    NamedTuple{(:M, :Y, :X, :Z),<:PointTuple4},
    NamedTuple{(:M, :Z, :Y, :X),<:PointTuple4},
    NamedTuple{(:M, :Z, :X, :Y),<:PointTuple4},
    NamedTuple{(:M, :X, :Z, :Y),<:PointTuple4},
    NamedTuple{(:M, :X, :Y, :Z),<:PointTuple4},
}

const NamedTuplePoint = Union{NamedTuplePointXY,NamedTuplePointZ,NamedTuplePointM,NamedTuplePointZM}

_keys(::Type{<:NamedTuple{K}}) where K = K
GeoInterface.isgeometry(::Type{T}) where {T<:NamedTuplePoint} = true
GeoInterface.geomtrait(::NamedTuplePoint) = PointTrait()
GeoInterface.ncoord(::PointTrait, geom::NamedTuplePoint) = Base.length(geom)
GeoInterface.getcoord(::PointTrait, geom::NamedTuplePoint, i) = getindex(geom, i)
GeoInterface.coordnames(::PointTrait, geom::NamedTuplePoint) = _keys(typeof(geom))
GeoInterface.x(::PointTrait, geom::NamedTuplePoint) = geom.X
GeoInterface.y(::PointTrait, geom::NamedTuplePoint) = geom.Y
GeoInterface.z(::PointTrait, geom::Union{NamedTuplePointZ,NamedTuplePointZM}) = geom.Z
GeoInterface.z(::PointTrait, geom::NamedTuplePointXY) = throw(ArgumentError("NamedTuple point has no Z field"))
GeoInterface.m(::PointTrait, geom::Union{NamedTuplePointXY,NamedTuplePointZ}) = throw(ArgumentError("NamedTuple point has no M field"))


# Default features using NamedTuple and AbstractArray

# Any named tuple with a `:geometry` field is a feature
_is_namedtuple_feature(::Type{<:NamedTuple{K}}) where K = :geometry in K
_is_namedtuple_feature(nt::NamedTuple) = _is_namedtuple_feature(typeof(nt))

GeoInterface.isfeature(T::Type{<:NamedTuple}) = _is_namedtuple_feature(T)
GeoInterface.trait(nt::NamedTuple) = _is_namedtuple_feature(nt) ? FeatureTrait() : geomtrait(nt)
GeoInterface.geometry(nt::NamedTuple) = _is_namedtuple_feature(nt) ? nt.geometry : nothing
GeoInterface.properties(nt::NamedTuple) = _is_namedtuple_feature(nt) ? _nt_properties(nt) : nothing

# Use Val to force constant propagation through `reduce`
function _nt_properties(nt::NamedTuple{K}) where K
    keys = reduce(K; init=()) do acc, k
        k == :geometry ? acc : (acc..., k)
    end
    return NamedTuple{keys}(nt)
end

const MaybeArrayFeatureCollection = AbstractArray{<:NamedTuple}

_is_array_featurecollection(::Type{<:AbstractArray{T}}) where {T<:NamedTuple} = _is_namedtuple_feature(T)
_is_array_featurecollection(A::AbstractArray{<:NamedTuple}) = _is_array_featurecollection(typeof(A))

GeoInterface.isfeaturecollection(T::Type{<:MaybeArrayFeatureCollection}) = _is_array_featurecollection(T)
GeoInterface.trait(fc::MaybeArrayFeatureCollection) = _is_array_featurecollection(fc) ? FeatureCollectionTrait() : geomtrait(fc)
GeoInterface.nfeature(::FeatureCollectionTrait, fc::MaybeArrayFeatureCollection) = _is_array_featurecollection(fc) ? Base.length(fc) : nothing
GeoInterface.getfeature(::FeatureCollectionTrait, fc::MaybeArrayFeatureCollection, i::Integer) = _is_array_featurecollection(fc) ? fc[i] : nothing
GeoInterface.geometrycolumns(fc::MaybeArrayFeatureCollection) = _is_array_featurecollection(fc) ? (:geometry,) : nothing

# Extents.Extent as RectangleTrait
GeoInterface.isgeometry(::Type{Extent{(:X, :Y), V}}) where V <:Tuple  = true
GeoInterface.isgeometry(::Type{Extent{(:X, :Y, :Z), V}}) where V <:Tuple  = true
GeoInterface.isgeometry(::Type{Extent{(:X, :Y, :Z, :M), V}}) where V <:Tuple  = true
GeoInterface.geomtrait(::Extents.Extent) = RectangleTrait()
GeoInterface.ncoord(::RectangleTrait, geom::Extent{(:X, :Y)}) = 2
GeoInterface.ncoord(::RectangleTrait, geom::Extent{(:X, :Y, :Z)}) = 3
GeoInterface.ncoord(::RectangleTrait, geom::Extent{(:X, :Y, :Z, :M)}) = 4
GeoInterface.ngeom(::RectangleTrait, geom::Extents.Extent) = 1  # Rectangle has one ring
function GeoInterface.getgeom(::RectangleTrait, geom::Extents.Extent{(:X, :Y)}, i::Integer)
    i == 1 || throw(BoundsError(geom, i))

    x_bounds = geom.X
    y_bounds = geom.Y
    
    corners = [
            (x_bounds[1], y_bounds[1]),  # bottom-left
            (x_bounds[2], y_bounds[1]),  # bottom-right  
            (x_bounds[2], y_bounds[2]),  # top-right
            (x_bounds[1], y_bounds[2]),  # top-left
            (x_bounds[1], y_bounds[1])   # close the ring
    ]
    # Wrap the corners in a LinearRing
    return GeoInterface.LinearRing(corners)
end

function GeoInterface.getgeom(::RectangleTrait, geom::Extents.Extent, i::Integer)
    throw(ArgumentError("Extents with dimension other than XY are not supported as RectangleTrait geometries"))
end

# Adapted from https://raw.githubusercontent.com/JuliaData/Tables.jl/main/find_integrations.jl
####
#### automatically generate a list of integrations
####

###
### Usage
###
### 1. ensure a development version of GeoInterface.jl (`pkg> add GeoInterface`)
### 2. make sure the General registry is up to date (`pkg> up`)
### 3. run this script, which uses the first depot from DEPOT_PATH

DEPOT = first(DEPOT_PATH)
REGISTRIES = joinpath(DEPOT, "registries")
@info DEPOT
# find each package w/ a direct dependency on GeoInterface.jl
general = joinpath(DEPOT, "General")
mkpath(general)
# run(`tar -xzf General.tar.gz -C $general`)
pkgs = cd(REGISTRIES) do
    dirname.(readlines(`grep -rl ^GeoInterface General/. --include=Deps.toml`))
end

pkgnames = sort([splitpath(x)[end] for x in pkgs])

function parseurl(file)
    repo = readlines(file)[end]
    return strip(split(repo, " = ")[end], '"')
end

urls = [parseurl(joinpath(REGISTRIES, "General", string(first(nm)), nm, "Package.toml"))
        for nm in pkgnames]

open(joinpath(dirname(@__DIR__), "GeoInterface.jl", "INTEGRATIONS.md"), "w+") do io
    println(io, "# Packages\nPackages currently integrating with GeoInterface.jl:")
    for (nm, url) in zip(pkgnames, urls)
        println(io, "* [$nm]($url)")
    end
end

module GeoInterfaceRecipesBaseExt

using GeoInterface
using RecipesBase

const GI = GeoInterface

function GI._plots_apply_recipe(plotattributes, geom)
    @nospecialize
    series_list = RecipesBase.RecipeData[]
    RecipesBase.is_explicit(plotattributes, :label) || (plotattributes[:label] = :none)
    Base.push!(series_list, RecipesBase.RecipeData(plotattributes, (GeoInterface.trait(geom), geom)))
    return series_list
end

function GI._plots_apply_recipe_array(plotattributes, geom)
    @nospecialize
    series_list = RecipesBase.RecipeData[]
    RecipesBase.is_explicit(plotattributes, :label) || (plotattributes[:label] = :none)
    for g in Base.skipmissing(geom)
        Base.push!(series_list, RecipesBase.RecipeData(plotattributes, (GeoInterface.trait(g), g)))
    end
    return series_list
end

RecipesBase.@recipe function f(t::Union{GI.PointTrait,GI.MultiPointTrait}, geom)
    seriestype --> :scatter
    _coordvecs(t, geom)
end
RecipesBase.@recipe function f(t::Union{GI.AbstractLineStringTrait,GI.MultiLineStringTrait}, geom)
    seriestype --> :path
    _coordvecs(t, geom)
end
RecipesBase.@recipe function f(t::Union{GI.PolygonTrait,GI.MultiPolygonTrait,GI.LinearRingTrait}, geom)
    seriestype --> :shape
    _coordvecs(t, geom)
end
RecipesBase.@recipe f(::GI.GeometryCollectionTrait, collection) = collect(getgeom(collection))
# Features
RecipesBase.@recipe f(t::GI.FeatureTrait, feature) = GI.geometry(feature)
RecipesBase.@recipe f(t::GI.FeatureCollectionTrait, fc) = collect(GI.getfeature(fc))

# Convert coordinates to the form used by Plots.jl
_coordvecs(::GI.PointTrait, geom) = [tuple(GI.coordinates(geom)...)]
function _coordvecs(::GI.MultiPointTrait, geom)
    n = GI.npoint(geom)
    # We use a fixed conditional instead of dispatch,
    # as `is3d` may not be known at compile-time
    if GI.is3d(geom)
        _geom2coordvecs!(ntuple(_ -> Array{Float64}(undef, n), 3)..., geom)
    else
        _geom2coordvecs!(ntuple(_ -> Array{Float64}(undef, n), 2)..., geom)
    end
end
function _coordvecs(::GI.AbstractLineStringTrait, geom)
    n = GI.npoint(geom)
    if GI.is3d(geom)
        vecs = ntuple(_ -> Array{Float64}(undef, n), 3)
        return _geom2coordvecs!(vecs..., geom)
    else
        vecs = ntuple(_ -> Array{Float64}(undef, n), 2)
        return _geom2coordvecs!(vecs..., geom)
    end
end
function _coordvecs(::GI.MultiLineStringTrait, geom)
    function loop!(vecs, geom)
        i1 = 1
        for line in GI.getgeom(geom)
            i2 = i1 + GI.npoint(line) - 1
            vvecs = map(v -> view(v, i1:i2), vecs)
            _geom2coordvecs!(vvecs..., line)
            map(v -> v[i2 + 1] = NaN, vecs)
            i1 = i2 + 2
        end
        return vecs
    end
    n = GI.npoint(geom) + GI.ngeom(geom)
    if GI.is3d(geom)
        vecs = ntuple(_ -> Array{Float64}(undef, n), 3)
        return loop!(vecs, geom)
    else
        vecs = ntuple(_ -> Array{Float64}(undef, n), 2)
        return loop!(vecs, geom)
    end
end
function _coordvecs(::GI.LinearRingTrait, geom)
    points = GI.getpoint(geom)
    if GI.is3d(geom)
        return getcoord.(points, 1), getcoord.(points, 2), getcoord.(points, 3)
    else
        return getcoord.(points, 1), getcoord.(points, 2)
    end
end
function _coordvecs(::GI.PolygonTrait, geom)
    ring = first(GI.getgeom(geom)) # currently doesn't plot holes
    points = GI.getpoint(ring)
    if GI.is3d(geom)
        return getcoord.(points, 1), getcoord.(points, 2), getcoord.(points, 3)
    else
        return getcoord.(points, 1), getcoord.(points, 2)
    end
end
function _coordvecs(::GI.MultiPolygonTrait, geom)
    function loop!(vecs, geom)
        i1 = 1
        for ring in GI.getring(geom)
            i2 = i1 + GI.npoint(ring) - 1
            range = i1:i2
            vvecs = map(v -> view(v, range), vecs)
            _geom2coordvecs!(vvecs..., ring)
            map(v -> v[i2 + 1] = NaN, vecs)
            i1 = i2 + 2
        end
        return vecs
    end
    n = GI.npoint(geom) + GI.nring(geom)
    if GI.is3d(geom)
        vecs = ntuple(_ -> Array{Float64}(undef, n), 3)
        return loop!(vecs, geom)
    else
        vecs = ntuple(_ -> Array{Float64}(undef, n), 2)
        return loop!(vecs, geom)
    end
end


_coordvec(n) = Array{Float64}(undef, n)

function _geom2coordvecs!(xs, ys, geom)
    for (i, p) in enumerate(GI.getpoint(geom))
        xs[i] = GI.x(p)
        ys[i] = GI.y(p)
    end
    return xs, ys
end
function _geom2coordvecs!(xs, ys, zs, geom)
    for (i, p) in enumerate(GI.getpoint(geom))
        xs[i] = GI.x(p)
        ys[i] = GI.y(p)
        zs[i] = GI.z(p)
    end
    return xs, ys, zs
end

# Enable Plots.jl for GeoInterface wrappers
GeoInterface.@enable_plots RecipesBase GeoInterface.WrapperGeometry
GeoInterface.@enable_plots RecipesBase GeoInterface.Feature
GeoInterface.@enable_plots RecipesBase GeoInterface.FeatureCollection

end

using Test, GeoFormatTypes, Extents
import GeoInterface as GI
using GeoInterface.Wrappers

# checks that our string display for geoms in regular/compact form is as expected
function test_display(geom, expected_str, expected_compact_str)
    # checks non-compact string repr
    generated_str = sprint() do io
        show(IOContext(io, :displaysize => (24, 80)), MIME"text/plain"(), geom)  
    end
    @test expected_str == generated_str
    # checks compact string repr
    generated_compact_str = sprint() do io
        show(IOContext(io, :displaysize => (24, 80), :compact => true), MIME"text/plain"(), geom)
    end
    @test expected_compact_str == generated_compact_str
end

# Point
point = GI.Point(1, 2)
@test point === GI.Point(point) 
GI.getcoord(point, 1)
@test !GI.ismeasured(point)
@test !GI.is3d(point)
@test GI.ncoord(point) == 2
@test GI.coordtype(point) == Int
@test GI.extent(point) == Extent(X=(1, 1), Y=(2, 2))
@test point == GI.Point(point)
@test (GI.x(point), GI.y(point)) == (1, 2)
@test_throws ArgumentError GI.z(point)
@test_throws ArgumentError GI.m(point)
@test_throws ArgumentError GI.Point(1, 2, 3, 4, 5)
@test GI.testgeometry(point)
@test GI.convert(GI, (1, 2)) isa GI.Point
test_display(point, "Point{false, false}((1, 2))", "Point((1,2))")
point_crs = GI.Point(point; crs=EPSG(4326))
@test parent(point_crs) === parent(point)
@test GI.crs(point_crs) === EPSG(4326)
test_display(point_crs, "Point{false, false}((1, 2), crs = \"EPSG:4326\")", "Point((1,2))")

# 3D Point
pointz = GI.Point(1, 2, 3)
@test !GI.ismeasured(pointz)
@test GI.is3d(pointz)
@test GI.ncoord(pointz) == 3
@test GI.coordtype(pointz) == Int
@test (GI.x(pointz), GI.y(pointz), GI.z(pointz)) == (1, 2, 3)
@test GI.testgeometry(pointz)
@test GI.convert(GI, pointz) === pointz
@test GI.extent(pointz) == Extents.Extent(X=(1, 1), Y=(2, 2), Z=(3, 3))
test_display(pointz, "Point{true, false}((1, 2, 3))", "Point((1,2,3))")

# 3D measured point
pointzm = GI.Point(; X=1, Y=2, Z=3, M=4)
@test pointzm == GI.Point(1, 2, 3, 4)
@test pointzm != GI.Point(1, 2, 3)
@test GI.ismeasured(pointzm)
@test GI.is3d(pointzm)
@test GI.ncoord(pointzm) == 4
@test GI.coordtype(pointzm) == Int
@test pointzm == GI.Point(pointzm)
@test point != GI.Point(pointzm)
@test (GI.x(pointzm), GI.y(pointzm), GI.z(pointzm), GI.m(pointzm)) == (1, 2, 3, 4)
@test GI.testgeometry(pointzm)
@test GI.convert(GI, pointzm) === pointzm
pointzm_crs = GI.Point(; X=1, Y=2, Z=3, M=4, crs=EPSG(4326))
@test parent(pointzm_crs) === parent(pointzm)
@test GI.crs(pointzm_crs) === EPSG(4326)
test_display(pointzm, "Point{true, true}((1, 2, 3, 4))", "Point((1,2,3,4))")

# Measured point
pointm = GI.Point((X=1, Y=2, M=3))
@test_throws MethodError GI.Point(; X=1, Y=2, T=3)
@test GI.ismeasured(pointm)
@test !GI.is3d(pointm)
@test GI.ncoord(pointm) == 3
@test GI.coordtype(pointm) == Int
@test pointm == GI.Point(pointm)
@test point != GI.Point(pointm)
@test (GI.x(pointm), GI.y(pointm), GI.m(pointm)) == (1, 2, 3)
@test_throws ArgumentError GI.z(pointm)
@test GI.testgeometry(pointm)
test_display(pointm, "Point{false, true}((1, 2, 3))", "Point((1,2,3))")
pointm_crs = GI.Point((X=1, Y=2, M=3); crs=EPSG(4326))
@test parent(pointm_crs) === parent(pointm)
@test GI.crs(pointm_crs) === EPSG(4326)
test_display(pointm_crs, "Point{false, true}((1, 2, 3), crs = \"EPSG:4326\")", "Point((1,2,3))")

# Forced measured point with a tuple
pointtm = GI.Point{false,true}(1, 2, 3)
@test_throws ArgumentError GI.Point{false,true}(1, 2, 3, 4)
@test GI.ismeasured(pointtm)
@test !GI.is3d(pointtm)
@test GI.ncoord(pointtm) == 3
@test GI.coordtype(pointtm) == Int
@test (GI.x(pointtm), GI.y(pointtm), GI.m(pointtm)) == (1, 2, 3)
@test_throws ArgumentError GI.z(pointtm)
@test GI.testgeometry(pointtm)
test_display(pointtm, "Point{false, true}((1, 2, 3))", "Point((1,2,3))")
pointtm_crs = GI.Point{false,true}(1, 2, 3; crs=EPSG(4326))
@test parent(pointtm_crs) === parent(pointtm)
@test GI.crs(pointtm_crs) === EPSG(4326)
test_display(pointtm_crs, "Point{false, true}((1, 2, 3), crs = \"EPSG:4326\")", "Point((1,2,3))")

# Point made from an array
pointa = GI.Point([1, 2])
@test !GI.ismeasured(pointa)
@test !GI.is3d(pointa)
@test GI.ncoord(pointa) == 2
@test GI.coordtype(pointa) == Int
@test (GI.x(pointa), GI.y(pointa)) == (1, 2)
@test GI.testgeometry(pointa)
test_display(pointa, "Point{false, false}((1, 2))", "Point((1,2))")

pointaz = GI.Point([1, 2, 3])
@test !GI.ismeasured(pointaz)
@test GI.is3d(pointaz)
@test GI.ncoord(pointaz) == 3
@test (GI.x(pointaz), GI.y(pointaz), GI.z(pointaz)) == (1, 2, 3)
@test GI.testgeometry(pointaz)
test_display(pointaz, "Point{true, false}((1, 2, 3))", "Point((1,2,3))")

pointazm = GI.Point([1, 2, 3, 4])
@test GI.ismeasured(pointazm)
@test GI.is3d(pointazm)
@test GI.ncoord(pointazm) == 4
@test (GI.x(pointazm), GI.y(pointazm), GI.z(pointazm), GI.m(pointazm)) == (1, 2, 3, 4)
@test GI.testgeometry(pointazm)
test_display(pointazm, "Point{true, true}((1, 2, 3, 4))", "Point((1,2,3,4))")

# We can force a vector point to be measured
pointam = GI.Point{false,true}([1, 2, 3])
@test GI.ismeasured(pointam)
@test !GI.is3d(pointam)
@test GI.ncoord(pointam) == 3
@test (GI.x(pointam), GI.y(pointam), GI.m(pointam)) == (1, 2, 3)
@test_throws ArgumentError GI.z(pointam)
@test GI.testgeometry(pointam)
test_display(pointam, "Point{false, true}((1, 2, 3))", "Point((1,2,3))")
@test_throws ArgumentError GI.Point(1, 2, 3, 4, 5)

# Line
line = GI.Line([(1, 2), (3, 4)])
@test line == GI.Line(line)
@test GI.getgeom(line, 1) === (1, 2)
@test GI.getgeom(line) == [(1, 2), (3, 4)]
@test GI.testgeometry(line)
@test !GI.is3d(line)
@test GI.ncoord(line) == 2
@test GI.extent(line) == Extent(X=(1, 3), Y=(2, 4))
test_display(line, "Line{false, false}([(1, 2), (3, 4)])", "Line([(1,2),(3,4)])")
@test_throws ArgumentError GI.Line(point)
@test_throws ArgumentError GI.Line([(1, 2)])
@test_throws ArgumentError GI.Line([line, line])
line_crs = GI.Line(line; crs=EPSG(4326))
@test parent(line_crs) === parent(line)
@test GI.crs(line_crs) === EPSG(4326)
test_display(line_crs, "Line{false, false}([(1, 2), (3, 4)], crs = \"EPSG:4326\")", "Line([(1,2),(3,4)])")

# LineString
linestring = GI.LineString([(1, 2), (3, 4)])
@test linestring === GI.LineString(linestring)
@test GI.getgeom(linestring, 1) === (1, 2)
@test GI.getgeom(linestring) == [(1, 2), (3, 4)]
@test GI.testgeometry(linestring)
@test !GI.is3d(linestring)
@test GI.ncoord(linestring) == 2
@test GI.coordtype(linestring) == Int
test_display(linestring, "LineString{false, false}([(1, 2), (3, 4)])", "LineString([(1,2),(3,4)])")
@test @inferred(GI.extent(linestring)) == Extent(X=(1, 3), Y=(2, 4))
@test_throws ArgumentError GI.LineString([(1, 2)])
linestring_crs = GI.LineString(linestring; crs=EPSG(4326))
@test parent(linestring_crs) === parent(linestring)
@test GI.crs(linestring_crs) === EPSG(4326)
test_display(linestring_crs, "LineString{false, false}([(1, 2), (3, 4)], crs = \"EPSG:4326\")", "LineString([(1,2),(3,4)])")

# LinearRing
linearring = GI.LinearRing([(1, 2), (3, 4), (5, 6), (1, 2)])
@test linearring === GI.LinearRing(linearring)
@test GI.getgeom(linearring, 1) === (1, 2)
@test GI.getgeom(linearring) == [(1, 2), (3, 4), (5, 6), (1, 2)]
@test GI.testgeometry(linearring)
@test !GI.is3d(linearring)
@test GI.ncoord(linearring) == 2
test_display(linearring, "LinearRing{false, false}([(1, 2), (3, 4), (5, 6), (1, 2)])", "LinearRing([(1,2),(3,4),(5,6),(1,2)])")
@test @inferred(GI.extent(linearring)) == Extent(X=(1, 5), Y=(2, 6))
@test_throws ArgumentError GI.LinearRing([(1, 2)])
linearring_crs = GI.LinearRing(linearring; crs=EPSG(4326))
@test parent(linearring_crs) === parent(linearring)
@test GI.crs(linearring_crs) === EPSG(4326)
test_display(linearring_crs, "LinearRing{false, false}([(1, 2), (3, 4), (5, 6), (1, 2)], crs = \"EPSG:4326\")", "LinearRing([(1,2),(3,4),(5,6),(1,2)])")

# Polygon
polygon = GI.Polygon([linearring, linearring])
@test GI.Polygon([linearring]) == GI.Polygon(linearring)
@test polygon == GI.Polygon(polygon)
@test GI.getgeom(polygon, 1) === linearring
@test collect(GI.getgeom(polygon)) == [linearring, linearring]
@test collect(GI.getpoint(polygon)) == vcat(collect(GI.getpoint(linearring)), collect(GI.getpoint(linearring)))
@test GI.testgeometry(polygon)
@test !GI.is3d(polygon)
@test GI.ncoord(polygon) == 2
@test @inferred(GI.extent(polygon)) == Extent(X=(1, 5), Y=(2, 6))
@test GI.convert(GI, MyPolygon()) isa GI.Polygon
@test GI.convert(GI, polygon) === polygon
test_display(polygon, "Polygon{false, false}([LinearRing([(1, 2), … (2) … , (1, 2)]), LinearRing([(1, 2), … (2) … , (1, 2)])])",
                "Polygon([LinearRing([(1,2),(3,4),(5,6),(1,2)]),LinearRing([(1,2),(3,4),(5,6),(1,2)])])")
polygon_crs = GI.Polygon(polygon; crs=EPSG(4326))
@test parent(polygon_crs) === parent(polygon)
@test GI.crs(polygon_crs) === EPSG(4326)
test_display(polygon_crs, "Polygon{false, false}([LinearRing([(1, 2), … (2) … , (1, 2)]), LinearRing([(1, 2), … (2) … , (1, 2)])], crs = \"EPSG:4326\")",
                "Polygon([LinearRing([(1,2),(3,4),(5,6),(1,2)]),LinearRing([(1,2),(3,4),(5,6),(1,2)])])")
# Make sure `linestring` is also ok in polygons
polygon = GI.Polygon([linestring, linestring])
@test GI.getgeom(polygon, 1) === linestring
@test collect(GI.getgeom(polygon)) == [linestring, linestring]
test_display(polygon, "Polygon{false, false}([LineString([(1, 2), (3, 4)]), LineString([(1, 2), (3, 4)])])",
                "Polygon([LineString([(1,2),(3,4)]),LineString([(1,2),(3,4)])])")

linearring3d = GI.LinearRing([(1, 2, 3), (3, 4, 5), (5, 6, 7), (1, 2, 3)])
polygon3d = GI.Polygon([linearring3d, linearring3d])
@test GI.is3d(polygon3d)
@test GI.ncoord(polygon3d) == 3
@test GI.extent(polygon3d) == Extents.Extent(X=(1, 5), Y=(2, 6), Z=(3, 7))
test_display(linearring3d, "LinearRing{true, false}([(1, 2, 3), (3, 4, 5), (5, 6, 7), (1, 2, 3)])", "LinearRing([(1,2,3),(3,4,5),(5,6,7),(1,2,3)])")

# MultiPoint
multipoint = GI.MultiPoint([(1, 2), (3, 4), (3, 2), (1, 4), (7, 8), (9, 10)])
@test multipoint == GI.MultiPoint(multipoint)
@test GI.MultiPoint([(1, 2)]) == GI.MultiPoint((1, 2))
@test GI.getgeom(multipoint, 1) === (1, 2)
@test !GI.is3d(multipoint)
@test GI.ncoord(multipoint) == 2
@test @inferred(GI.extent(multipoint)) == Extent(X=(1, 9), Y=(2, 10))
@test_throws ArgumentError GI.MultiPoint([[(1, 2), (3, 4), (3, 2), (1, 4), (7, 8), (9, 10)]])
@test GI.testgeometry(multipoint)
test_display(multipoint, "MultiPoint{false, false}([(1, 2), (3, 4), (3, 2), (1, 4), (7, 8), (9, 10)])", "MultiPoint([(1,2),(3,4),(3,2),(1,4),(7,8),(9,10)])")
multipoint_crs = GI.MultiPoint(multipoint; crs=EPSG(4326))
@test parent(multipoint_crs) == parent(multipoint)
@test GI.crs(multipoint_crs) === EPSG(4326)
test_display(multipoint_crs, "MultiPoint{false, false}([(1, 2), (3, 4), (3, 2), … (1) … , (7, 8), (9, 10)], crs = \"EPSG:4326\")", "MultiPoint([(1,2),(3,4),(3,2),(1,4),(7,8),(9,10)])")

# GeometryCollection
geoms = [line, linestring, linearring, multipoint, (1, 2)]
collection = GI.GeometryCollection(geoms)
@test GI.GeometryCollection([line]) == GI.GeometryCollection(line)
@test collection == GI.GeometryCollection(collection)
@test GI.getgeom(collection) == geoms
@test GI.testgeometry(collection)
@test !GI.is3d(collection)
@test GI.ncoord(collection) == 2
@test GI.coordtype(collection) == Int
@test GI.extent(collection) == reduce(Extents.union, map(GI.extent, geoms))
test_display(collection, "GeometryCollection{false, false}([Line([(1, 2), (3, 4)]), … (3) … , (1, 2)])",
                    "GeometryCollection([Line([(1,2),(3,4)]),LineString([(1,2),(3,4)]),…(2)…,(1,2)])")
collection_crs = GI.GeometryCollection(collection; crs=EPSG(4326))
@test parent(collection_crs) == parent(collection)
@test GI.crs(collection_crs) === EPSG(4326)
test_display(collection_crs, "GeometryCollection{false, false}([Line([(1, 2), (3, 4)]), … (3) … , (1, 2)], crs = \"EPSG:4326\")",
                    "GeometryCollection([Line([(1,2),(3,4)]),LineString([(1,2),(3,4)]),…(2)…,(1,2)])")

# MultiCurve
multicurve = GI.MultiCurve([linestring, linearring])
@test collect(GI.getpoint(multicurve)) == vcat(collect(GI.getpoint(linestring)), collect(GI.getpoint(linearring)))
@test GI.MultiCurve([linestring]) == GI.MultiCurve(linestring)
@test multicurve == GI.MultiCurve(multicurve)
@test GI.getgeom(multicurve, 1) === linestring
@test !GI.is3d(multicurve)
@test GI.ncoord(multicurve) == 2
@test GI.coordtype(multicurve) == Int
@test GI.extent(multicurve) == Extent(X=(1, 5), Y=(2, 6))
@test_throws ArgumentError GI.MultiCurve([pointz, polygon])
@test GI.testgeometry(multicurve)
test_display(multicurve, "MultiCurve{false, false}([LineString([(1, 2), (3, 4)]), LinearRing([(1, 2), … (2) … , (1, 2)])])",
                        "MultiCurve([LineString([(1,2),(3,4)]),LinearRing([(1,2),(3,4),…(1)…,(1,2)])])")
multicurve_crs = GI.MultiCurve(multicurve; crs=EPSG(4326))
@test parent(multicurve_crs) == parent(multicurve)
@test GI.crs(multicurve_crs) === EPSG(4326)
test_display(multicurve_crs, "MultiCurve{false, false}([LineString([(1, 2), (3, 4)]), LinearRing([(1, 2), … (2) … , (1, 2)])], crs = \"EPSG:4326\")",
                        "MultiCurve([LineString([(1,2),(3,4)]),LinearRing([(1,2),(3,4),…(1)…,(1,2)])])")

# MultiPolygon
polygon = GI.Polygon([linearring, linearring])
multipolygon = GI.MultiPolygon([polygon])
@test multipolygon == GI.MultiPolygon(multipolygon)
@test multipolygon == GI.MultiPolygon(polygon)
@test GI.getgeom(multipolygon, 1) === polygon
@test !GI.is3d(multipolygon)
@test GI.ncoord(multipolygon) == 2
@test GI.coordtype(multipolygon) == Int
test_display(multipolygon, "MultiPolygon{false, false}([Polygon([LinearRing([(1, 2), … (2) … , (1, 2)]), LinearRing([(1, 2), … (2) … , (1, 2)])])])",
                            "MultiPolygon([Polygon([LinearRing([(1,2),…(2)…,(1,2)]),LinearRing([(1,2),…(2)…,(1,2)])])])")
# MultiPolygon extent does not infer, maybe due to nesting
@test GI.extent(multipolygon) == Extent(X=(1, 5), Y=(2, 6))
@test collect(GI.getpoint(multipolygon)) == collect(GI.getpoint(polygon))
@test_throws ArgumentError GI.MultiPolygon([[[[(1, 2), (3, 4), (3, 2), (1, 4)]]]])
@test GI.testgeometry(multipolygon)
multipolygon_crs = GI.MultiPolygon(multipolygon; crs=EPSG(4326))
@test parent(multipolygon_crs) == parent(multipolygon)
@test GI.crs(multipolygon_crs) === EPSG(4326)
test_display(multipolygon_crs, "MultiPolygon{false, false}([Polygon([LinearRing([(1, 2), … (2) … , (1, 2)]), LinearRing([(1, 2), … (2) … , (1, 2)])])], crs = \"EPSG:4326\")",
                            "MultiPolygon([Polygon([LinearRing([(1,2),…(2)…,(1,2)]),LinearRing([(1,2),…(2)…,(1,2)])])])")

# PolyhedralSurface
polyhedralsurface = GI.PolyhedralSurface([polygon, polygon])
@test polyhedralsurface == GI.PolyhedralSurface(polyhedralsurface)
@test GI.PolyhedralSurface(polygon) == GI.PolyhedralSurface(polygon)
@test !GI.is3d(polyhedralsurface)
@test GI.ncoord(polyhedralsurface) == 2
@test GI.coordtype(polyhedralsurface) == Int
@test @inferred(GI.extent(polyhedralsurface)) == Extent(X=(1, 5), Y=(2, 6))
@test GI.getgeom(polyhedralsurface, 1) === polygon
@test collect(GI.getgeom(polyhedralsurface)) == [polygon, polygon]
@test GI.getgeom(polyhedralsurface, 1) == polygon
@test collect(GI.getpoint(polyhedralsurface)) == vcat(collect(GI.getpoint(polygon)), collect(GI.getpoint(polygon)))
@test GI.testgeometry(polyhedralsurface)
test_display(polyhedralsurface, "PolyhedralSurface{false, false}([Polygon([LinearRing([(1, 2), … (2) … , (1, 2)]), LinearRing([(1, 2), … (2) … , (1, 2)])]), Polygon([LinearRing([(1, 2), … (2) … , (1, 2)]), LinearRing([(1, 2), … (2) … , (1, 2)])])])",
                                "PolyhedralSurface([Polygon([LinearRing([(1,2),…(2)…,(1,2)]),LinearRing([(1,2),…(2)…,(1,2)])]),Polygon([LinearRing([(1,2),…(2)…,(1,2)]),LinearRing([(1,2),…(2)…,(1,2)])])])")
polyhedralsurface_crs = GI.PolyhedralSurface(polyhedralsurface; crs=EPSG(4326))
@test parent(polyhedralsurface_crs) == parent(polyhedralsurface)
@test GI.crs(polyhedralsurface_crs) === EPSG(4326)
test_display(polyhedralsurface_crs, "PolyhedralSurface{false, false}([Polygon([LinearRing([(1, 2), … (2) … , (1, 2)]), LinearRing([(1, 2), … (2) … , (1, 2)])]), Polygon([LinearRing([(1, 2), … (2) … , (1, 2)]), LinearRing([(1, 2), … (2) … , (1, 2)])])], crs = \"EPSG:4326\")",
                                "PolyhedralSurface([Polygon([LinearRing([(1,2),…(2)…,(1,2)]),LinearRing([(1,2),…(2)…,(1,2)])]),Polygon([LinearRing([(1,2),…(2)…,(1,2)]),LinearRing([(1,2),…(2)…,(1,2)])])])")

# Round-trip coordinates
multipolygon_coords = [[[[1, 2], [3, 4], [3, 2], [1, 4]]]]
multipolygon = GI.MultiPolygon(multipolygon_coords)
@test GI.coordinates(multipolygon) == multipolygon_coords
@test GI.coordtype(multipolygon) == Int
test_display(multipolygon, "MultiPolygon{false, false}([Polygon([LinearRing([[1, 2], [3, 4], [3, 2], [1, 4]])])])",
                        "MultiPolygon([Polygon([LinearRing([[1,2],[3,4],[3,2],[1,4]])])])")

# Wrong parent type
@test_throws ArgumentError GI.Point(nothing)
@test_throws ArgumentError GI.Point(linestring)
@test_throws ArgumentError GI.LineString(1)
@test_throws ArgumentError GI.MultiPolygon(1)
@test_throws ArgumentError GI.MultiPolygon((1, 2))

# Feature
feature = GI.Feature(multipolygon; properties=(x=1, y=2, z=3))
@test feature === GI.Feature(feature) === GI.Feature(feature; properties=(a=1, b=2))
@test GI.geometry(feature) === multipolygon
@test GI.properties(feature) === (x=1, y=2, z=3)
@test GI.crs(feature) == nothing
@test GI.extent(feature) == GI.extent(multipolygon) 
@test GI.testfeature(feature)
test_display(feature, "Feature(MultiPolygon{false, false}([Polygon([LinearRing([[1, 2], [3, 4], [3, 2], [1, 4]])])]), properties = (x = 1, y = 2, z = 3))",
                    "Feature(MultiPolygon([Polygon([LinearRing([[1,2],[3,4],[3,2],[1,4]])])]),properties=(x=1,y=2,z=3))")
feature = GI.Feature(multipolygon; 
    properties=(x=1, y=2, z=3), crs=EPSG(4326), extent=extent(multipolygon)
)
test_display(feature, "Feature(MultiPolygon{false, false}([Polygon([LinearRing([[1, 2], [3, 4], [3, 2], [1, 4]])])]), properties = (x = 1, y = 2, z = 3), crs = \"EPSG:4326\")",
                    "Feature(MultiPolygon([Polygon([LinearRing([[1,2],[3,4],[3,2],[1,4]])])]),properties=(x=1,y=2,z=3))")
@test GI.geometry(feature) === multipolygon
@test GI.properties(feature) === (x=1, y=2, z=3)
@test GI.crs(feature) == EPSG(4326)
@test GI.extent(feature) == GI.extent(multipolygon) 
@test GI.testfeature(feature)
@test GI.coordtype(feature) == Int
@test_throws ArgumentError GI.Feature(:not_a_feature; properties=(x=1, y=2, z=3))
@test GI.properties(GI.Feature(multipolygon)) == NamedTuple()

# Feature Collection
fc_unwrapped = GI.FeatureCollection(feature; crs=EPSG(4326), extent=GI.extent(feature))
fc = GI.FeatureCollection(fc_unwrapped.parent; crs=EPSG(4326), extent=GI.extent(feature)) # so that `==` works since the underlying array is the same
@test fc_unwrapped == fc
@test GI.crs(fc) == GI.crs(GI.FeatureCollection(feature; crs=EPSG(4326), extent=GI.extent(feature)))
@test GI.extent(fc) == GI.extent(GI.FeatureCollection(feature; crs=EPSG(4326), extent=GI.extent(feature)))
@test fc === GI.FeatureCollection(fc)
@test GI.crs(fc) == EPSG(4326)
@test GI.extent(fc) == fc.extent
@test first(GI.getfeature(fc)) == GI.getfeature(fc, 1) === feature
@test GI.testfeaturecollection(fc)
test_display(fc, "FeatureCollection([Feature(MultiPolygon{false, false}([Polygon([LinearRing([[1, 2], [3, 4], [3, 2], [1, 4]])])]), properties = (x = 1, y = 2, z = 3), crs = \"EPSG:4326\")], crs = \"EPSG:4326\", extent = Extent(X = (1, 3), Y = (2, 4)))",
                "FeatureCollection([Feature(MultiPolygon([Polygon([LinearRing([[1,2],[3,4],[3,2],[1,4]])])]),properties=(x=1,y=2,z=3))])")
@test_throws ArgumentError GI.FeatureCollection([1])
vecfc = GI.FeatureCollection([(geometry=(1,2), a=1, b=2)])
@test GI.getfeature(vecfc, 1) == (geometry=(1,2), a=1, b=2)
@test GI.coordtype(vecfc) == Int



struct MaPointRappa
    x::Float64
    y::Float64
end

@testset "Wrapped geometry printing" begin

    GI.geomtrait(::MaPointRappa) = GI.PointTrait()
    GI.ncoord(::GI.PointTrait, ::MaPointRappa) = 2
    GI.x(::GI.PointTrait, p::MaPointRappa) = p.x
    GI.y(::GI.PointTrait, p::MaPointRappa) = p.y
    

    test_display(GI.Point(MaPointRappa(1.0, 2.0)), "Point{false, false}((1.0, 2.0))", "Point((1.0,2.0))")

    GI.geomtrait(::Vector{MaPointRappa}) = GI.LineStringTrait()
    GI.npoint(::GI.LineStringTrait, v::Vector{MaPointRappa}) = length(v)
    GI.getpoint(::GI.LineStringTrait, v::Vector{MaPointRappa}, i::Integer) = v[i]

    test_display(
        GI.LineString([MaPointRappa(1.0, 2.0), MaPointRappa(3.0, 4.0)]), 
        "LineString{false, false}([MaPointRappa(1.0, 2.0), MaPointRappa(3.0, 4.0)])", 
        "LineString([MaPointRappa(1.0, 2.0),MaPointRappa(3.0, 4.0)])" # FIXME: this should not show the point type!
    )
end

# TODO

# # Triangle
# triangle = GI.Triangle([[(1, 2, 3), (3, 4, 5), (3, 2, 1)]])
# @test triangle == GI.Triangle(triangle)
# @test GI.getgeom(triangle, 1) === (1, 2, 3)
# @test_throws ArgumentError GI.Triangle([[(1, 2, 3), (3, 4, 5), (3, 2, 1)]])
# @test GI.testgeometry(triangle)

#rectangle = GI.Rectangle([(1, 2), (3, 4), (3, 2)])

# # Quad
# quad = GI.Quad([(1, 2), (3, 4), (3, 2), (1, 4)])
# @test quad == GI.Quad(quad)
# @test GI.getgeom(quad, 1) === (1, 2)
# quad = GI.Quad([[(1, 2), (3, 4), (3, 2), (1, 4)]])
# @test quad == GI.Quad(quad)
# @test GI.getgeom(quad, 1) === (1, 2)
# @test_throws ArgumentError GI.Quad([[(1, 2), (3, 4), (3, 2)]])
# @test GI.testgeometry(quad)

# # Pentagon
# hex = GI.Pentagon([(1, 2), (3, 4), (3, 2), (1, 4), (7, 8)])
# @test hex == GI.Pentagon(hex)
# @test GI.getgeom(hex, 1) === (1, 2)
# GI.Pentagon([[(1, 2), (3, 4), (3, 2), (1, 4), (7, 8)]])
# @test GI.testgeometry(hex)
# @test_throws ArgumentError GI.Pentagon([[(1, 2), (3, 4), (3, 2), (1, 4)]])

# # Hexagon
# hex = GI.Hexagon([(1, 2), (3, 4), (3, 2), (1, 4), (7, 8), (9, 10)])
# @test hex == GI.Hexagon(hex)
# @test GI.getgeom(hex, 1) === (1, 2)
# GI.Hexagon([[(1, 2), (3, 4), (3, 2), (1, 4), (7, 8), (9, 10)]])
# @test GI.testgeometry(hex)
# @test_throws ArgumentError GI.Hexagon([[(1, 2), (3, 4), (3, 2), (1, 4)]])

# # TIN
# tin = GI.TIN([triangle])
# @test tin == GI.TIN(tin)
# @test GI.getgeom(tin, 1) === triangle
# @test collect(GI.getpoint(tin)) == collect(GI.getpoint(triangle))
# @test_throws ArgumentError GI.TIN([(1, 2), (3, 4), (3, 2), (1, 4), (7, 8), (9, 10)])
# @test GI.testgeometry(tin)

"""
    testgeometry(geom)

Test whether the required interface for your `geom` has been implemented correctly.
"""
function testgeometry(geom)
    @assert isgeometry(geom) "$geom doesn't implement `isgeometry`."
    @assert isgeometry(typeof(geom)) "Type{$(typeof(geom))} doesn't implement `isgeometry`."
    type = geomtrait(geom)
    @assert !isnothing(type) "$geom doesn't implement `geomtrait`."

    @assert hasmethod(ncoord, (typeof(type), typeof(geom))) "$geom does not correctly implement two argument `ncoord`"

    if type == PointTrait()
        n = ncoord(geom)
        @assert n == ncoord(type, geom) "$geom does not correctly implement three argument `getcoord`"
        if n >= 1  # point could be empty
            c = getcoord(geom, 1)  # point always needs at least 2
            @assert c == getcoord(type, geom, 1) "$geom does not correctly implement three argument `getcoord`"
        end
    else
        n = ngeom(geom)
        @assert n == ngeom(type, geom) "$geom does not correctly implement two argument `ngeom`"
        if n >= 1  # geometry could be empty
            g2 = getgeom(geom, 1)
            @assert g2 == getgeom(type, geom, 1) "$geom does not correctly implement three argument `getgeom`"
            subtype = subtrait(type)
            if !isnothing(subtype)
                issub = geomtrait(g2) isa subtype
                !issub && error("Implemented hierarchy for $geom type is incorrect. Subgeometry should be a $subtype")
            end
            @assert testgeometry(g2) "Subgeometry implementation is not valid."
        end
    end
    return true
end

"""
    testfeature(feature)

Test whether the required interface for your `feature` has been implemented correctly.
"""
function testfeature(feature)
    @assert isfeature(typeof(feature)) "$feature doesn't implement `isfeature`."
    @assert trait(feature) isa AbstractFeatureTrait "$feature does not return an `AbstractFeatureTrait` for `geomtrait`."
    @assert isnothing(geomtrait(feature))
    geom = geometry(feature)
    if !isnothing(geom)
        @assert isgeometry(geom) "geom $geom from $feature doesn't implement `isgeometry`."
        @assert coordinates(feature) == coordinates(geometry(feature))
    end

    props = properties(feature)
    if !isnothing(props)
        @assert first(propertynames(props)) isa Symbol "`propertynames` of $props does not return an iterable of `Symbol`"
        map(n -> getproperty(props, n), propertynames(props))
    end
    ext = extent(feature)
    @assert ext isa Union{Nothing,Extent}
    return true
end

"""
    testfeaturecollection(featurecollection)

Test whether the required interface for your `featurecollection` has been implemented correctly.
"""
function testfeaturecollection(fc)
    @assert isfeaturecollection(typeof(fc)) "$fc doesn't implement `isfeaturecollection`."
    @assert trait(fc) isa AbstractFeatureCollectionTrait "$fc does not return an `AbstractFeatureCollectionTrait` for `geomtrait`."
    @assert isnothing(geomtrait(fc))
    @assert isa(nfeature(fc), Integer) "feature collection $fc doesn't return an `Integer` from `nfeatures`."
    if nfeature(fc) > 0
        @assert isfeature(getfeature(fc, 1)) "For $fc `getfeature(featurecollection, 1)` does not return an object where `isfeature(obj) == true`."
        @assert isfeature(getfeature(fc, nfeature(fc))) "For $fc `getfeature(featurecollection, nfeatures(featurecollection))` does not return an object where `isfeature(obj) == true`."
    else
        @warn "`nfeatures == 0` for feature collection, cannot test some properties"
    end
    @assert coordinates(fc) == coordinates.(getfeature(fc))
    @assert geometrycolumns(fc) isa NTuple "feature collection $fc doesn't return a `NTuple` from `geometrycolumns`."
    return true
end

"""
    testraster(raster)

Test whether the required interface for your `raster` has been implemented correctly.
"""
function testraster(raster)
    @assert israster(typeof(raster)) "$raster doesn't implement `israster`."
    @assert trait(raster) isa AbstractRasterTrait "$raster does not return an `AbstractRasterTrait` for `trait`."

    # Symbol because we don't directly depend on GeoFormatTypes
    @assert crs(raster) isa CoordinateReferenceSystemFormat "Raster $raster doesn't return a CoordinateReferenceSystemFormat for `crs`."
    @assert extent(raster) isa Extent "Raster $raster doesn't return an `Extent` for `extent`"
    return true
end

using GeoInterface
using Documenter

DocMeta.setdocmeta!(GeoInterface, :DocTestSetup, :(using GeoInterface); recursive=true)
cp(joinpath(@__DIR__, "../INTEGRATIONS.md"), joinpath(@__DIR__, "src/reference/integrations.md"); force=true)

makedocs(;
    modules=[GeoInterface, GeoInterface.Wrappers],
    authors="JuliaGeo and contributors",
    repo="https://github.com/JuliaGeo/GeoInterface.jl/blob/{commit}{path}#{line}",
    sitename="GeoInterface.jl",
    format=Documenter.HTML(;
        prettyurls=get(ENV, "CI", "false") == "true",
        canonical="https://juliageo.github.io/GeoInterface.jl",
        assets=String[]
    ),
    pages=[
        "Home" => "index.md",
        "Background" => Any[
            "Simple Features"=>"background/sf.md",
            "History"=>"background/history.md",
        ],
        "Tutorials" => Any[
            "Installation"=>"tutorials/installation.md",
            "Usage"=>"tutorials/usage.md",
        ],
        "Guides" => Any[
            "For developers"=>"guides/developer.md",
            "Defaults"=>"guides/defaults.md",
        ],
        "Reference" => Any[
            "API" => "reference/api.md"
            "Implementations" => "reference/integrations.md"
        ],
    ],
    doctest=true,
    warnonly=[:cross_references, :missing_docs]
)

deploydocs(;
    repo="github.com/JuliaGeo/GeoInterface.jl",
    devbranch="main",
    push_preview = true,
)

"""
    Wrappers

Geometry, Feature, and FeatureCollection wrappers for constructing ad-hoc
geometry objects from any GeoInterface.jl compatible geometries, or
vectors of them.

These are not exported by default, due to the names being so common.
To bring them into your local scope, do:

```juila
using GeoInterface.Wrappers
```

Otherwise they can be accessed as:

```julia
GeoInterface.Polygon
```
"""
module Wrappers

import Extents

import ..GeoInterface: AbstractGeometryTrait, PointTrait, LineTrait, LineStringTrait, LinearRingTrait,
       MultiPointTrait, PolygonTrait, MultiLineStringTrait, MultiCurveTrait, MultiPolygonTrait,
       AbstractCurveTrait, GeometryCollectionTrait, FeatureTrait, FeatureCollectionTrait, PointTuple3,
       PolyhedralSurfaceTrait, TriangleTrait, QuadTrait, PentagonTrait, HexagonTrait, RectangleTrait, TINTrait

import ..GeoInterface: isgeometry, isfeature, isfeaturecollection, is3d, ismeasured,
       trait, geomtrait, convert, x, y, z, m, extent, crs,
       getgeom, getpoint, getring, gethole, getcoord,
       ngeom, npoint, nring, nhole, ncoord,
       nfeature, getfeature, geometry, properties

export WrapperGeometry, Point, Line, LineString, LinearRing, Polygon, MultiPoint, MultiPolygon, MultiLineString, MultiCurve,
    PolyhedralSurface, GeometryCollection, Feature, FeatureCollection

# TODO
# Triangle, Quad, Pentagon, Hexagon, TIN, Surface


# Implement interface

"""
    abstract type WrapperGeometry{Z,M,T}

Provides geometry wrappers that wrap any GeoInterface compatible
objects, or vectors or their child objects.

These can be useful for building custom geometries, in tests,
and in packages with no direct dependencies on specific geometry
types.

Parameters `Z` and `M` hold `Bool` values `true` or `false`
to indicate if a z dimension or measures are present. They are
usually detected from the wrapped object, but can be added manually
e.g. for `Tuple` or `Vector` points to have the third value used as
measures.
"""
abstract type WrapperGeometry{Z,M,T,C} end

isgeometry(::Type{<:WrapperGeometry}) = true
is3d(::AbstractGeometryTrait, ::WrapperGeometry{Z}) where Z = Z
ismeasured(::AbstractGeometryTrait, ::WrapperGeometry{<:Any,M})  where M = M
ncoord(::AbstractGeometryTrait, ::WrapperGeometry{Z, M}) where {Z, M} = 2 + Z + M

Base.parent(geom::WrapperGeometry) = geom.geom

function Base.:(==)(g1::WrapperGeometry, g2::WrapperGeometry)
    all(((a, b),) -> a == b, zip(getgeom(g1), getgeom(g2)))
end

# Interface methods
# With indexing
function getgeom(trait::AbstractGeometryTrait, geom::WrapperGeometry{<:Any,<:Any,T}, i) where T
    isgeometry(T) ? getgeom(trait, parent(geom), i) : parent(geom)[i]
end
function getgeom(trait::AbstractGeometryTrait, geom::WrapperGeometry{<:Any,<:Any,T}) where T
    isgeometry(T) ? getgeom(trait, parent(geom)) : parent(geom)
end

extent(::AbstractGeometryTrait, geom::WrapperGeometry) =
    isnothing(geom.extent) && isgeometry(parent(geom)) ? extent(parent(geom)) : geom.extent
crs(::AbstractGeometryTrait, geom::WrapperGeometry) =
    isnothing(geom.crs) && isgeometry(parent(geom)) ? crs(parent(geom)) : geom.crs
function ngeom(trait::AbstractGeometryTrait, geom::WrapperGeometry{<:Any,<:Any,T}) where T
    isgeometry(T) ? ngeom(parent(geom)) : length(parent(geom))
end

# Forward all 2-argument show calls to the 3-argument version
# with a "text/plain" MIME type.  This gives us a consistent target
# to implement the show methods.
Base.show(io::IO, geom::WrapperGeometry) = show(io, MIME"text/plain"(), geom)

# We define all the types in a loop so we have standardised docs and behaviour
# without too much repetition of code.
# `child_trait` and `child_type` define the trait and type of child geometries
# a geometry can be constructed from.
# `length_check` limits some types to specific number of points, defined with a Fix2 or function
# `nesting` indicates how many layers of point vectors need to be used to construct the object.
for (geomtype, trait, childtype, child_trait, length_check, nesting) in (
        (:Line, :LineTrait, :Point, :PointTrait, ==(2), 1),
        (:LineString, :LineStringTrait, :Point, :PointTrait, >=(2), 1),
        (:LinearRing, :LinearRingTrait, :Point, :PointTrait, >=(3), 1),
        (:MultiPoint, :MultiPointTrait, :Point, :PointTrait, nothing, 1),
        (:Polygon, :PolygonTrait, :LinearRing, :AbstractCurveTrait, nothing, 2),
        (:MultiLineString, :MultiLineStringTrait, :LineString, :LineStringTrait, nothing, 2),
        (:MultiCurve, :MultiCurveTrait, :LineString, :AbstractCurveTrait, nothing, 2),
        (:MultiPolygon, :MultiPolygonTrait, :Polygon, :PolygonTrait, nothing, 3),
        (:GeometryCollection, :GeometryCollectionTrait, :AbstractGeometry, :AbstractGeometryTrait, nothing, nothing),
        (:PolyhedralSurface, :PolyhedralSurfaceTrait, :Polygon, :PolygonTrait, nothing, 3),
        # (:Triangle, :TriangleTrait, :LinearRingTrait, :LinearRing, ==(3), 2),
        # (:Quad, :QuadTrait, :LinearRingTrait, :LinearRing, ==(4), 2),
        # (:Pentagon, :PentagonTrait, :LinearRingTrait, :LinearRing, ==(5), 2),
        # (:Hexagon, :HexagonTrait, :LinearRingTrait, :LinearRing, ==(6), 2),
        # (:Rectangle, :RectangleTrait, :Point, :PointTrait, nothing, 1), ?
        # (:TIN, :TINTrait, :Triangle, :TriangleTrait, nothing, 3),
    )

    # Prepare docstring example
    childname = lowercase(string(childtype))
    example_child_geoms = if geomtype == :Polygon
        "interior, hole1, hole2"
    else
        join((string(childname, n) for n in 1:(isnothing(length_check) ? 3 : length_check.x)), ", ")
    end
    docstring = """
        $geomtype

        $geomtype(geom; [extent, crs])
        $geomtype{Z,M}(geom; [extent, crs])

    ## Arguments

    - `geom`: any object returning $trait from `GeoInterface.trait`, or a vector
        of objects returning $child_trait.

    ## Keywords
    
    - `extent`: an `Extents.Extent`, or `nothing`.
    - `crs`: a `GeoFormatTypes.GeoFormat`, or `nothing`.

    ## Type Parameters (optional)

    These are usually detected from the parent object properties.

    - `Z`: `true` or `false` if there is a z dimension.
    - `M`: `true` or `false` if there are measures.

    ## Examples

    ```julia
    geom = $geomtype(geometry)
    ```

    Or with child objects with [`$child_trait`](@ref):

    ```julia
    geom = $geomtype([$example_child_geoms])
    ```
    """
    @eval begin
        @doc $docstring
        struct $geomtype{Z,M,T,E<:Union{Nothing,Extents.Extent},C} <: WrapperGeometry{Z,M,T,C}
            geom::T
            extent::E
            crs::C
        end
        $geomtype(geom::$geomtype; kw...) =
            $geomtype(parent(geom); extent=geom.extent, crs=geom.crs, kw...)
        $geomtype(geom; kw...) = $geomtype{nothing,nothing}(geom; kw...)
        geomtrait(::$geomtype) = $trait()
        geointerface_geomtype(::$trait) = $geomtype
        # Here converting means wrapping
        convert(::Type{$geomtype}, ::$trait, geom) = $geomtype(geom)
        # But not if geom is already a WrapperGeometry
        convert(::Type{$geomtype}, ::$trait, geom::$geomtype) = geom
        
        function Base.show(io::IO, ::MIME"text/plain", geom::$geomtype{Z, M, T, E, C}; 
            show_mz::Bool = true, screen_ncols::Int = displaysize(io)[2]
        ) where {Z, M, T, E <: Union{Nothing,Extents.Extent}, C}
            compact = get(io, :compact, false)
            spacing = compact ? "" : " "
            show_mz &= !compact

            extent_str = ""
            crs_str = ""
            if !compact
                if !isnothing(geom.extent)
                    extent_str = ",$(spacing)extent$(spacing)=$(spacing)$(repr(MIME"text/plain"(), geom.extent))"
                end
                if !isnothing(geom.crs)
                    crs_str = ",$(spacing)crs$(spacing)=$(spacing)\"$(repr(MIME"text/plain"(), geom.crs))\""
                end
            end

            str = string($geomtype)
            if show_mz
                str *= "{$Z,$(spacing)$M}"
            end
            str *= "("
            this_geom = getgeom(trait(geom), geom)
            # keep track of how much space we've used + make sure we give this info to any child geoms so they don't go over the limit
            currently_used_space = textwidth(str) + textwidth(extent_str) + textwidth(crs_str)
            if this_geom isa AbstractVector
                # check here if we have enough room to display the whole object or if we need to condense the string
                str *= "["
                currently_used_space += 2 # +2 for brackets
                available_space = screen_ncols - currently_used_space

                space_per_object = floor(Int, available_space / length(this_geom))

                length_of_one_object_in_chars = textwidth(_nice_geom_str(this_geom[1], false, compact, space_per_object))

                # this makes sure that if we have 1 or 2 geometries here, we show both, but any more and we skip them
                num_objects_to_show = min(length(this_geom), max(2, floor(Int, (available_space - 1 #=triple dot character =#) / length_of_one_object_in_chars)))

                # separately track how many objects to show to the left and right of the ...()...
                num_objects_left = num_objects_to_show == 1 ? 0 : ceil(Int, num_objects_to_show/2)
                num_objects_right = max(1, floor(Int, num_objects_to_show/2))
                
                # how many objects are we skipping?
                num_missing = length(this_geom) - (num_objects_left + num_objects_right)
                
                for i ∈ 1:num_objects_left
                    str *= "$(_nice_geom_str(this_geom[i], false, compact, space_per_object)),$(spacing)"
                end
                
                if num_missing > 0
                    # report how many geometries aren't shown here
                    str *= "…$(spacing)($(num_missing))$(spacing)…$(spacing),$(spacing)"
                end

                for i ∈ 1:num_objects_right
                    str *= _nice_geom_str(this_geom[end - num_objects_right + i], false, compact, space_per_object)
                    if i != num_objects_right
                        str *= ",$(spacing)"
                    end
                end
                
                str *= "]"
            else
                str *= _nice_geom_str(parent(geom), false, compact, screen_ncols - currently_used_space)
            end

            str *= extent_str
            str *= crs_str
            
            str *= ")"
            print(io, str)
            return nothing
        end
    end

    @eval function $geomtype{Z,M}(geom::T; extent::E=nothing, crs::C=nothing) where {Z,M,T,E,C}
        Z isa Union{Bool,Nothing} || throw(ArgumentError("Z Parameter must be `true`, `false` or `nothing`"))
        M isa Union{Bool,Nothing} || throw(ArgumentError("M Parameter must be `true`, `false` or `nothing`"))

        # Is geom a single geometry ?
        if isgeometry(geom)
            if geomtrait(geom) isa $child_trait
                # If geom is a child_trait, then make geom a vector and call again
                return $geomtype([geom]; extent, crs)
            else
                # Wrap some geometry at the same level
                geomtrait(geom) isa $trait || _argument_error(T, $trait)
                Z1 = isnothing(Z) ? is3d(geom) : Z
                M1 = isnothing(M) ? ismeasured(geom) : M
                return $geomtype{Z1,M1,T,E,C}(geom, extent, crs)
            end

        # Otherwise wrap an array of child geometries
        elseif geom isa AbstractArray
            child = first(geom)
            children_match = findfirst(child -> !(geomtrait(child) isa $child_trait), geom)

            # Where the next level down is the child geometry
            if isnothing(children_match)
                if $(!isnothing(length_check))
                    $length_check(Base.length(geom)) || _length_error($geomtype, $length_check, geom)
                end
                Z1 = isnothing(Z) ? is3d(first(geom)) : Z
                M1 = isnothing(M) ? ismeasured(first(geom)) : M
                return $geomtype{Z1,M1,T,E,C}(geom, extent, crs)

            # Where we have nested points, as in `coordinates(geom)`
            else
                if child isa AbstractArray
                    if $nesting === 2
                        all(child2 -> geomtrait(child2) isa PointTrait, child) || _parent_type_error($geomtype, $child_trait, geom)
                        Z1 = isnothing(Z) ? is3d(first(child)) : Z
                        M1 = isnothing(M) ? ismeasured(first(child)) : M
                        childtype = $childtype
                        newgeom = childtype.(geom)
                        return $geomtype{Z1,M1,typeof(newgeom),E,C}(newgeom, extent, crs)
                    elseif $nesting === 3
                        all(child) do child2
                            child2 isa AbstractArray && all(child3 -> geomtrait(child3) isa PointTrait, child2)
                        end || _parent_type_error($geomtype, $child_trait, geom)
                        Z1 = isnothing(Z) ? is3d(first(first(child))) : Z
                        M1 = isnothing(M) ? ismeasured(first(first(child))) : M
                        childtype = $childtype
                        newgeom = childtype.(geom)
                        return $geomtype{Z1,M1,typeof(newgeom),E,C}(newgeom, extent, crs)
                    end
                end
                # Otherwise compain the nested child type is wrong
                _wrong_child_error($trait, $child_trait, geom[children_match])
            end
        else
            # Or complain the parent type is wrong
            _parent_type_error($geomtype, $child_trait, geom)
        end
    end
end

function _nice_geom_str(geom, ::Bool, ::Bool, ::Int) 
    io = IOBuffer()
    show(io, MIME"text/plain"(), geom)
    return String(take!(io))
end
# need a work around to pass the show_mz variable through - put string to a temp IOBuffer then read it
function _nice_geom_str(geom::WrapperGeometry, show_mz::Bool, compact::Bool, screen_ncols::Int) 
    buf = IOBuffer()
    io = IOContext(IOContext(buf, :compact => compact))
    show(io, MIME"text/plain"(), geom; show_mz = show_mz, screen_ncols = screen_ncols)
    return String(take!(buf))
end
# handle tuples/vectors explicitly
function _nice_geom_str(geom::AbstractVector, ::Bool, compact::Bool, ::Int)
    spacing = compact ? "" : " "
    str = "["
    str *= _add_elements_with_spacing(geom, spacing)
    str *= "]"
    return str
end
function _nice_geom_str(geom::Tuple, ::Bool, compact::Bool, ::Int)
    spacing = compact ? "" : " "
    str = "("
    str *= _add_elements_with_spacing(geom, spacing)
    str *= ")"
    return str
end

function _add_elements_with_spacing(itr, spacing::String = "")
    str = ""
    for x ∈ itr[1:end - 1]
        str *= "$(x),$(spacing)"
    end
    str *= "$(itr[end])"
end

@noinline _wrong_child_error(geomtype, C, child) = throw(ArgumentError("$geomtype must have child objects with trait $C, got $(typeof(child)) with trait $(geomtrait(child))"))
@noinline _argument_error(T, A) = throw(ArgumentError("$T does not have $A"))
@noinline _length_error(T, f, x) = throw(ArgumentError("Length of array must be $(f.f) $(f.x) for $T"))
@noinline _parent_type_error(trait, child_trait, geom) = throw(ArgumentError("Object $geom is not a $trait geometry or array of $child_trait child geometries"))
@noinline _not_a_point_error(geom) = throw(ArgumentError("Object $geom is not a PointTrait geometry"))

"""
    Point
    Point(geom)
    Point{Z,M}(geom)
    Point(; X, Y, [Z, M])

## Arguments

- `geom`: any object returning `PontTrait` from `GeoInterface.trait`.

## Parameters (optional)

These can be used to force points to be interpreted with
measures or z dimension.

- `Z`: `true` or `false` if there is a z dimension.
- `M`: `true` or `false` if there are measures.

# Example

```jldoctest
using GeoInterface
using GeoInterface.Wrappers
point = Point{false,true}([1, 2, 3])
@assert GeoInterface.ismeasured(point) == true
@assert GeoInterface.is3d(point) == false
GeoInterface.m(point)
# output
3
```
"""
struct Point{Z,M,T,C} <: WrapperGeometry{Z,M,T,C}
    geom::T
    crs::C
end
function Point{Z,M}(geom::T; crs::C=nothing) where {Z,M,T,C}
    expected_coords = 2 + Z + M
    ncoord(geom) == expected_coords || _coord_length_error(Z, M, ncoord(geom))
    Point{Z,M,T,C}(geom, crs)
end
Point(x::Real, y::Real, args::Real...; crs=nothing) = Point((x, y, args...); crs)
Point{Z,M}(x::Real, y::Real, args::Real...; crs=nothing) where {Z,M} = Point{Z,M}((x, y, args...); crs)
function Point(; X::Real, Y::Real, Z::Union{Real,Nothing}=nothing, M::Union{Real,Nothing}=nothing, crs=nothing)
    p = (; X, Y)
    if !isnothing(Z)
        p = merge(p, (; Z))
    end
    if !isnothing(M)
        p = merge(p, (; M))
    end
    return Point(p; crs)
end
function Point(geom::T; crs::C=nothing) where {T,C}
    geomtrait(geom) isa PointTrait || _not_a_point_error(geom)
    if is3d(geom) && ismeasured(geom)
        return Point{true,true,T,C}(geom, crs)
    elseif is3d(geom)
        return Point{true,false,T,C}(geom, crs)
    elseif ismeasured(geom)
        return Point{false,true,T,C}(geom, crs)
    else
        return Point{false,false,T,C}(geom, crs)
    end
end
Point(point::Point{Z,M,T}; crs::C=crs(point)) where {Z,M,T,C} = 
    Point{Z,M,T,C}(parent(point), crs)

geointerface_geomtype(::PointTrait) = Point

isgeometry(::Type{<:Point}) = true
geomtrait(geom::Point) = PointTrait()
ncoord(trait::PointTrait, geom::Point) = ncoord(trait, parent(geom))
getcoord(trait::PointTrait, geom::Point, i::Integer) = getcoord(trait, parent(geom), i)
convert(::Type{Point}, ::PointTrait, geom) = Point(geom)
convert(::Type{Point}, ::PointTrait, geom::Point) = geom
extent(trait::PointTrait, geom::Point) = extent(trait, parent(geom)) 

coordtype(::Point{<:Any,<:Any,<:AbstractArray{T}}) where T = T 
coordtype(::Point{<:Any,<:Any,<:NTuple{<:Any,T}}) where T = T 
coordtype(::Point{<:Any,<:Any,<:NamedTuple{<:Any,<:NTuple{<:Any,T}}}) where T = T 
coordtype(p::Point) = coordtype(parent(p))

x(trait::PointTrait, geom::Point) = x(trait, parent(geom))
y(trait::PointTrait, geom::Point) = y(trait, parent(geom))
z(trait::PointTrait, geom::Point{true}) = z(trait, parent(geom))
z(trait::PointTrait, geom::Point{false}) = _no_z_error()
m(trait::PointTrait, geom::Point{<:Any,false}) = _no_m_error()
m(trait::PointTrait, geom::Point{<:Any,true}) = m(trait, parent(geom))
# Special-case vector and tuple points so we can force them to be measured while not 3d
m(trait::PointTrait, geom::Point{false,true,<:PointTuple3}) = parent(geom)[3]
m(trait::PointTrait, geom::Point{false,true,<:Vector{<:Real}}) = parent(geom)[3]

function Base.:(==)(g1::Point, g2::Point)
    x(g1) == x(g2) && y(g1) == y(g2) && is3d(g1) == is3d(g2) && ismeasured(g1) == ismeasured(g2) || return false
    if is3d(g1)
        z(g1) == z(g2) || return false
    end
    if ismeasured(g1)
        m(g1) == m(g2) || return false
    end
    return true
end
Base.:(!=)(g1::Point, g2::Point) = !(g1 == g2)

function Base.show(io::IO, ::MIME"text/plain", point::Point{Z, M, T, C}; show_mz::Bool = true, screen_ncols::Int = displaysize(io)[2]) where {Z,M,T,C}
    print(io, "Point")
    this_crs = crs(point)

    compact = get(io, :compact, false)
    spacing = compact ? "" : " "

    if !compact && show_mz
        print(io, "{$Z, $M}")
    end
    print(io, "(")
    trait = geomtrait(point)
    print(io, "($(x(trait, point)),$(spacing)$(y(trait, point))")
    if Z
        print(io, ",$(spacing)$(z(trait, point))")
    end
    if M
        print(io, ",$(spacing)$(m(trait, point))")
    end
    print(io, ")")

    if !compact && !isnothing(this_crs)
        print(io, ",$(spacing)crs$(spacing)=$(spacing)")
        print(io, "\"")
        show(io, MIME"text/plain"(), this_crs)
        print(io, "\"")
    end
    print(io, ")")

    return nothing
end

@noinline _coord_length_error(Z, M, l) =
    throw(ArgumentError("Number of coordinates must be $(2 + Z + M) when `Z` is $Z and `M` is $M. Got $l"))
@noinline _no_z_error() = throw(ArgumentError("Point has no `Z` coordinate"))
@noinline _no_m_error() = throw(ArgumentError("Point has no `M` coordinate"))

"""
    Feature(geometry; [properties, crs, extent])

A Feature wrapper.

## Arguments

- `geometry`: any GeoInterface compatible geometry object, or `nothing`.

## Keywords

- `properties`: any object that defines `propertynames` and `getproperty`
- `crs`: Any GeoFormatTypes.jl crs type, or `nothing`
- `extent`: An Extents.jl `Extent` or `nothing`

## Example

```julia
feature = Feature(geom; properties=(a=1, b="2"), crs=EPSG(4326))
```
"""
struct Feature{T,C,E<:Union{Extents.Extent,Nothing}}
    parent::T
    crs::C
    extent::E
end
function Feature(f::Feature; crs=crs(f), extent=f.extent, properties=nothing)
    isnothing(properties) || @info "`properties` keyword not used when wrapping a feature"
    Feature(parent(f), crs, extent)
end
function Feature(geometry=nothing; properties=(;), crs=nothing, extent=nothing)
    if isnothing(geometry) || isgeometry(geometry)
        # Wrap a NamedTuple feature
        Feature((; geometry, properties...), crs, extent)
    else
        throw(ArgumentError("object must be a feature, geometry or `nothing`. Got $(typeof(geometry))"))
    end
end

function Base.show(io::IO, ::MIME"text/plain", f::Feature; show_mz::Bool = true)
    compact = get(io, :compact, false)
    spacing = compact ? "" : " "
    print(io, "Feature(")
    show(io, MIME"text/plain"(), f.parent.geometry; show_mz = show_mz)
    non_geom_props = filter(!=(:geometry), propertynames(f.parent))
    if !isempty(non_geom_props)
        print(io, ",$(spacing)properties$(spacing)=$(spacing)(")
        for (i, property) ∈ enumerate(non_geom_props)
            print(io, "$(property)$(spacing)=$(spacing)")
            show(io, getproperty(f.parent, property))
            if i != length(non_geom_props)
                print(io, ",$(spacing)")
            end
        end
        print(io, ")")
    end
    if !compact
        if !isnothing(f.extent)
            print(io, ", extent$(spacing)=$(spacing)")
            show(io, MIME"text/plain"(), f.extent)
        end
        if !isnothing(f.crs)
            print(io, ", crs$(spacing)=$(spacing)\"")
            show(io, MIME"text/plain"(), f.crs)
            print(io, "\"")
        end
    end
    print(io, ")")
end

Base.parent(f::Feature) = f.parent

isfeature(::Type{<:Feature}) = true
trait(::Feature) = FeatureTrait()
geometry(f::Feature) = geometry(parent(f))
properties(f::Feature) = properties(parent(f))
extent(f::Feature) =
    isfeature(parent(f)) && isnothing(f.extent) ? extent(parent(f)) : f.extent
crs(f::Feature) =
    isfeature(parent(f)) && isnothing(f.crs) ? crs(parent(f)) : f.crs

"""
    FeatureCollection(features; [crs, extent])

A FeatureCollection wrapper.

## Arguments

- `features`: an `AbstractArray` of GeoInterface compatible features.
    Iterables are accepted but will be collected to an `Array`.

## Keywords

- `crs`: Any GeoFormatTypes.jl crs type, or `nothing`
- `extent`: An Extents.jl `Extent` or `nothing`

## Examples

```julia
fc = FeatureCollection([feature1, feature2, feature3];
    crs=EPSG(4326), extent=Extent(X=(11.0, 34.0), Y=(45.7, 78.0))
)
```

Or wrap another `FeatureColection`, e.g. if it has no crs attached:

```julia
fc = FeatureCollection(featurecollection, crs=EPSG(4326))
```
"""
struct FeatureCollection{P,C,E}
    parent::P
    crs::C
    extent::E
end
function FeatureCollection(fc::FeatureCollection; crs=crs(fc), extent=extent(fc))
    FeatureCollection(parent(fc), crs, extent)
end
function FeatureCollection(parent; crs=nothing, extent=nothing)
    if isfeaturecollection(parent)
        FeatureCollection(parent, crs, extent)
    elseif isfeature(parent)
        # If `parent` is a single feature, wrap it in a featurecollection
        FeatureCollection(
            [parent], 
            isnothing(crs) ? Wrappers.crs(parent) : crs, 
            isnothing(extent) ? Wrappers.extent(parent) : extent
        )
    else
        features = (parent isa AbstractArray) ? parent : collect(parent) 
        all(f -> isfeature(f), features) || _child_feature_error()
        FeatureCollection(parent, crs, extent)
    end
end

function Base.show(io::IO, ::MIME"text/plain", fc::FeatureCollection)
    print(io, "FeatureCollection(")
    compact = get(io, :compact, false)
    spacing = compact ? "" : " "
    features = _parent_is_fc(fc) ? getfeature(trait(fc), parent(fc)) : parent(fc)
    print(io, "[")
    for (i, f) ∈ enumerate(features)
        show(io, MIME"text/plain"(), f; show_mz = !compact)
        if i != length(features)
            print(io, ",$(spacing)")
        end
    end
    print(io, "]")
    if !compact
        if !isnothing(fc.crs)
            print(io, ",$(spacing)crs$(spacing)=$(spacing)\"")
            show(io, MIME"text/plain"(), fc.crs)
            print(io, "\"")
        end
        if !isnothing(fc.extent)
            print(io, ",$(spacing)extent$(spacing)=$(spacing)")
            show(io, MIME"text/plain"(), fc.extent)
        end
    end
    print(io, ")")
    return nothing
end

Base.parent(fc::FeatureCollection) = fc.parent

_child_feature_error() = throw(ArgumentError("child objects must be features"))

isfeaturecollection(fc::Type{<:FeatureCollection}) = true
trait(fc::FeatureCollection) = FeatureCollectionTrait()

nfeature(t::FeatureCollectionTrait, fc::FeatureCollection) =
    _parent_is_fc(fc) ? nfeature(t, parent(fc)) : length(parent(fc))
getfeature(t::FeatureCollectionTrait, fc::FeatureCollection) =
    _parent_is_fc(fc) ? getfeature(t, parent(fc)) : parent(fc)
getfeature(t::FeatureCollectionTrait, fc::FeatureCollection, i::Integer) =
    _parent_is_fc(fc) ? getfeature(t, parent(fc), i) : parent(fc)[i]
extent(fc::FeatureCollection) =
    (isnothing(fc.extent) && _parent_is_fc(fc)) ? extent(parent(fc)) : fc.extent
crs(fc::FeatureCollection) =
    (isnothing(fc.crs) && _parent_is_fc(fc)) ? crs(parent(fc)) : fc.crs

_parent_is_fc(x) = isfeaturecollection(parent(x))

end # module

# This file contains internal helper functions to get metadata from DataAPI objects.
# At some point, it may also contain methods to set metadata.

"""
    Internal function.

## Extended help

    _get_dataapi_metadata(geom, key, default)

Get metadata associated with key `key` from some object, `geom`, that has DataAPI.jl metadata support.

If the object does not have metadata support, or the key does not exist, return `default`.
"""
function _get_dataapi_metadata(geom::GeomType, key, default) where GeomType
    if DataAPI.metadatasupport(GeomType).read # check that the type has metadata, and supports reading it
        if key in DataAPI.metadatakeys(geom) # check that the key exists
            return DataAPI.metadata(geom, key; style = false) # read the metadata
        end
    end
    return default
end

function _makie_plottype end
function _makie_convert_arguments end
function _makie_convert_array_arguments end

"""

    GeoInterface.@enable_makie(Makie, GeometryType)

Enable Makie plotting for a type `Geom` that implements the 
geometry interface defined in `GeoInterface`.

# Usage

```julia
using GeoInterface, Makie

struct MyGeometry 
...
end
# overload GeoInterface for MyGeometry
...

# Enable Makie.jl plotting
GeoInterface.@enable_makie Makie GeometryType
```
"""
macro enable_makie(LocalMakie, Geom)
    esc(expr_enable_makie(LocalMakie, Geom))
end

# We need to use `LocalMakie` so that this macro can be called in a package 
# extension as `@enable_makie Makie Geom` otherwise Makie will not be available even 
# after it is loaded, because ot the world age of the @enable macro
function expr_enable_makie(LocalMakie, Geom)
    quote
        # plottype
        function $LocalMakie.plottype(geom::$Geom)
            $_makie_plottype(geom)
        end
        function $LocalMakie.plottype(geom::AbstractArray{<:$Geom})
            $_makie_plottype(first(geom))
        end
        function $LocalMakie.plottype(geom::AbstractArray{<:Union{Missing,<:$Geom}})
            $_makie_plottype(first(skipmissing(geom)))
        end
        # we need `AbstractVector` specifically for dispatch
        function $LocalMakie.plottype(geom::AbstractVector{<:$Geom})
            $_makie_plottype(first(geom))
        end
        function $LocalMakie.plottype(geom::AbstractVector{<:Union{Missing,<:$Geom}})
            $_makie_plottype(first(skipmissing(geom)))
        end

        # convert_arguments
        function $LocalMakie.convert_arguments(p::Type{<:$LocalMakie.Poly}, geom::$Geom; kw...)
            $_makie_convert_arguments(p, geom)
        end
        function $LocalMakie.convert_arguments(p::Type{<:$LocalMakie.Poly}, geoms::AbstractArray{<:$Geom}; kw...)
            $_makie_convert_array_arguments(p, geoms)
        end
        function $LocalMakie.convert_arguments(p::Type{<:$LocalMakie.Poly}, geoms::AbstractArray{<:Union{Missing,<:$Geom}}; kw...)
            $_makie_convert_array_arguments(p, geoms)
        end
        function $LocalMakie.convert_arguments(p::$LocalMakie.PointBased, geom::$Geom; kw...)
            $_makie_convert_arguments(p, geom)
        end
        function $LocalMakie.convert_arguments(p::$LocalMakie.PointBased, geoms::AbstractArray{<:$Geom}; kw...)
            $_makie_convert_array_arguments(p, geoms)
        end
        function $LocalMakie.convert_arguments(p::$LocalMakie.PointBased, geoms::AbstractArray{<:Union{Missing,<:$Geom}}; kw...)
            $_makie_convert_array_arguments(p, geoms)
        end
        function $LocalMakie.convert_arguments(p::Type{<:$LocalMakie.Lines}, geom::$Geom; kw...)
            $_makie_convert_arguments(p, geom)
        end
        function $LocalMakie.convert_arguments(p::Type{<:$LocalMakie.Lines}, geoms::AbstractArray{<:$Geom}; kw...)
            $_makie_convert_array_arguments(p, geoms)
        end
        function $LocalMakie.convert_arguments(p::Type{<:$LocalMakie.Lines}, geoms::AbstractArray{<:Union{Missing,<:$Geom}}; kw...)
            $_makie_convert_array_arguments(p, geoms)
        end
    end
end

function _plots_apply_recipe end
function _plots_apply_recipe_array end

"""
     GeoInterface.@enable_plots(RecipesBase, GeometryType)

Macro to add RecipesBase.jl/Plots.jl recipes to a geometry type.

# Usage

```julia
using RecipesBase, GeoInterface

struct MyGeometry 
...
end
# overload GeoInterface for MyGeometry
...

# Enable Plots.jl plotting
GeoInterfaceRecipes.@enable_plots RecipesBase MyGeometry
```
"""
macro enable_plots(LocalRecipesBase, typ)
    esc(expr_enable_plots(LocalRecipesBase, typ))
end

# We need to use `LocalRecipesBase` so that this macro can be called in a package 
# extension as `@enable_plots RecipesBase Geom` otherwise RecipesBase will not be available even 
# after it is loaded, because ot the world age of the @enable_plots macro
function expr_enable_plots(LocalRecipesBase, typ)
    quote
        # We recreate the apply_recipe functions manually here
        # as nesting the @recipe macro doesn't work.
        function $LocalRecipesBase.apply_recipe(plotattributes::Base.AbstractDict{Base.Symbol, Base.Any}, geom::$typ)
            $_plots_apply_recipe(plotattributes, geom)
        end
        function $LocalRecipesBase.apply_recipe(plotattributes::Base.AbstractDict{Base.Symbol, Base.Any}, geom::Base.AbstractVector{<:Base.Union{Base.Missing,<:$typ}})
            $_plots_apply_recipe_array(plotattributes, geom)
        end
    end
end

module GeoInterfaceMakieExt

import Makie
import GeometryBasics as GB
import GeoInterface as GI

# Functions called from the macro in GeoInterface 
GI._makie_plottype(geom) = _plottype_from_geomtrait(GI.geomtrait(geom))
function GI._makie_convert_arguments(t, geom)::Tuple
    geob = GI.convert(GB, geom)
    return Makie.convert_arguments(t, geob)
end
function GI._makie_convert_array_arguments(plottrait, geoms::AbstractArray{T})::Tuple where T
    geoms_without_missings = Missing <: T ? skipmissing(geoms) : geoms
    # assess whether multification is needed!
    # Multification is the conversion of a vector of mixed single and multi-geometry types,
    # like [::PolygonTrait, ::MultiPolygonTrait, ::PolygonTrait, ...], to the higher multi-
    # type, in this case `MultiPolygon`.
    needs_multification, trait = _needs_multification_trait(geoms_without_missings)

    func_to_apply = if needs_multification
        if trait isa GI.MultiLineStringTrait
            to_multilinestring
        elseif trait isa GI.MultiPolygonTrait
            to_multipoly
        else
            error("GeoInterface: We don't support mixed single-and-multi geometries for this multi trait yet: $(trait)")
        end
    else
        # base case
        Base.Fix1(GI.convert, GB)
    end
    if Missing <: T
        return Makie.convert_arguments(
            plottrait, 
            map(
                _operator_nangeom_if_missing_or_func(
                    func_to_apply, 
                    trait, 
                    GI.ncoord(first(geoms_without_missings))
                ), 
                geoms
            )
        )
    else # no missings, do this the regular way
        return Makie.convert_arguments(plottrait, map(func_to_apply, geoms))
    end
end

function _plottype_from_geomtrait(::Union{GI.LineStringTrait,GI.MultiLineStringTrait})
    Makie.Lines
end
function _plottype_from_geomtrait(::Union{GI.PointTrait,GI.MultiPointTrait})
    Makie.Scatter
end
function _plottype_from_geomtrait(::Union{GI.GeometryCollectionTrait,GI.PolygonTrait,GI.MultiPolygonTrait,GI.LinearRingTrait})
    Makie.Poly
end

function _operator_nangeom_if_missing_or_func(func, trait::GI.AbstractGeometryTrait, ndims; numtype=Float64)
    nan_geom = _nan_geom(trait, ndims, numtype)
    return x -> ismissing(x) ? nan_geom : func(x)
end

# Creating empty geometries from traits
function _geomtrait_for_array(arr)
    idx = findfirst(!ismissing, arr)
    geom = if isnothing(idx)
        error("We can't plot only missings!!")
    else
        arr[idx]
    end
end

# NaN geometry creators from traits
_nan_geom(::GI.PointTrait, ndims = 2, T = Float64) = GB.Point{ndims, T}(NaN)
_nan_geom(::GI.MultiPointTrait, ndims = 2, T = Float64) = GB.MultiPoint(_nan_geom(GI.PointTrait(), ndims, T))
_nan_geom(::GI.LineStringTrait, ndims = 2, T = Float64) = GB.LineString([_nan_geom(GI.PointTrait(), ndims, T)])
_nan_geom(::GI.MultiLineStringTrait, ndims = 2, T = Float64) = GB.MultiLineString([_nan_geom(GI.LineStringTrait(), ndims, T)])
_nan_geom(::GI.PolygonTrait, ndims = 2, T = Float64) = GB.Polygon([_nan_geom(GI.PointTrait(), ndims, T)])
_nan_geom(::GI.MultiPolygonTrait, ndims = 2, T = Float64) = GB.MultiPolygon([_nan_geom(GI.PolygonTrait(), ndims, T)])

# Munging utilities for mixed geometry arrays
# Taken from GeoMakie.jl


_multi_trait(::Union{GI.PolygonTrait, GI.MultiPolygonTrait}) = GI.MultiPolygonTrait()
_multi_trait(::Union{GI.LineStringTrait, GI.MultiLineStringTrait}) = GI.MultiLineStringTrait()
_multi_trait(::Union{GI.PointTrait, GI.MultiPointTrait}) = GI.MultiPointTrait()

"""
    _needs_multification_trait(geoms)::(needs_mulification::Bool, trait::GI.AbstractTrait)

`geoms` must be some iterable of geometries.
"""
function _needs_multification_trait(geoms)
    first_trait = GI.geomtrait(first(skipmissing(geoms)))
    # GeometryCollections are a special case, since they can contain
    # multiple geometries, which all need to be handled differently.
    if first_trait isa GI.GeometryCollectionTrait # if this happens, look at the second trait if it exists
        if length(geoms) ≤ 1 # there is only one geometrycollection
            # analyze the contents
            traits = unique(map(GI.geomtrait, GI.getgeom(first(geoms))))
            if GI.MultiPolygonTrait() ∈ traits || GI.PolygonTrait() ∈ traits
                return true, GI.MultiPolygonTrait()
            elseif GI.MultiLineStringTrait() ∈ traits || GI.LineStringTrait() ∈ traits
                return true, GI.MultiLineStringTrait()
            elseif GI.MultiPointTrait() ∈ traits || GI.PointTrait() ∈ traits
                return true, GI.MultiPointTrait()
            end
        else 
            # A robust solution is to:
            # - Traverse the array to find the first non-geometrycollection element
            # If that fails, then introspect the first element as was done earlier, to
            # get the multification trait.
            first_nongc_idx = findfirst(x -> GI.geomtrait(x) != GI.GeometryCollectionTrait, geoms)
            if isnothing(first_nongc_idx) # only geometry collections in the whole array
                return _needs_multification_trait((GI.getgeom(first(skipmissing(geoms))),)) # introspect the first element
            else
                # introspect the first non-geometrycollection element
                return _needs_multification_trait((first(Iterators.drop(geoms, first_nongc_idx-1)),))
            end
        end
    end
    # Now, we continue with the regular code.
    different_trait_idx = findfirst(x -> GI.geomtrait(x) != first_trait, geoms)
    if isnothing(different_trait_idx)
        return false, first_trait # all traits are the same, so we don't need to multify
    else
        return true, _multi_trait(first_trait) # traits are different, so we need to multify
    end
end

to_multipoly(poly::GB.Polygon) = GB.MultiPolygon([poly])
to_multipoly(poly::Vector{GB.Polygon}) = GB.MultiPolygon(poly)
to_multipoly(mp::GB.MultiPolygon) = mp
to_multipoly(geom) = to_multipoly(GI.trait(geom), geom)
to_multipoly(::Nothing, geom::AbstractVector) = to_multipoly.(GI.trait.(geom), geom)
to_multipoly(::GI.PolygonTrait, geom) = GB.MultiPolygon([GI.convert(GB, geom)])
to_multipoly(::GI.MultiPolygonTrait, geom) = GI.convert(GB, geom)

function to_multipoly(::GI.GeometryCollectionTrait, geom)
    ls_or_mls = filter(x -> GI.geomtrait(x) isa Union{GI.MultiPolygonTrait, GI.PolygonTrait}, GI.getgeom(geom))
    multipolys = to_multipoly(ls_or_mls)
    return GB.MultiPolygon(vcat(getproperty.(multipolys, :polygons)...))
end

to_multilinestring(poly::GB.LineString) = GB.MultiLineString([poly])
to_multilinestring(poly::Vector{GB.Polygon}) = GB.MultiLineString(poly)
to_multilinestring(mp::GB.MultiLineString) = mp
to_multilinestring(geom) = to_multilinestring(GI.trait(geom), geom)
to_multilinestring(geom::AbstractVector) = to_multilinestring.(GI.trait.(geom), geom)
to_multilinestring(::GI.LineStringTrait, geom) = GB.MultiLineString([GI.convert(GB, geom)])
to_multilinestring(::GI.MultiLineStringTrait, geom) = GI.convert(GB, geom)

function to_multilinestring(::GI.GeometryCollectionTrait, geom)
    ls_or_mls = filter(x -> GI.geomtrait(x) isa Union{GI.MultiLineStringTrait, GI.LineStringTrait}, GI.getgeom(geom))
    multilinestrings = to_multilinestring(ls_or_mls)
    return GeometryBasics.MultiLineString(vcat(getproperty.(multilinestrings, :linestrings)...))
end

# TODO: MultiPoint is broken in Makie, but should be fixed there
to_multipoint(poly::GB.Point) = GB.MultiPoint([poly])
to_multipoint(poly::Vector{GB.Point}) = GB.MultiPoint(poly)
to_multipoint(mp::GB.MultiPoint) = mp
to_multipoint(geom) = to_multipoint(GI.trait(geom), geom)
to_multipoint(geom::AbstractVector) = to_multipoint.(GI.trait.(geom), geom)
to_multipoint(::GI.PointTrait, geom) = GB.MultiPoint([GI.convert(GB, geom)])
to_multipoint(::GI.MultiPointTrait, geom) = GI.convert(GB, geom)

# TODO 
# Features and Feature collections
# https://github.com/JuliaGeo/GI.jl/pull/72#issue-1406325596

# Enable Makie.jl for GI wrappers
GI.@enable_makie Makie GI.WrapperGeometry

end

using GeoInterfaceRecipes
using GeoInterface
using Plots
using Test


abstract type MyAbstractGeom{N} end
# Implement interface
struct MyPoint{N} <: MyAbstractGeom{N} end
struct MyCurve{N} <: MyAbstractGeom{N} end
struct MyLinearRing{N} <: MyAbstractGeom{N} end
struct MyLineString{N} <: MyAbstractGeom{N} end
struct MyPolygon{N} <: MyAbstractGeom{N} end
struct MyMultiPoint{N} <: MyAbstractGeom{N} end
struct MyMultiCurve{N} <: MyAbstractGeom{N} end
struct MyMultiPolygon{N} <: MyAbstractGeom{N} end
struct MyCollection{N} <: MyAbstractGeom{N} end
struct MyFeature end
struct MyFeatureCollection end

GeoInterfaceRecipes.@enable MyAbstractGeom
GeoInterfaceRecipes.@enable MyFeature
# Test legacy interface
GeoInterfaceRecipes.@enable_geo_plots MyFeatureCollection

GeoInterface.isgeometry(::MyAbstractGeom) = true
GeoInterface.is3d(::GeoInterface.AbstractGeometryTrait, ::MyAbstractGeom{N}) where {N} = N == 3
GeoInterface.ncoord(::GeoInterface.AbstractGeometryTrait, geom::MyAbstractGeom{N}) where {N} = N
GeoInterface.coordnames(::GeoInterface.AbstractGeometryTrait, ::MyAbstractGeom{2}) = (:X, :Y)
GeoInterface.coordnames(::GeoInterface.AbstractGeometryTrait, ::MyAbstractGeom{3}) = (:X, :Y, :Z)

GeoInterface.geomtrait(::MyPoint) = GeoInterface.PointTrait()
GeoInterface.getcoord(::GeoInterface.PointTrait, geom::MyPoint{2}, i::Integer) = (rand(1:10), rand(11:20))[i]
GeoInterface.getcoord(::GeoInterface.PointTrait, geom::MyPoint{3}, i::Integer) = (rand(1:10), rand(11:20), rand(21:30))[i]

GeoInterface.geomtrait(::MyCurve) = GeoInterface.LineStringTrait()
GeoInterface.ngeom(::GeoInterface.LineStringTrait, geom::MyCurve) = 3
GeoInterface.getgeom(::GeoInterface.LineStringTrait, geom::MyCurve{N}, i) where {N} = MyPoint{N}()
GeoInterface.convert(::Type{MyCurve}, ::GeoInterface.LineStringTrait, geom) = geom

GeoInterface.geomtrait(::MyLinearRing) = GeoInterface.LinearRingTrait()
GeoInterface.ngeom(::GeoInterface.LinearRingTrait, geom::MyLinearRing) = 3
GeoInterface.getgeom(::GeoInterface.LinearRingTrait, geom::MyLinearRing{N}, i) where {N} = MyPoint{N}()
GeoInterface.convert(::Type{MyLinearRing}, ::GeoInterface.LinearRingTrait, geom) = geom

GeoInterface.geomtrait(::MyLineString) = GeoInterface.LineStringTrait()
GeoInterface.ngeom(::GeoInterface.LineStringTrait, geom::MyLineString) = 3
GeoInterface.getgeom(::GeoInterface.LineStringTrait, geom::MyLineString{N}, i) where {N} = MyPoint{N}()
GeoInterface.convert(::Type{MyLineString}, ::GeoInterface.LineStringTrait, geom) = geom

GeoInterface.geomtrait(::MyPolygon) = GeoInterface.PolygonTrait()
GeoInterface.ngeom(::GeoInterface.PolygonTrait, geom::MyPolygon) = 2
GeoInterface.getgeom(::GeoInterface.PolygonTrait, geom::MyPolygon{N}, i) where {N} = MyCurve{N}()

GeoInterface.geomtrait(::MyMultiPolygon) = GeoInterface.MultiPolygonTrait()
GeoInterface.ngeom(::GeoInterface.MultiPolygonTrait, geom::MyMultiPolygon) = 2
GeoInterface.getgeom(::GeoInterface.MultiPolygonTrait, geom::MyMultiPolygon{N}, i) where {N} = MyPolygon{N}()

GeoInterface.geomtrait(::MyMultiPoint) = GeoInterface.MultiPointTrait()
GeoInterface.ngeom(::GeoInterface.MultiPointTrait, geom::MyMultiPoint) = 10
GeoInterface.getgeom(::GeoInterface.MultiPointTrait, geom::MyMultiPoint{N}, i) where {N} = MyPoint{N}()

GeoInterface.geomtrait(geom::MyCollection) = GeoInterface.GeometryCollectionTrait()
GeoInterface.ncoord(::GeoInterface.GeometryCollectionTrait, geom::MyCollection{N}) where {N} = N
GeoInterface.ngeom(::GeoInterface.GeometryCollectionTrait, geom::MyCollection) = 4
GeoInterface.getgeom(::GeoInterface.GeometryCollectionTrait, geom::MyCollection{N}, i) where {N} = MyMultiPolygon{N}()

GeoInterface.trait(::MyFeature) = FeatureTrait()
GeoInterface.trait(::MyFeatureCollection) = FeatureCollectionTrait()
GeoInterface.getfeature(::GeoInterface.FeatureCollectionTrait, geom::MyFeatureCollection, i) = MyFeature()
GeoInterface.getfeature(::GeoInterface.FeatureCollectionTrait, geom::MyFeatureCollection) = [MyFeature(), MyFeature()]
GeoInterface.geometry(geom::MyFeature) = rand((MyPolygon{2}(), MyMultiPolygon{2}()))
GeoInterface.nfeature(::GeoInterface.FeatureTrait, geom::MyFeature) = 1

@testset "plot" begin
    # We just check if they actually run
    # 2d
    plot(MyPoint{2}())
    plot(MyCurve{2}())
    plot(MyLinearRing{2}())
    plot(MyLineString{2}())
    plot(MyMultiPoint{2}())
    plot(MyPolygon{2}())
    plot(MyMultiPolygon{2}())
    plot(MyCollection{2}())
    # 3d
    plot(MyPoint{3}())
    plot(MyCurve{3}())
    plot(MyLinearRing{3}())
    plot(MyLineString{3}())
    plot(MyMultiPoint{3}())
    plot(MyPolygon{3}())
    plot(MyMultiPolygon{3}())
    plot(MyCollection{3}())
    plot(MyFeature())
    plot(MyFeatureCollection())
end

# All Geometries
"""
    GeoInterface.isgeometry(x) => Bool

Check if an object `x` is a geometry and thus implicitly supports GeoInterface methods.
It is recommended that for users implementing `MyType`, they define only
`isgeometry(::Type{MyType})`. `isgeometry(::MyType)` will then automatically delegate to this
method.
"""
isgeometry(x::T) where {T} = isgeometry(T)
isgeometry(::Type{T}) where {T} = false

"""
    GeoInterface.isfeature(x) => Bool

Check if an object `x` is a feature and thus implicitly supports some GeoInterface methods.
A feature is a combination of a geometry and properties, not unlike a row in a table.
It is recommended that for users implementing `MyType`, they define only
`isfeature(::Type{MyType})`. `isfeature(::MyType)` will then automatically delegate to this
method.

Ensures backwards compatibility with GeoInterface version 0.
"""
isfeature(x::T) where {T} = isfeature(T)
isfeature(::Type{T}) where {T} = false

"""
    GeoInterface.isfeaturecollection(x) => Bool

Check if an object `x` is a collection of features and thus implicitly supports some
GeoInterface methods. A feature collection is a collection of features, and may also
contain metatdata for the whole collection, like an `Extent`.

It is recommended that for users implementing `MyType`, they define only
`isfeaturecollection(::Type{MyType})`. `isfeaturecollection(::MyType)` will then
automatically delegate to this method.
"""
isfeaturecollection(x::T) where {T} = isfeaturecollection(T)
isfeaturecollection(::Type{T}) where {T} = false

"""
The key used to retrieve and store the geometrycolumns from DataAPI.jl metadata, if no other solution exists in that format.
"""
const GEOINTERFACE_GEOMETRYCOLUMNS_KEY = "GEOINTERFACE:geometrycolumns"

"""
    GeoInterface.geometrycolumns(featurecollection) => (:geometry,)

Retrieve the geometrycolumn(s) of `featurecollection`; the fields (or columns in a table)
which contain geometries that support GeoInterface.

This is always a `Tuple` of `Symbol`s.
"""
function geometrycolumns(featurecollection)
    gcs = _get_dataapi_metadata(featurecollection, GEOINTERFACE_GEOMETRYCOLUMNS_KEY, (:geometry,)) # see `metadata.jl`
    return _aftercare_geometrycolumns(gcs)
end

_aftercare_geometrycolumns(gcs::Tuple{Vararg{Symbol}}) = gcs
_aftercare_geometrycolumns(gcs::Tuple{Vararg{String}}) = Symbol.(gcs)
_aftercare_geometrycolumns(gcs::String) = (Symbol(gcs),)
_aftercare_geometrycolumns(gcs::Symbol) = (gcs,)

"""
    GeoInterface.geometry(feat) => geom

Retrieve the geometry of `feat`. It is expected that `isgeometry(geom) === true`.
Ensures backwards compatibility with GeoInterface version 0.
"""
geometry(feat) = nothing

"""
    GeoInterface.properties(feat) => properties

Retrieve the properties of `feat`. This can be any Iterable that behaves like an AbstractRow.
Ensures backwards compatibility with GeoInterface version 0.
"""
properties(feat) = nothing

"""
    GeoInterface.getfeature(collection) => [feature, ...]

Retrieve the features of `collection` as some iterable of features.
It is expected that `isfeature(feature) === true`.
"""
getfeature(collection) = getfeature(trait(collection), collection)
getfeature(collection, i::Integer) = getfeature(trait(collection), collection, i)

"""
    GeoInterface.nfeature(collection)

Retrieve the number of features in a feature collection.
"""
nfeature(collection) = nfeature(trait(collection), collection)

"""
    GeoInterface.geomtrait(geom) => T <: AbstractGeometry

Returns the geometry type, such as [`PolygonTrait`](@ref) or [`PointTrait`](@ref).
"""
geomtrait(geom) = nothing

"""
    GeoInterface.trait(geom) => T <: AbstractGeometry

Returns the object type, such as [`FeatureTrait`](@ref).
For all `isgeometry` objects `trait` is the same as `geomtrait(obj)`,
e.g. [`PointTrait`](@ref).
"""
trait(geom) = geomtrait(geom)

"""
    GeoInterface.israster(x) => Bool

Check if an object `x` is a raster and thus implicitly supports some
GeoInterface methods. A raster requires the crs and extent methods to be defined.

It is recommended that for users implementing `MyType`, they define only
`israster(::Type{MyType})`. `israster(::MyType)` will then
automatically delegate to this method.
"""
israster(x::T) where {T} = israster(T)
israster(::Type{T}) where {T} = false


# All types
"""
    ncoord(geom) -> Integer

Return the number of coordinate dimensions (such as 3 for X,Y,Z) for the geometry.
Note that SF distinguishes between dimensions, spatial dimensions and topological dimensions, which we do not.
"""
ncoord(geom) = ncoord(geomtrait(geom), geom)

"""
    coordnames(geom) -> Tuple{Symbol}

Return the names of coordinate dimensions (such for (:X,:Y,:Z)) for the geometry.
"""
coordnames(geom) = coordnames(geomtrait(geom), geom)

"""
    isempty(geom) -> Bool

Return `true` when the geometry is empty.
"""
isempty(geom) = isempty(geomtrait(geom), geom)

"""
    issimple(geom) -> Bool

Return `true` when the geometry is simple, i.e. doesn't cross or touch itself.
"""
issimple(geom) = issimple(geomtrait(geom), geom)

"""
    getcoord(geom, i) -> Number

Return the `i`th coordinate for a given `geom`. A coordinate isa `Real`.
Note that this is only valid for individual [`AbstractPointTrait`](@ref)s.
"""
getcoord(geom, i::Integer) = getcoord(geomtrait(geom), geom, i)
"""
    getcoord(geom) -> iterator
"""
getcoord(geom) = getcoord(geomtrait(geom), geom)

# Curve, LineString, MultiPoint
"""
    npoint(geom) -> Int

Return the number of points in given `geom`.
Note that this is only valid for [`AbstractCurveTrait`](@ref)s and [`AbstractMultiPointTrait`](@ref)s.
"""
npoint(geom) = npoint(geomtrait(geom), geom)

"""
    getpoint(geom, i::Integer) -> Point

Return the `i`th Point in given `geom`.
Note that this is only valid for [`AbstractCurveTrait`](@ref)s and [`AbstractMultiPointTrait`](@ref)s.
"""
getpoint(geom, i::Integer) = getpoint(geomtrait(geom), geom, i)

"""
    getpoint(geom) -> iterator

Returns an iterator over all points in `geom`.
"""
getpoint(geom) = getpoint(geomtrait(geom), geom)

# Curve
"""
    startpoint(geom) -> Point

Return the first point in the `geom`.
Note that this is only valid for [`AbstractCurveTrait`](@ref)s.
"""
startpoint(geom) = startpoint(geomtrait(geom), geom)

"""
    endpoint(geom) -> Point

Return the last point in the `geom`.
Note that this is only valid for [`AbstractCurveTrait`](@ref)s.
"""
endpoint(geom) = endpoint(geomtrait(geom), geom)

"""
    isclosed(geom) -> Bool

Return whether the `geom` is closed, i.e. whether
the `startpoint` is the same as the `endpoint`.
Note that this is only valid for [`AbstractCurveTrait`](@ref)s.
"""
isclosed(geom) = isclosed(geomtrait(geom), geom)

"""
    isring(geom) -> Bool

Return whether the `geom` is a ring, i.e. whether
the `geom` [`isclosed`](@ref) and [`issimple`](@ref).
Note that this is only valid for [`AbstractCurveTrait`](@ref)s.
"""
isring(geom) = isclosed(geom) && issimple(geom)

"""
    length(geom) -> Number

Return the length of `geom` in its 2d coordinate system.
Note that this is only valid for [`AbstractCurveTrait`](@ref)s.
"""
length(geom) = length(geomtrait(geom), geom)


# Surface

"""
    area(geom) -> Number

Return the area of `geom` in its 2d coordinate system.
Note that this is only valid for [`AbstractSurfaceTrait`](@ref)s.
"""
area(geom) = area(geomtrait(geom), geom)


"""
    centroid(geom) -> Point

The mathematical centroid for this Surface as a Point.
The result is not guaranteed to be on this Surface.
Note that this is only valid for [`AbstractSurfaceTrait`](@ref)s.
"""
centroid(geom) = centroid(geomtrait(geom), geom)


"""
    pointonsurface(geom) -> Point

A Point guaranteed to be on this geometry (as opposed to [`centroid`](@ref)).
Note that this is only valid for [`AbstractSurfaceTrait`](@ref)s.
"""
pointonsurface(geom) = pointonsurface(geomtrait(geom), geom)


"""
    boundary(geom) -> Curve

Return the boundary of `geom`.
Note that this is only valid for [`AbstractSurfaceTrait`](@ref)s.
"""
boundary(geom) = boundary(geomtrait(geom), geom)


# Polygon/Triangle

"""
    nring(geom) -> Integer

Return the number of rings in given `geom`.
Note that this is only valid for [`AbstractPolygonTrait`](@ref)s and
[`AbstractMultiPolygonTrait`](@ref)s
"""
nring(geom) = nring(geomtrait(geom), geom)

"""
    getring(geom, i::Integer) -> AbstractCurve

A specific ring `i` in a polygon or multipolygon (exterior and holes).
Note that this is only valid for [`AbstractPolygonTrait`](@ref)s and
[`AbstractMultiPolygonTrait`](@ref)s.
"""
getring(geom, i::Integer) = getring(geomtrait(geom), geom, i)

"""
    getring(geom) -> iterator

Returns an iterator over all rings in `geom`.
Note that this is only valid for [`AbstractPolygonTrait`](@ref)s and
[`AbstractMultiPolygonTrait`](@ref)s in single-argument form.
"""
getring(geom) = getring(geomtrait(geom), geom)

"""
    getexterior(geom) -> Curve

Returns the exterior ring of a Polygon as a `AbstractCurve`.
Note that this is only valid for [`AbstractPolygonTrait`](@ref)s.
"""
getexterior(geom) = getexterior(geomtrait(geom), geom)

"""
    nhole(geom) -> Integer

Returns the number of holes for this given `geom`.
Note that this is only valid for [`AbstractPolygonTrait`](@ref)s.
"""
nhole(geom)::Integer = nhole(geomtrait(geom), geom)

"""
    gethole(geom, i::Integer) -> Curve

Returns the `i`th interior ring for this given `geom`.
Note that this is only valid for [`AbstractPolygonTrait`](@ref)s.
"""
gethole(geom, i::Integer) = gethole(geomtrait(geom), geom, i)

"""
    gethole(geom) -> iterator

Returns an iterator over all holes in `geom`.
Note that this is only valid for [`AbstractPolygonTrait`](@ref)s.
"""
gethole(geom) = gethole(geomtrait(geom), geom)

# PolyhedralSurface
"""
    npatch(geom)

Returns the number of patches for the given `geom`.
Note that this is only valid for [`AbstractPolyhedralSurfaceTrait`](@ref)s.
"""
npatch(geom)::Integer = npatch(geomtrait(geom), geom)

"""
    getpatch(geom, i::Integer) -> AbstractPolygon

Returns the `i`th patch for the given `geom`.
Note that this is only valid for [`AbstractPolyhedralSurfaceTrait`](@ref)s.
"""
getpatch(geom, i::Integer) = getpatch(geomtrait(geom), geom, i)

"""
    getpatch(geom) -> iterator

Returns an iterator over all patches in `geom`.
Note that this is only valid for [`AbstractPolyhedralSurfaceTrait`](@ref)s.
"""
getpatch(geom) = getpatch(geomtrait(geom), geom)

"""
    boundingpolygons(geom, i) -> AbstractMultiPolygon

Returns the collection of polygons in this surface that bounds the `i`th patch in the given `geom`.
"""
boundingpolygons(geom, i) = boundingpolygons(geomtrait(geom), geom, i)

# GeometryCollection
"""
    ngeom(geom) -> Integer

Returns the number of geometries for the given `geom`.
"""
ngeom(geom) = ngeom(geomtrait(geom), geom)

"""
    getgeom(geom, i::Integer) -> AbstractGeometry

Returns the `i`th geometry for the given `geom`.
"""
getgeom(geom, i::Integer) = getgeom(geomtrait(geom), geom, i)

"""
    getgeom(geom) -> iterator

Returns an iterator over all geometry components in `geom`.
"""
getgeom(geom) = getgeom(geomtrait(geom), geom)

# MultiLineString
"""
    nlinestring(geom) -> Integer

Returns the number of curves for the given `geom`.
Note that this is only valid for [`AbstractMultiLineStringTrait`](@ref)s.
"""
nlinestring(geom) = nlinestring(geomtrait(geom), geom)

"""
    getlinestring(geom, i::Integer) -> AbstractCurve

Returns the `i`th linestring for the given `geom`.
Note that this is only valid for [`AbstractMultiLineStringTrait`](@ref)s.
"""
getlinestring(geom, i::Integer) = getlinestring(geomtrait(geom), geom, i)

"""
    getlinestring(geom) -> iterator

Returns an iterator over all linestrings in a geometry.
Note that this is only valid for [`AbstractMultiLineStringTrait`](@ref)s.
"""
getlinestring(geom) = getlinestring(geomtrait(geom), geom)

# MultiPolygon
"""
    npolygon(geom) -> Integer

Returns the number of polygons for the given `geom`.
Note that this is only valid for [`AbstractMultiPolygonTrait`](@ref)s.
"""
npolygon(geom) = npolygon(geomtrait(geom), geom)

"""
    getpolygon(geom, i::Integer) -> AbstractCurve

Returns the `i`th polygon for the given `geom`.
Note that this is only valid for [`AbstractMultiPolygonTrait`](@ref)s.
"""
getpolygon(geom, i::Integer) = getpolygon(geomtrait(geom), geom, i)

"""
    getpolygon(geom) -> iterator

Returns an iterator over all polygons in a geometry.
Note that this is only valid for [`AbstractMultiPolygonTrait`](@ref)s.
"""
getpolygon(geom) = getpolygon(geomtrait(geom), geom)

# Other methods
"""
    crs(geom) -> T <: GeoFormatTypes.CoordinateReferenceSystemFormat

Retrieve Coordinate Reference System for given geom.
In SF this is defined as `SRID`.
"""
crs(geom) = crs(trait(geom), geom)

"""
    extent(obj; fallback=true) -> T <: Extents.Extent

Retrieve the extent (bounding box) for given geom or feature.
In SF this is defined as `envelope`.

`Extents.extent(obj)` will be called if `extent(trait(obj), obj)`,
is not defined so it may be preferable to define `Extents.extent` directly.

When `fallback` is true, and the obj does not have an extent,
an extent is calculated from the coordinates of all geometries in `obj`.
"""
function extent(obj; fallback=true)
    t = trait(obj)
    isnothing(t) && return Extents.extent(obj)
    ex = extent(t, obj)
    isnothing(ex) && fallback && return calc_extent(t, obj)
    return ex
end

"""
    bbox(geom) -> T <: Extents.Extent

Alias for [`extent`](@ref), for compatibility with
GeoJSON and the Python geointerface.
Ensures backwards compatibility with GeoInterface version 0.
"""
bbox(geom) = extent(geom)

# DE-9IM, see https://en.wikipedia.org/wiki/DE-9IM
"""
    equals(a, b) -> Bool

Returns whether `a` and `b` are equal.
Equivalent to ([`within`](@ref) && [`contains`](@ref)).
"""
equals(a, b)::Bool = equals(geomtrait(a), geomtrait(b), a, b)

"""
    disjoint(a, b) -> Bool

Returns whether `a` and `b` are disjoint.
Inverse of [`intersects`](@ref).
"""
disjoint(a, b)::Bool = disjoint(geomtrait(a), geomtrait(b), a, b)

"""
    intersects(a, b) -> Bool

Returns whether `a` and `b` intersect.
Inverse of [`disjoint`](@ref).
"""
intersects(a, b)::Bool = intersects(geomtrait(a), geomtrait(b), a, b)

"""
    touches(a, b) -> Bool

Returns whether `a` and `b` touch.
"""
touches(a, b)::Bool = touches(geomtrait(a), geomtrait(b), a, b)

"""
    within(a, b) -> Bool

Returns whether `a` is within `b`.
The order of arguments is important.
Equivalent to [`contains`](@ref) with reversed arguments.
"""
within(a, b)::Bool = within(geomtrait(a), geomtrait(b), a, b)

"""
    contains(a, b) -> Bool

Returns whether `a` contains `b`.
The order of arguments is important.
Equivalent to [`within`](@ref) with reversed arguments.
"""
contains(a, b)::Bool = contains(geomtrait(a), geomtrait(b), a, b)

"""
    overlaps(a, b) -> Bool

Returns whether `a` and `b` overlap. Also called `covers` in DE-9IM.
"""
overlaps(a, b)::Bool = overlaps(geomtrait(a), geomtrait(b), a, b)

"""
    crosses(a, b) -> Bool

Returns whether `a` and `b` cross.
"""
crosses(a, b)::Bool = crosses(geomtrait(a), geomtrait(b), a, b)

"""
    relate(a, b, relationmatrix::String) -> Bool

Returns whether `a` and `b` relate, based on the provided relation matrix.
"""
relate(a, b, relationmatrix)::Bool = relate(geomtrait(a), geomtrait(b), a, b, relationmatrix)

# Set theory
"""
    symdifference(a, b) -> AbstractGeometry

Returns a geometric object that represents the Point set symmetric difference of `a` with `b`.
"""
symdifference(a, b) = symdifference(geomtrait(a), geomtrait(b), a, b)

"""
    difference(a, b) -> AbstractGeometry

Returns a geometric object that represents the Point set difference of `a` with `b`
"""
difference(a, b) = difference(geomtrait(a), geomtrait(b), a, b)

"""
    intersection(a, b) -> AbstractGeometry

Returns a geometric object that represents the Point set intersection of `a` with `b`
"""
intersection(a, b) = intersection(geomtrait(a), geomtrait(b), a, b)

"""
    union(a, b) -> AbstractGeometry

Returns a geometric object that represents the Point set union of `a` with `b`
"""
union(a, b) = union(geomtrait(a), geomtrait(b), a, b)

# Spatial analysis
"""
    distance(a, b) -> Number

Returns the shortest distance between `a` with `b`.
"""
distance(a, b) = distance(geomtrait(a), geomtrait(b), a, b)

"""
    buffer(geom, distance) -> AbstractGeometry

Returns a geometric object that represents a buffer of the given `geom` with `distance`.
"""
buffer(geom, distance) = buffer(geomtrait(geom), geom, distance)

"""
    convexhull(geom) -> AbstractCurve

Returns a geometric object that represents the convex hull of the given `geom`.
"""
convexhull(geom) = convexhull(geomtrait(geom), geom)

"""
    coordtype(geom) -> Type

Return the type of the coordinates in the geom. 

Usually `<: AbstractFloat` but can be any `Number`.
"""
coordtype(geom) = coordtype(trait(geom), geom)

"""
    x(geom) -> Number

Return the :X coordinate of the given `geom`.
Note that this is only valid for [`AbstractPointTrait`](@ref)s.

For `Tuple` and `Vector` points, the first value is returned.
"""
x(geom) = x(geomtrait(geom), geom)

"""
    y(geom) -> Number

Return the :Y coordinate of the given `geom`.
Note that this is only valid for [`AbstractPointTrait`](@ref)s.

For `Tuple` and `Vector` points, the second value is returned.
"""
y(geom) = y(geomtrait(geom), geom)

"""
    z(geom) -> Number

Return the :Z coordinate of the given `geom`.
Note that this is only valid for [`AbstractPointTrait`](@ref)s.

For length 3 `Tuple` and `Vector` points, the third value is returned.
"""
z(geom) = z(geomtrait(geom), geom)

"""
    m(geom) -> Number

Return the :M (measured) coordinate of the given `geom`.
Note that this is only valid for [`AbstractPointTrait`](@ref)s.

For length 4 `Tuple` and `Vector` points, the fourth value
is returned. 

Length 3 `Tuple` and `Vector` points can *not* represent measured points,
and will throw an `ArgumentError`.
"""
m(geom) = m(geomtrait(geom), geom)

"""
    is3d(geom) -> Bool

Return whether the given `geom` has a :Z coordinate.
"""
is3d(geom) = is3d(geomtrait(geom), geom)
"""
    ismeasured(geom) -> Bool

Return whether the given `geom` has a :M coordinate.
"""
ismeasured(geom) = ismeasured(geomtrait(geom), geom)

"""
    coordinates(geom) -> Vector

Return (an iterator of) point coordinates.
Ensures backwards compatibility with GeoInterface version 0.
"""
coordinates(obj) = coordinates(trait(obj), obj)

"""
    convert(type::CustomGeom, geom)
    convert(module::Module, geom)

Create a `CustomGeom` from any `geom` that implements the GeoInterface.

Can also convert to a `Module`, which finds the corresponding
geom type for the trait using the modules `geointerface_traittype` method.

`convert(T::Type)` or `convert(m::Module)` return curried versions of that function, 
just like `==`.

# Extended help

For developers, the base implementation is `GeoInterface.convert(::YourGeomType, ::AbstractTrait, some_other_geom)`.
This is the method signature that must be implemented for a custom geometry type.  
    
Users may also call this method directly, if they know the exact output - this can sometimes 
save the Julia compiler some work and cause more optimal code to be generated.

For convenience and type stability there is a `convert(::Module, ::AbstractTrait, geom)` method
that is particularly useful when the trait of a geometry needs to be propagated deep within the 
stack.  

This helps to prevent the compiler from losing the trait information, especially useful 
when dealing with sumtype-like implementations or opaque pointers from C libraries.
"""
convert(T, geom) = convert(T, geomtrait(geom), geom)
convert(::Type{T}, x::T) where {T} = x  # no-op
convert(T::Type) = Base.Fix1(convert, T)
convert(M::Module) = Base.Fix1(convert, M)

"""
    astext(geom) -> WKT

Convert `geom` into Well Known Text (WKT) representation, such as `POINT (30 10)`.
"""
astext(geom) = astext(geomtrait(geom), geom)

"""
    asbinary(geom) -> WKB

Convert `geom` into Well Known Binary (WKB) representation, such as `000000000140000000000000004010000000000000`.
"""
asbinary(geom) = asbinary(geomtrait(geom), geom)

"""
    crstrait(geom) -> AbstractCRSTrait

Retrieves the type of the Coordinate Reference System for the given `geom`.
Defaults to retrieving from `crs(geom)` and to `UnknownTrait` if not implemented.

"""
crstrait(geom) = UnknownTrait()

"An AbstractTrait type for all geometries, features and feature collections."
abstract type AbstractTrait end
"An AbstractGeometryTrait type for all geometries."
abstract type AbstractGeometryTrait <: AbstractTrait end

"An AbstractGeometryCollectionTrait type for all geometrycollections."
abstract type AbstractGeometryCollectionTrait <: AbstractGeometryTrait end
"A GeometryCollection is a collection of `Geometry`s."
struct GeometryCollectionTrait <: AbstractGeometryCollectionTrait end

"An AbstractPointTrait for all points."
abstract type AbstractPointTrait <: AbstractGeometryTrait end
"A single point."
struct PointTrait <: AbstractPointTrait end

"An AbstractCurveTrait type for all curves."
abstract type AbstractCurveTrait <: AbstractGeometryTrait end
"An AbstractLineString type for all linestrings."
abstract type AbstractLineStringTrait <: AbstractCurveTrait end
"A LineStringTrait is a collection of straight lines between its `PointTrait`s."
struct LineStringTrait <: AbstractLineStringTrait end
"A LineTrait is [`LineStringTrait`](@ref) with just two points."
struct LineTrait <: AbstractLineStringTrait end
"A LinearRingTrait is a [`LineStringTrait`](@ref) with the same begin and endpoint."
struct LinearRingTrait <: AbstractLineStringTrait end

"A CircularStringTrait is a curve, with an odd number of points.
A single segment consists of three points, where the first and last are the beginning and end,
while the second is halfway the curve."
struct CircularStringTrait <: AbstractCurveTrait end
"A CompoundCurveTrait is a curve that combines straight [`LineStringTrait`](@ref)s and curved [`CircularStringTrait`](@ref)s."
struct CompoundCurveTrait <: AbstractCurveTrait end

"An AbstractSurfaceTrait type for all surfaces."
abstract type AbstractSurfaceTrait <: AbstractGeometryTrait end
"An AbstractCurvePolygonTrait type for all curved polygons."
abstract type AbstractCurvePolygonTrait <: AbstractSurfaceTrait end
"An [`AbstractCurvePolygonTrait`](@ref) that can contain either circular or straight curves as rings."
struct CurvePolygonTrait <: AbstractCurvePolygonTrait end
"An AbstractPolygonTrait type for all polygons."
abstract type AbstractPolygonTrait <: AbstractCurvePolygonTrait end
"An [`AbstractSurfaceTrait`](@ref) with straight rings either as exterior or interior(s)."
struct PolygonTrait <: AbstractPolygonTrait end
"A [`PolygonTrait`](@ref) that is triangular."
struct TriangleTrait <: AbstractPolygonTrait end
"A [`PolygonTrait`](@ref) that is rectangular and could be described by the minimum and maximum vertices."
struct RectangleTrait <: AbstractPolygonTrait end
"A [`PolygonTrait`](@ref) with four vertices."
struct QuadTrait <: AbstractPolygonTrait end
"A [`PolygonTrait`](@ref) with five vertices."
struct PentagonTrait <: AbstractPolygonTrait end
"A [`PolygonTrait`](@ref) with six vertices."
struct HexagonTrait <: AbstractPolygonTrait end

"An AbstractPolyhedralSurfaceTrait type for all polyhedralsurfaces."
abstract type AbstractPolyhedralSurfaceTrait <: AbstractSurfaceTrait end
"A PolyhedralSurfaceTrait is a connected surface consisting of [`PolygonTrait`](@ref)s."
struct PolyhedralSurfaceTrait <: AbstractPolyhedralSurfaceTrait end
"A TINTrait is a [`PolyhedralSurfaceTrait`](@ref) consisting of [`TriangleTrait`](@ref)s."
struct TINTrait <: AbstractPolyhedralSurfaceTrait end  # Surface consisting of Triangles

"An AbstractMultiPointTrait type for all multipoints."
abstract type AbstractMultiPointTrait <: AbstractGeometryCollectionTrait end
"A MultiPointTrait is a collection of [`PointTrait`](@ref)s."
struct MultiPointTrait <: AbstractMultiPointTrait end

"An AbstractMultiCurveTrait type for all multicurves."
abstract type AbstractMultiCurveTrait <: AbstractGeometryCollectionTrait end
"A MultiCurveTrait is a collection of [`CircularStringTrait`](@ref)s."
struct MultiCurveTrait <: AbstractMultiCurveTrait end
"An AbstractMultiLineStringTrait type for all multilinestrings."
abstract type AbstractMultiLineStringTrait <: AbstractMultiCurveTrait end
"A MultiLineStringTrait is a collection of [`LineStringTrait`](@ref)s."
struct MultiLineStringTrait <: AbstractMultiLineStringTrait end

"An AbstractMultiSurfaceTrait type for all multisurfaces."
abstract type AbstractMultiSurfaceTrait <: AbstractGeometryCollectionTrait end
"A MultiSurfaceTrait is a collection of [`AbstractSurfaceTrait`](@ref)s."
struct MultiSurfaceTrait <: AbstractMultiSurfaceTrait end
"An AbstractMultiPolygonTrait type for all multipolygons."
abstract type AbstractMultiPolygonTrait <: AbstractMultiSurfaceTrait end
"A MultiPolygonTrait is a collection of [`PolygonTrait`](@ref)s."
struct MultiPolygonTrait <: AbstractMultiPolygonTrait end


"An AbstractFeatureTrait for all features"
abstract type AbstractFeatureTrait <: AbstractTrait end
"A FeatureTrait holds `geometries`, `properties` and an `extent`"
struct FeatureTrait <: AbstractFeatureTrait end

"An AbstractFeatureCollectionTrait for all feature collections"
abstract type AbstractFeatureCollectionTrait <: AbstractTrait end
"A FeatureCollectionTrait holds objects of `FeatureTrait`"
struct FeatureCollectionTrait <: AbstractFeatureCollectionTrait end

"Supertype for all coordinate reference system traits"
abstract type AbstractCRSTrait end

"An AbstractProjectedTrait for all projected coordinate reference systems"
abstract type AbstractProjectedTrait <: AbstractCRSTrait end
"An AbstractGeographicTrait for all geographic coordinate reference systems"
abstract type AbstractGeographicTrait <: AbstractCRSTrait end

"An ProjectedTrait for all projected coordinate reference systems"
struct ProjectedTrait <: AbstractProjectedTrait end
"An GeographicTrait for all geographic coordinate reference systems"
struct GeographicTrait <: AbstractGeographicTrait end
"An UnknownTrait for all unknown (assumed projected) coordinate reference systems"
struct UnknownTrait <: AbstractProjectedTrait
    function UnknownTrait()
        Base.depwarn("It is unknown whether your geometry is projected or geographic. Please implement `crstrait` for your geometry.", :UnknownTrait)
        new()
    end
end

"An AbstractRasterTrait for all rasters"
abstract type AbstractRasterTrait <: AbstractTrait end
struct RasterTrait <: AbstractRasterTrait end

import GeoInterface as GI

using Makie
using Test
using GeoInterface.Wrappers
using GeoInterface: Point
using CairoMakie

@testset "Makie plotting MultiLineString shows additional lines #83" begin
    mls = MultiLineString([LineString([(0, 0), (3, 0), (3, 3), (0, 3), (0, 0)]), LineString([(1, 1), (2, 1), (2, 2), (1, 2), (1, 1)])])
    expected = [[0.0, 0.0], [3.0, 0.0], [3.0, 3.0], [0.0, 3.0], [0.0, 0.0], 
                [NaN, NaN], 
                [1.0, 1.0], [2.0, 1.0], [2.0, 2.0], [1.0, 2.0], [1.0, 1.0]]

    converted = Makie.convert_arguments(Makie.Lines, mls)
    @test isequal(converted, (expected,))
end

@testset "smoketest 2d" begin
    # Set up test geometries
    unitsquare = Polygon(LineString([(0, 0), (0, 1), (1, 1), (1, 0), (0, 0)]))
    Makie.plot(unitsquare)
    bigsquare = Polygon(LineString([(0, 0), (11, 0), (11, 11), (0, 11), (0, 0)]))
    smallsquare = Polygon(LineString([(5, 5), (8, 5), (8, 8), (5, 8), (5, 5)]))
    multipolygon = MultiPolygon([smallsquare, unitsquare])
    point = Point(1, 0)
    multipoint = MultiPoint([(1, 2), (2, 3), (3, 4)])
    geoms = [
        unitsquare,
        multipolygon, 
        point, 
        multipoint,
    ]

    # Plot them all onto one figure
    fig = Figure()
    for (i, geom) in enumerate(geoms)
        # MultiPoint is broken in Makie
        geom isa MultiPoint && continue
        # plot a geometry into an axis
        Makie.plot(fig[i, 1], geom; axis=(; type=Axis, title="$(GI.geomtrait(geom))"))
        # plot a vector of the same geometry into the axis
        @test_nowarn Makie.plot(fig[i, 2], [geom, geom]; axis=(; type=Axis, title="Vector of $(GI.geomtrait(geom))"))
    end
    @test_nowarn Makie.update_state_before_display!(fig)
    @test_nowarn Makie.colorbuffer(fig.scene)
    fig
end

@testset "Make sure that Makie can plot NaN-based geometry correctly" begin
    f, a, p = poly(Makie.GeometryBasics.Polygon([Point2f(NaN)]))
    @test_nowarn Makie.update_state_before_display!(f)
    @test_nowarn Makie.colorbuffer(f.scene)
    @test a.finallimits[] == Makie.Rect2d(Vec2(0.0, 0.0), Vec2(10.0, 10.0))
    # Hide all decorations so the scene should ideally be completely white
    hidedecorations!(a)
    hidespines!(a)
    # Rasterize the figure's scene to an image
    img = Makie.colorbuffer(f.scene)
    # Test that everything is white, i.e., there is no color.
    # This means that nothing was plotted, which is good.
    @test all(==(Makie.ARGB32(1,1,1,1)), img)
end

@testset "Mixed geometry types work" begin
    poly = GI.Polygon([GI.LinearRing([(0, 0), (1, 0), (1, 1), (0, 0)])])
    multipoly = GI.MultiPolygon([poly, poly])
    @test_nowarn Makie.plot([poly, multipoly])
    @test_nowarn Makie.plot([GI.GeometryCollection([poly, multipoly]), multipoly])
end

@testset "handle missing values" begin
    # First test that missing values get the right dispatches
    points = [GI.Point(1.0, 2.0), GI.Point(3.0, 4.0), missing]
    @test_nowarn Makie.plot(points)
    lines = [GI.LineString(Point2d[(1, 2), (3, 4)]), GI.LineString(Point2d[(5, 4), (5, 6)]), missing]
    @test_nowarn Makie.plot(lines)
    polys = [GI.Polygon([GI.LinearRing([(1, 2), (3, 4), (5, 5), (1, 2)])]), GI.Polygon([GI.LinearRing([(7, 8), (9, 10), (11, 11), (7, 8)])]), missing]
    @test_nowarn Makie.plot(polys)
    # Now we test that appropriate "missing" (i.e., NaN) polygons 
    # are inserted in the correct place, so that we have the same
    # number of elements post conversion as pre conversion.  This
    # allows colors to be propagated correctly through the array.
    @test_nowarn Makie.poly(polys; color = 1:length(polys))
end

using Test
using GeoInterface
using GeoFormatTypes: EPSG
using GeoInterface.DataAPI

struct TestMetadata
    geometrycolumns
    crs
end

DataAPI.metadatasupport(::Type{TestMetadata}) = (; read = true, write = false)
DataAPI.metadatakeys(::TestMetadata) = ("GEOINTERFACE:geometrycolumns", "GEOINTERFACE:crs")
function DataAPI.metadata(x::TestMetadata, key::String; style::Bool=false)
    if key === "GEOINTERFACE:geometrycolumns"
        style ? (x.geometrycolumns, :note) : x.geometrycolumns
    elseif key === "GEOINTERFACE:crs"
        style ? (x.crs, :note) : x.crs
    else
        nothing
    end
end
DataAPI.metadata(x::TestMetadata, key::String, default; style::Bool=false) = something(DataAPI.metadata(x, key; style), style ? (default, :note) : default)





@testset "DataAPI" begin
    td = TestMetadata((:g,), nothing)
    @test GeoInterface.geometrycolumns(td) == (:g,)
    @test GeoInterface.crs(td) === nothing

    td = TestMetadata((:g,), EPSG(4326))
    @test GeoInterface.geometrycolumns(td) == (:g,)
    @test GeoInterface.crs(td) == EPSG(4326)

    td = TestMetadata("geometry1", EPSG(4326))
    @test GeoInterface.geometrycolumns(td) == (:geometry1,)
    @test GeoInterface.crs(td) == EPSG(4326)
end

module GeoInterface

using Extents: Extents, Extent
using GeoFormatTypes: CoordinateReferenceSystemFormat
using Base.Iterators: flatten
import DataAPI

export testgeometry, isgeometry, trait, geomtrait, ncoord, getcoord, ngeom, getgeom

# traits
export AbstractGeometryTrait,
    AbstractGeometryCollectionTrait,
    GeometryCollectionTrait,
    AbstractPointTrait,
    PointTrait,
    AbstractCurveTrait,
    AbstractLineStringTrait,
    LineStringTrait,
    LineTrait,
    LinearRingTrait,
    CircularStringTrait,
    CompoundCurveTrait,
    AbstractSurfaceTrait,
    AbstractCurvePolygonTrait,
    CurvePolygonTrait,
    AbstractPolygonTrait,
    PolygonTrait,
    TriangleTrait,
    RectangleTrait,
    QuadTrait,
    PentagonTrait,
    HexagonTrait,
    AbstractPolyhedralSurfaceTrait,
    PolyhedralSurfaceTrait,
    TINTrait,
    AbstractMultiPointTrait,
    MultiPointTrait,
    AbstractMultiCurveTrait,
    MultiCurveTrait,
    AbstractMultiLineStringTrait,
    MultiLineStringTrait,
    AbstractMultiSurfaceTrait,
    MultiSurfaceTrait,
    AbstractMultiPolygonTrait,
    MultiPolygonTrait,
    AbstractFeatureTrait,
    FeatureTrait,
    AbstractFeatureCollectionTrait,
    FeatureCollectionTrait,
    RasterTrait


include("types.jl")
include("interface.jl")
include("fallbacks.jl")
include("utils.jl")
include("base.jl")
include("wrappers.jl")
include("metadata.jl")
include("plotting.jl")

using .Wrappers
using .Wrappers: geointerface_geomtype

end # module

using GeoFormatTypes
using GeoInterface
using Documenter
using Test

include("test_primitives.jl")
include("test_wrappers.jl")
include("test_makie.jl")
include("test_plots.jl")
include("test_dataapi.jl")
doctest(GeoInterface)

using GeoInterface
using GeoInterface.Wrappers
using Plots
using Test

# We just check if plot actually runs
@testset "Plots.plot" begin
    linearring2 = LinearRing([Point(1.0, 2.0), Point(2.0, 3.0), Point(2.0, 1.0), Point(1.0, 2.0)])
    polygon2 = Polygon([linearring2])
    feature2 = Feature(polygon2)
    # 2d
    Plots.plot(Point(1.0, 2.0))
    Plots.plot(linearring2)
    Plots.plot(MultiPoint([Point(1.0, 2.0), Point(2.0, 3.0)]))
    Plots.plot(polygon2)
    Plots.plot(MultiPolygon([polygon]))
    # TODO this needs to handle mixed objects properly
    Plots.plot(GeometryCollection([polygon]))
    Plots.plot(feature2)
    Plots.plot(FeatureCollection([feature2]))
    # 3d
    linearring3 = LinearRing([Point(1.0, 2.0, 3.0), Point(2.0, 3.0, 4.0), Point(2.0, 1.0, 4.0), Point(1.0, 2.0, 3.0)])
    polygon3 = Polygon([linearring3])
    feature3 = Feature(polygon3)
    Plots.plot(Point(1.0, 2.0, 3.0))
    Plots.plot(linearring3)
    Plots.plot(MultiPoint([Point(1.0, 2.0, 3.0), Point(5.0, 4.0, 2.0)]))
    Plots.plot(polygon3)
    Plots.plot(MultiPolygon([polygon3]))
    Plots.plot(GeometryCollection(polygon3))
    Plots.plot(feature3)
    Plots.plot(FeatureCollection([feature3]))
end

module GeoInterfaceRecipes
using RecipesBase
using GeoInterface

export @enable_geo_plots

# This package is deprecated. Plotting recipes are now built into GeoInterface.jl
# as package extensions. See:
# - GeoInterfaceRecipesBaseExt for Plots.jl support
# - GeoInterfaceMakieExt for Makie.jl support

# This stub package exists only to allow smooth upgrades for users who had
# GeoInterfaceRecipes.jl installed. No action is needed - simply load
# GeoInterface with Plots or Makie and the recipes will work automatically.

macro enable(typ)
    :(GeoInterface.@enable_plots RecipesBase $(esc(typ)))
end

# Compat
macro enable_geo_plots(typ)
    :(GeoInterface.@enable_plots RecipesBase $(esc(typ)))
end

end

using GeoInterface
using GeoFormatTypes
using Extents
using Test

# Implement interface
struct MyPoint end
struct MyEmptyPoint end
struct MyCurve end
struct MyPolygon end
struct MyEmptyPolygon end
struct MyTriangle end
struct MyMultiPoint end
struct MyMultiCurve end
struct MyMultiPolygon end
struct MyTIN end
struct MyCollection end
struct MyFeature{G,P}
    geometry::G
    properties::P
end
struct MyFeatureCollection{G}
    geoms::G
end

struct Raster end

GeoInterface.isgeometry(::Type{MyPoint}) = true
GeoInterface.geomtrait(::MyPoint) = PointTrait()
GeoInterface.ncoord(::PointTrait, geom::MyPoint) = 2
GeoInterface.getcoord(::PointTrait, geom::MyPoint, i) = [1, 2][i]

GeoInterface.isgeometry(::Type{MyEmptyPoint}) = true
GeoInterface.geomtrait(::MyEmptyPoint) = PointTrait()
GeoInterface.ncoord(::PointTrait, geom::MyEmptyPoint) = 0
GeoInterface.isempty(::PointTrait, geom::MyEmptyPoint) = true

GeoInterface.isgeometry(::Type{MyCurve}) = true
GeoInterface.geomtrait(::MyCurve) = LineStringTrait()
GeoInterface.ngeom(::LineStringTrait, geom::MyCurve) = 2
GeoInterface.getgeom(::LineStringTrait, geom::MyCurve, i) = MyPoint()
GeoInterface.ncoord(t::LineStringTrait, geom::MyCurve) = 2

GeoInterface.isgeometry(::Type{MyPolygon}) = true
GeoInterface.geomtrait(::MyPolygon) = PolygonTrait()
GeoInterface.ngeom(::PolygonTrait, geom::MyPolygon) = 2
GeoInterface.getgeom(::PolygonTrait, geom::MyPolygon, i) = MyCurve()
GeoInterface.ncoord(t::PolygonTrait, geom::MyPolygon) = 2

GeoInterface.isgeometry(::Type{MyEmptyPolygon}) = true
GeoInterface.geomtrait(::MyEmptyPolygon) = PolygonTrait()
GeoInterface.ngeom(::PolygonTrait, geom::MyEmptyPolygon) = 0
GeoInterface.getgeom(::PolygonTrait, geom::MyEmptyPolygon, i) = nothing
GeoInterface.isempty(::PolygonTrait, geom::MyEmptyPolygon) = true

GeoInterface.isgeometry(::Type{MyTriangle}) = true
GeoInterface.geomtrait(::MyTriangle) = TriangleTrait()
GeoInterface.ngeom(::TriangleTrait, geom::MyTriangle) = 3
GeoInterface.getgeom(::TriangleTrait, geom::MyTriangle, i) = MyCurve()
GeoInterface.ncoord(t::TriangleTrait, geom::MyTriangle) = 2

GeoInterface.isgeometry(::Type{MyMultiPoint}) = true
GeoInterface.geomtrait(::MyMultiPoint) = MultiPointTrait()
GeoInterface.ngeom(::MultiPointTrait, geom::MyMultiPoint) = 2
GeoInterface.getgeom(::MultiPointTrait, geom::MyMultiPoint, i) = MyPoint()
GeoInterface.ncoord(t::MultiPointTrait, geom::MyMultiPoint) = 2

GeoInterface.isgeometry(::Type{MyMultiCurve}) = true
GeoInterface.geomtrait(::MyMultiCurve) = MultiCurveTrait()
GeoInterface.ngeom(::MultiCurveTrait, geom::MyMultiCurve) = 2
GeoInterface.getgeom(::MultiCurveTrait, geom::MyMultiCurve, i) = MyCurve()
GeoInterface.ncoord(t::MultiCurveTrait, geom::MyMultiCurve) = 2

GeoInterface.isgeometry(::Type{MyMultiPolygon}) = true
GeoInterface.geomtrait(::MyMultiPolygon) = MultiPolygonTrait()
GeoInterface.ngeom(::MultiPolygonTrait, geom::MyMultiPolygon) = 2
GeoInterface.getgeom(::MultiPolygonTrait, geom::MyMultiPolygon, i) = MyPolygon()
GeoInterface.ncoord(t::MultiPolygonTrait, geom::MyMultiPolygon) = 2

GeoInterface.isgeometry(::Type{MyTIN}) = true
GeoInterface.geomtrait(::MyTIN) = PolyhedralSurfaceTrait()
GeoInterface.ngeom(::PolyhedralSurfaceTrait, geom::MyTIN) = 2
GeoInterface.getgeom(::PolyhedralSurfaceTrait, geom::MyTIN, i) = MyTriangle()
GeoInterface.ncoord(t::PolyhedralSurfaceTrait, geom::MyTIN) = 2

GeoInterface.isgeometry(::Type{MyCollection}) = true
GeoInterface.geomtrait(::MyCollection) = GeometryCollectionTrait()
GeoInterface.ngeom(::GeometryCollectionTrait, geom::MyCollection) = 2
GeoInterface.getgeom(::GeometryCollectionTrait, geom::MyCollection, i) = MyCurve()
GeoInterface.ncoord(t::GeometryCollectionTrait, geom::MyCollection) = 2

GeoInterface.isfeature(::Type{<:MyFeature}) = true
GeoInterface.trait(feature::MyFeature) = FeatureTrait()
GeoInterface.geometry(f::MyFeature) = f.geometry
GeoInterface.properties(f::MyFeature) = f.properties
GeoInterface.extent(::FeatureTrait, f::MyFeature) = Extent(X=(1, 1), Y=(2, 2))

GeoInterface.isfeaturecollection(fc::Type{<:MyFeatureCollection}) = true
GeoInterface.trait(fc::MyFeatureCollection) = FeatureCollectionTrait()
GeoInterface.nfeature(::FeatureCollectionTrait, fc::MyFeatureCollection) = length(fc.geoms)
GeoInterface.getfeature(::FeatureCollectionTrait, fc::MyFeatureCollection) = fc.geoms
GeoInterface.getfeature(::FeatureCollectionTrait, fc::MyFeatureCollection, i::Integer) = fc.geoms[i]

GeoInterface.israster(::Type{<:Raster}) = true
GeoInterface.trait(::Raster) = RasterTrait()
GeoInterface.extent(::RasterTrait, ::Raster) = Extents.Extent()
GeoInterface.crs(::RasterTrait, ::Raster) = GeoFormatTypes.EPSG(4326)


@testset "Developer" begin

    @testset "Point" begin
        geom = MyPoint()
        @test testgeometry(geom)
        @test GeoInterface.x(geom) === 1
        @test GeoInterface.y(geom) === 2
        @test_throws ArgumentError GeoInterface.z(geom)
        @test_throws ArgumentError GeoInterface.m(geom)
        @test ncoord(geom) === 2
        @test collect(getcoord(geom)) == [1, 2]
        @test GeoInterface.coordinates(geom) == [1, 2]
        @test getcoord(geom, 1) === 1
        @test GeoInterface.coordnames(geom) == (:X, :Y)
        @test !GeoInterface.isempty(geom)
        @test !GeoInterface.is3d(geom)
        @test !GeoInterface.ismeasured(geom)
        @test GeoInterface.extent(geom) == Extents.Extent(X=(1, 1), Y=(2, 2))
        @test GeoInterface.bbox(geom) == Extents.Extent(X=(1, 1), Y=(2, 2))
        @test isnothing(GeoInterface.extent(geom, fallback=false))

        geom = MyEmptyPoint()
        @test GeoInterface.coordnames(geom) == ()
        @test GeoInterface.isempty(geom)

        @test isnothing(GeoInterface.crs(geom))
    end

    @testset "LineString" begin
        geom = MyCurve()
        @test testgeometry(geom)

        @test GeoInterface.npoint(geom) == 2  # defaults to ngeom
        @test GeoInterface.ncoord(geom) == 2
        @test GeoInterface.coordinates(geom) == [[1, 2], [1, 2]]
        points = GeoInterface.getpoint(geom)
        point = GeoInterface.getpoint(geom, 1)
        pointa = GeoInterface.startpoint(geom)
        pointb = GeoInterface.endpoint(geom)
        @test GeoInterface.y(point) == 2

        @test_throws MethodError GeoInterface.length(geom)

        @test GeoInterface.issimple(geom)
        @test GeoInterface.isclosed(geom)
        @test GeoInterface.isring(geom)

    end

    @testset "Polygon" begin
        geom = MyPolygon()
        @test testgeometry(geom)
        # Test that half a implementation yields an error

        @test GeoInterface.nring(geom) == 2
        @test GeoInterface.nhole(geom) == 1
        @test GeoInterface.ncoord(geom) == 2
        @test GeoInterface.coordinates(geom) == [[[1, 2], [1, 2]], [[1, 2], [1, 2]]]
        lines = GeoInterface.getring(geom)
        line = GeoInterface.getring(geom, 1)
        lines = GeoInterface.gethole(geom)
        line = GeoInterface.gethole(geom, 1)
        line = GeoInterface.getexterior(geom)
        @test GeoInterface.npoint(geom) == 4
        @test collect(GeoInterface.getpoint(geom)) == [MyPoint(), MyPoint(), MyPoint(), MyPoint()]

        @test_throws MethodError GeoInterface.area(geom)

        geom = MyTriangle()
        @test testgeometry(geom)
        @test GeoInterface.nring(geom) == 1
        @test GeoInterface.nhole(geom) == 0
        @test GeoInterface.npoint(geom) == 3

        geom = MyEmptyPolygon()
        @test GeoInterface.isempty(geom)
        @test GeoInterface.nring(geom) == 0
        @test GeoInterface.npoint(geom) == 0
    end

    @testset "MultiPoint" begin
        geom = MyMultiPoint()
        @test testgeometry(geom)

        @test GeoInterface.npoint(geom) == 2
        @test GeoInterface.ncoord(geom) == 2
        points = GeoInterface.getpoint(geom)
        point = GeoInterface.getpoint(geom, 1)
        @test GeoInterface.coordinates(geom) == [[1, 2], [1, 2]]
        @test collect(points) == [MyPoint(), MyPoint()]

        @test !GeoInterface.issimple(geom)
    end

    @testset "MultiLineString" begin
        geom = MyMultiCurve()
        @test testgeometry(geom)

        @test GeoInterface.ncoord(geom) == 2
        @test GeoInterface.nlinestring(geom) == 2
        lines = GeoInterface.getlinestring(geom)
        line = GeoInterface.getlinestring(geom, 1)
        @test GeoInterface.coordinates(geom) == [[[1, 2], [1, 2]], [[1, 2], [1, 2]]]
        @test collect(lines) == [MyCurve(), MyCurve()]
    end

    @testset "MultiPolygon" begin
        geom = MyMultiPolygon()
        @test testgeometry(geom)

        @test GeoInterface.npolygon(geom) == 2
        @test GeoInterface.ncoord(geom) == 2
        polygons = GeoInterface.getpolygon(geom)
        polygon = GeoInterface.getpolygon(geom, 1)
        @test GeoInterface.coordinates(geom) == [[[[1, 2], [1, 2]], [[1, 2], [1, 2]]], [[[1, 2], [1, 2]], [[1, 2], [1, 2]]]]
        @test GeoInterface.extent(geom) == Extents.Extent(X=(1, 1), Y=(2, 2))
        @test collect(polygons) == [MyPolygon(), MyPolygon()]
    end

    @testset "Surface" begin
        geom = MyTIN()
        @test testgeometry(geom)

        @test GeoInterface.npatch(geom) == 2
        polygons = GeoInterface.getpatch(geom)
        polygon = GeoInterface.getpatch(geom, 1)
        @test GeoInterface.coordinates(geom) == [[[[1, 2], [1, 2]], [[1, 2], [1, 2]], [[1, 2], [1, 2]]], [[[1, 2], [1, 2]], [[1, 2], [1, 2]], [[1, 2], [1, 2]]]]
        @test collect(polygons) == [MyTriangle(), MyTriangle()]
    end

    @testset "GeometryCollection" begin
        geom = MyCollection()
        @test testgeometry(geom)

        @test GeoInterface.ngeom(geom) == 2
        @test GeoInterface.ncoord(geom) == 2
        geoms = GeoInterface.getgeom(geom)
        thing = GeoInterface.getgeom(geom, 1)
        @test GeoInterface.coordinates(geom) == [[[1, 2], [1, 2]], [[1, 2], [1, 2]]]
        @test collect(geoms) == [MyCurve(), MyCurve()]
    end

end

@testset "Defaults" begin
    @test GeoInterface.subtrait(TINTrait()) == TriangleTrait
    @test GeoInterface.nring(QuadTrait(), ()) == 1
    @test GeoInterface.npoint(QuadTrait(), ()) == 4
end

@testset "Feature" begin
    feature = MyFeature((1, 2), (a=10, b=20))
    @test GeoInterface.testfeature(feature)
    @test GeoInterface.extent(feature) == Extents.Extent(X=(1, 1), Y=(2, 2))
end

@testset "FeatureCollection" begin
    features = MyFeatureCollection(
        [MyFeature(MyPoint(), (a="1", b="2")), MyFeature(MyPolygon(), (a="3", b="4")), MyFeature(nothing, (a="5", b="6"))]
    )
    @test GeoInterface.testfeaturecollection(features)
    @test GeoInterface.extent(features) == Extents.Extent(X=(1, 1), Y=(2, 2))
end

@testset "Raster" begin
    raster = Raster()
    @test GeoInterface.testraster(raster)
end

@testset "Conversion" begin
    struct XCurve end
    struct XPolygon end

    geom = MyCurve()
    @test GeoInterface.convert(MyCurve, geom) === geom
    @test_throws Exception GeoInterface.convert(MyPolygon, geom)
    @test GeoInterface.convert(MyCurve)(geom) == geom
    @test_throws Exception GeoInterface.convert(MyPolygon)(geom)

end

@testset "Operations" begin
    struct XGeom end

    GeoInterface.isgeometry(::Type{XGeom}) = true
    GeoInterface.geomtrait(::XGeom) = PointTrait()
    GeoInterface.ncoord(::PointTrait, geom::XGeom) = 2
    GeoInterface.getcoord(::PointTrait, geom::XGeom, i) = [1, 2][i]

    GeoInterface.equals(::PointTrait, ::PointTrait, ::XGeom, ::XGeom) = true
    GeoInterface.disjoint(::PointTrait, ::PointTrait, ::XGeom, ::XGeom) = true
    GeoInterface.intersects(::PointTrait, ::PointTrait, ::XGeom, ::XGeom) = true
    GeoInterface.touches(::PointTrait, ::PointTrait, ::XGeom, ::XGeom) = true
    GeoInterface.within(::PointTrait, ::PointTrait, ::XGeom, ::XGeom) = true
    GeoInterface.contains(::PointTrait, ::PointTrait, ::XGeom, ::XGeom) = true
    GeoInterface.overlaps(::PointTrait, ::PointTrait, ::XGeom, ::XGeom) = true
    GeoInterface.crosses(::PointTrait, ::PointTrait, ::XGeom, ::XGeom) = true

    GeoInterface.relate(::PointTrait, ::PointTrait, ::XGeom, ::XGeom, matrix) = true

    GeoInterface.symdifference(::PointTrait, ::PointTrait, a::XGeom, ::XGeom) = a
    GeoInterface.difference(::PointTrait, ::PointTrait, a::XGeom, ::XGeom) = a
    GeoInterface.intersection(::PointTrait, ::PointTrait, a::XGeom, ::XGeom) = a
    GeoInterface.union(::PointTrait, ::PointTrait, ::XGeom, a::XGeom) = a

    GeoInterface.distance(::PointTrait, ::PointTrait, ::XGeom, ::XGeom) = rand()

    GeoInterface.buffer(::PointTrait, a::XGeom, distance) = a
    GeoInterface.convexhull(::PointTrait, a::XGeom) = a

    GeoInterface.astext(::PointTrait, ::XGeom) = "POINT (1 2)"
    GeoInterface.asbinary(::PointTrait, ::XGeom) = [0x0, 0x0]

    geom = XGeom()

    @test GeoInterface.equals(geom, geom)
    @test GeoInterface.disjoint(geom, geom)
    @test GeoInterface.intersects(geom, geom)
    @test GeoInterface.touches(geom, geom)
    @test GeoInterface.within(geom, geom)
    @test GeoInterface.contains(geom, geom)
    @test GeoInterface.overlaps(geom, geom)
    @test GeoInterface.crosses(geom, geom)

    @test GeoInterface.relate(geom, geom, ["a"])

    @test GeoInterface.isgeometry(GeoInterface.symdifference(geom, geom))
    @test GeoInterface.isgeometry(GeoInterface.difference(geom, geom))
    @test GeoInterface.isgeometry(GeoInterface.intersection(geom, geom))
    @test GeoInterface.isgeometry(GeoInterface.union(geom, geom))

    @test GeoInterface.distance(geom, geom) isa Number

    @test GeoInterface.isgeometry(GeoInterface.buffer(geom, 1.0))
    @test GeoInterface.isgeometry(GeoInterface.convexhull(geom))

    @test GeoInterface.astext(geom) isa String
    @test GeoInterface.asbinary(geom) isa Vector{UInt8}
end

@testset "Base Implementations" begin

    @testset "Vector" begin
        geom = [1, 2]
        @test !GeoInterface.is3d(geom)
        @test !GeoInterface.ismeasured(geom)
        @test testgeometry(geom)
        @test collect(GeoInterface.getcoord(geom)) == geom
        @test GeoInterface.ncoord(geom) == 2
        @test GeoInterface.x(geom) == 1
        @test GeoInterface.y(geom) == 2
        @test_throws ArgumentError GeoInterface.z(geom)
        @test_throws ArgumentError GeoInterface.m(geom)
        @test GeoInterface.extent(geom) == Extents.Extent(X=(1, 1), Y=(2, 2))
        geom = [1, 2, 3]
        @test testgeometry(geom)
        @test collect(GeoInterface.getcoord(geom)) == geom
        @test GeoInterface.is3d(geom)
        @test !GeoInterface.ismeasured(geom)
        @test GeoInterface.x(geom) == 1
        @test GeoInterface.y(geom) == 2
        @test GeoInterface.z(geom) == 3
        @test_throws ArgumentError GeoInterface.m(geom)
        geom = [1, 2, 3, 4]
        @test testgeometry(geom)
        @test collect(GeoInterface.getcoord(geom)) == geom
        @test GeoInterface.is3d(geom)
        @test GeoInterface.ismeasured(geom)
        @test GeoInterface.ncoord(geom) == 4
        @test GeoInterface.x(geom) == 1
        @test GeoInterface.y(geom) == 2
        @test GeoInterface.z(geom) == 3
        @test GeoInterface.m(geom) == 4
        geom = [1, 2, 3, 4, 5]
        @test !GeoInterface.is3d(geom)
        @test !GeoInterface.ismeasured(geom)
        @test_throws ArgumentError GeoInterface.x(geom)
        @test_throws ArgumentError GeoInterface.y(geom)
        @test_throws ArgumentError GeoInterface.z(geom)
        @test_throws ArgumentError GeoInterface.m(geom)
    end

    @testset "Tuple" begin
        geom = (1, 2.0f0)
        @test GeoInterface.trait(geom) isa PointTrait
        @test GeoInterface.geomtrait(geom) isa PointTrait
        @test testgeometry(geom)
        @test !GeoInterface.is3d(geom)
        @test !GeoInterface.ismeasured(geom)
        @test GeoInterface.x(geom) === 1
        @test GeoInterface.y(geom) === 2.0f0
        @test_throws ArgumentError GeoInterface.z(geom)
        @test_throws ArgumentError GeoInterface.m(geom)
        @test GeoInterface.ncoord(geom) == 2
        @test collect(GeoInterface.getcoord(geom)) == [1, 2]
        geom = (1, 2, 3.0)
        @test GeoInterface.trait(geom) isa PointTrait
        @test GeoInterface.geomtrait(geom) isa PointTrait
        @test testgeometry(geom)
        @test GeoInterface.is3d(geom)
        @test !GeoInterface.ismeasured(geom)
        @test GeoInterface.x(geom) === 1
        @test GeoInterface.y(geom) === 2
        @test GeoInterface.z(geom) === 3.0
        @test_throws ArgumentError GeoInterface.m(geom)
        @test GeoInterface.ncoord(geom) == 3
        @test collect(GeoInterface.getcoord(geom)) == [1, 2, 3]
        geom = (1, 2, 3, 4.0)
        @test GeoInterface.trait(geom) isa PointTrait
        @test GeoInterface.geomtrait(geom) isa PointTrait
        @test testgeometry(geom)
        @test GeoInterface.is3d(geom)
        @test GeoInterface.ismeasured(geom)
        @test GeoInterface.x(geom) === 1
        @test GeoInterface.y(geom) === 2
        @test GeoInterface.z(geom) === 3
        @test GeoInterface.m(geom) === 4.0
        @test GeoInterface.ncoord(geom) == 4
        @test collect(GeoInterface.getcoord(geom)) == [1, 2, 3, 4]
        geom = (1, 2, 3, 4.0, 5)
        @test GeoInterface.isgeometry(geom) == false
        @test GeoInterface.trait(geom) isa Nothing
        @test GeoInterface.geomtrait(geom) isa Nothing
        @test_throws MethodError GeoInterface.x(geom)
        @test_throws MethodError GeoInterface.y(geom)
        @test_throws MethodError GeoInterface.z(geom)
        @test_throws MethodError GeoInterface.m(geom)
        @test_throws MethodError GeoInterface.ncoord(geom) == 4
        @test_throws MethodError GeoInterface.getcoord(geom)
    end

    @testset "NamedTuple" begin
        geom = (; X=1, Y=2.0)
        @test GeoInterface.is3d(geom) == false
        @test GeoInterface.ismeasured(geom) == false
        @test GeoInterface.trait(geom) isa PointTrait
        @test GeoInterface.geomtrait(geom) isa PointTrait
        @test testgeometry(geom)
        @test GeoInterface.x(geom) == 1
        @test GeoInterface.y(geom) == 2.0
        @test_throws ArgumentError GeoInterface.z(geom)
        @test_throws ArgumentError GeoInterface.m(geom)
        @test collect(GeoInterface.getcoord(geom)) == [1, 2]

        geom = (; X=1.0, Y=2.0, Z=0x03)
        @test testgeometry(geom)
        @test GeoInterface.is3d(geom)
        @test GeoInterface.ismeasured(geom) == false
        @test GeoInterface.coordnames(geom) == (:X, :Y, :Z)
        @test GeoInterface.x(geom) == 1
        @test GeoInterface.y(geom) == 2.0
        @test GeoInterface.z(geom) == 0x03
        @test_throws ArgumentError GeoInterface.m(geom)

        geom = (; X=1, Y=2, Z=3.0f0, M=4.0)
        @test GeoInterface.trait(geom) isa PointTrait
        @test GeoInterface.geomtrait(geom) isa PointTrait
        @test GeoInterface.is3d(geom)
        @test GeoInterface.ismeasured(geom)
        @test GeoInterface.coordnames(geom) == (:X, :Y, :Z, :M)
        @test GeoInterface.ncoord(geom) == 4
        @test testgeometry(geom)
        @test GeoInterface.x(geom) === 1
        @test GeoInterface.y(geom) === 2
        @test GeoInterface.z(geom) === 3.0f0
        @test GeoInterface.m(geom) === 4.0
        @test GeoInterface.ncoord(geom) == 4
        @test GeoInterface.getcoord(geom, 1) === 1
        @test GeoInterface.getcoord(geom, 2) === 2
        @test GeoInterface.getcoord(geom, 3) === 3.0f0
        @test GeoInterface.getcoord(geom, 4) === 4.0
        @test collect(GeoInterface.getcoord(geom)) == [1, 2, 3, 4]

        geom = (; Z=3, X=1, Y=2, M=4)
        @test testgeometry(geom)
        @test collect(GeoInterface.getcoord(geom)) == [3, 1, 2, 4]
        @test GeoInterface.coordnames(geom) == (:Z, :X, :Y, :M)

        geom = (; A=0, X=1, Y=2, Z=3.0f0, M=4.0)
        @test GeoInterface.trait(geom) isa Nothing
        @test GeoInterface.geomtrait(geom) isa Nothing
        @test_throws MethodError GeoInterface.x(geom)
        @test_throws MethodError GeoInterface.y(geom)
        @test_throws MethodError GeoInterface.z(geom)
        @test_throws MethodError GeoInterface.m(geom)
        @test_throws MethodError GeoInterface.ncoord(geom) == 4
        @test_throws MethodError GeoInterface.getcoord(geom)
    end

    @testset "NamedTupleFeature" begin
        feature = (; geometry=(1, 2), a="x", b="y", c="z")
        GeoInterface.geometry(feature) = (1, 2)
        @test GeoInterface.properties(feature) == (a="x", b="y", c="z")
        @test GeoInterface.testfeature(feature)
        @test GeoInterface.testfeaturecollection([feature, feature])
    end


end

@testset "extent and crs fallback to nothing on unknown objects" begin
    @test isnothing(GeoInterface.crs(nothing))
    @test isnothing(GeoInterface.extent(nothing))
end

module ConvertTestModule
using GeoInterface
struct TestPolygon end
geointerface_geomtype(::GeoInterface.PolygonTrait) = TestPolygon

GeoInterface.isgeometry(::TestPolygon) = true
GeoInterface.geomtrait(::TestPolygon) = PolygonTrait()
GeoInterface.ngeom(::PolygonTrait, geom::TestPolygon) = 2
GeoInterface.getgeom(::PolygonTrait, geom::TestPolygon, i) = TestCurve()
GeoInterface.convert(::Type{<:TestPolygon}, ::PolygonTrait, geom) = TestPolygon()
end

module BadModule
end

@test GeoInterface.convert(ConvertTestModule, MyPolygon()) == ConvertTestModule.TestPolygon()
@test GeoInterface.convert(ConvertTestModule)(MyPolygon()) == ConvertTestModule.TestPolygon()
@test_throws ArgumentError GeoInterface.convert(BadModule, MyPolygon()) == ConvertTestModule.TestPolygon()
@test_throws ArgumentError GeoInterface.convert(BadModule)(MyPolygon()) == ConvertTestModule.TestPolygon()


struct ExtentPolygon end
GeoInterface.geomtrait(::ExtentPolygon) = PolygonTrait()
Extents.extent(::ExtentPolygon) = Extent(X=(1, 2), Y=(3, 4))

@testset "Extents.jl extent fallback" begin
    @test GeoInterface.extent(ExtentPolygon()) == Extent(X=(1, 2), Y=(3, 4))
    @test isnothing(GeoInterface.extent(1))
    @test isnothing(GeoInterface.extent(nothing, 1))
end

@testset "Extent as RectangleTrait" begin
    # Create an extent
    extent = Extent(X=(1.0, 3.0), Y=(2.0, 4.0))
    
    @test GeoInterface.isgeometry(extent)
    @test GeoInterface.geomtrait(extent) isa RectangleTrait
    @test GeoInterface.ncoord(extent) == 2
    @test GeoInterface.ngeom(extent) == 1
    
    ring = GeoInterface.getgeom(extent, 1)
    @test GeoInterface.geomtrait(ring) isa LinearRingTrait
    @test GeoInterface.npoint(ring) == 5  # 4 corners + closing point
    @inferred GeoInterface.getpoint(extent)
    corners = collect(GeoInterface.getpoint(extent))
    @test corners[1] == (1.0, 2.0)  # bottom-left
    @test corners[2] == (3.0, 2.0)  # bottom-right
    @test corners[3] == (3.0, 4.0)  # top-right
    @test corners[4] == (1.0, 4.0)  # top-left
    @test corners[5] == (1.0, 2.0)  # closed ring
    
    @test testgeometry(extent)
end

# Defaults for many of the interface functions are defined here as fallback.
# Methods here should take a trait instance as first argument and should already be defined
# in the `interface.jl` first as a generic f(geom) method.

## Coords
# Four options in SF, xy, xyz, xym, xyzm
const default_coord_names = (:X, :Y, :Z, :M)

coordnames(t::AbstractGeometryTrait, geom) = default_coord_names[1:ncoord(t, geom)]

@inline coordtype(::FeatureCollectionTrait, fc) = coordtype(getfeature(fc, 1))
@inline coordtype(::FeatureTrait, feature) = coordtype(geometry(feature))
@inline coordtype(::AbstractGeometryTrait, geom) = coordtype(getgeom(geom, 1))
@inline coordtype(::PointTrait, geom) = typeof(x(geom))

# Maybe hardcode dimension order? At least for X and Y?
x(t::AbstractPointTrait, geom) = getcoord(t, geom, findfirst(isequal(:X), coordnames(geom)))
y(t::AbstractPointTrait, geom) = getcoord(t, geom, findfirst(isequal(:Y), coordnames(geom)))
z(t::AbstractPointTrait, geom) = getcoord(t, geom, findfirst(isequal(:Z), coordnames(geom)))
m(t::AbstractPointTrait, geom) = getcoord(t, geom, findfirst(isequal(:M), coordnames(geom)))

is3d(::AbstractGeometryTrait, geom) = :Z in coordnames(geom)
ismeasured(::AbstractGeometryTrait, geom) = :M in coordnames(geom)
isempty(::AbstractGeometryTrait, geom) = false

## Points
ngeom(::AbstractPointTrait, geom) = 0
getgeom(::AbstractPointTrait, geom) = nothing
getgeom(::AbstractPointTrait, geom, i) = nothing

## LineStrings
npoint(t::AbstractCurveTrait, geom) = ngeom(t, geom)
getpoint(t::AbstractCurveTrait, geom) = getgeom(t, geom)
getpoint(t::AbstractCurveTrait, geom, i) = getgeom(t, geom, i)
startpoint(t::AbstractCurveTrait, geom) = getpoint(t, geom, 1)
endpoint(t::AbstractCurveTrait, geom) = getpoint(t, geom, npoint(geom))

## Polygons
nring(t::AbstractPolygonTrait, geom) = ngeom(t, geom)
getring(t::AbstractPolygonTrait, geom) = getgeom(t, geom)
getring(t::AbstractPolygonTrait, geom, i) = getgeom(t, geom, i)
getexterior(t::AbstractPolygonTrait, geom) = getring(t, geom, 1)
nhole(t::AbstractPolygonTrait, geom) = nring(t, geom) - 1
gethole(t::AbstractPolygonTrait, geom) = (getgeom(t, geom, i) for i in 2:ngeom(t, geom))
gethole(t::AbstractPolygonTrait, geom, i) = getring(t, geom, i + 1)
npoint(t::AbstractPolygonTrait, geom) = sum(npoint(p) for p in getring(t, geom); init=0)
getpoint(t::AbstractPolygonTrait, geom) = flatten((p for p in getpoint(r)) for r in getring(t, geom))

## MultiPoint
npoint(t::AbstractMultiPointTrait, geom) = ngeom(t, geom)
getpoint(t::AbstractMultiPointTrait, geom) = getgeom(t, geom)
getpoint(t::AbstractMultiPointTrait, geom, i) = getgeom(t, geom, i)

## MultiLineString
nlinestring(t::AbstractMultiCurveTrait, geom) = ngeom(t, geom)
getlinestring(t::AbstractMultiCurveTrait, geom) = getgeom(t, geom)
getlinestring(t::AbstractMultiCurveTrait, geom, i) = getgeom(t, geom, i)
npoint(t::AbstractMultiCurveTrait, geom) = sum(npoint(ls) for ls in getgeom(t, geom); init=0)
getpoint(t::AbstractMultiCurveTrait, geom) = flatten((p for p in getpoint(ls)) for ls in getgeom(t, geom))

## MultiPolygon
npolygon(t::AbstractMultiPolygonTrait, geom) = ngeom(t, geom)
getpolygon(t::AbstractMultiPolygonTrait, geom) = getgeom(t, geom)
getpolygon(t::AbstractMultiPolygonTrait, geom, i) = getgeom(t, geom, i)
nring(t::AbstractMultiPolygonTrait, geom) = sum(nring(p) for p in getpolygon(t, geom); init=0)
getring(t::AbstractMultiPolygonTrait, geom) = flatten((r for r in getring(p)) for p in getpolygon(t, geom))
npoint(t::AbstractMultiPolygonTrait, geom) = sum(npoint(r) for r in getring(t, geom); init=0)
getpoint(t::AbstractMultiPolygonTrait, geom) = flatten((p for p in getpoint(r)) for r in getring(t, geom))

## Surface
npatch(t::AbstractPolyhedralSurfaceTrait, geom)::Integer = ngeom(t, geom)
getpatch(t::AbstractPolyhedralSurfaceTrait, geom) = getgeom(t, geom)
getpatch(t::AbstractPolyhedralSurfaceTrait, geom, i::Integer) = getgeom(t, geom, i)
getpoint(t::AbstractPolyhedralSurfaceTrait, geom) = flatten((p for p in getpoint(g)) for g in getgeom(t, geom))

## Default iterator
getgeom(t::AbstractGeometryTrait, geom) = (getgeom(t, geom, i) for i in 1:ngeom(t, geom))
getcoord(t::AbstractPointTrait, geom) = (getcoord(t, geom, i) for i in 1:ncoord(t, geom))

## Special geometries
npoint(::LineTrait, geom) = 2
npoint(::TriangleTrait, geom) = 3
nring(::TriangleTrait, geom) = 1
npoint(::RectangleTrait, geom) = 4
nring(::RectangleTrait, geom) = 1
npoint(::QuadTrait, geom) = 4
nring(::QuadTrait, geom) = 1
npoint(::PentagonTrait, geom) = 5
nring(::PentagonTrait, geom) = 1
npoint(::HexagonTrait, geom) = 6
nring(::HexagonTrait, geom) = 1

# TODO Only simple if it's also not intersecting itself, except for its endpoints
issimple(t::AbstractCurveTrait, geom) = allunique((getpoint(t, geom, i) for i in 1:npoint(geom)-1)) && allunique((getpoint(t, geom, i) for i in 2:npoint(t, geom)))
isclosed(t::AbstractCurveTrait, geom) = getpoint(t, geom, 1) == getpoint(t, geom, npoint(t, geom))
isring(t::AbstractCurveTrait, geom) = issimple(t, geom) && isclosed(t, geom)

issimple(t::AbstractMultiPointTrait, geom) = allunique((getgeom(t, geom)))

issimple(t::AbstractMultiCurveTrait, geom) = all(issimple.(getgeom(t, geom)))
isclosed(t::AbstractMultiCurveTrait, geom) = all(isclosed.(getgeom(t, geom)))

"The key used to retrieve and store the CRS from DataAPI.jl metadata, if no other solution exists in that format."
const GEOINTERFACE_CRS_KEY = "GEOINTERFACE:crs"

crs(::Nothing, geom) = _get_dataapi_metadata(geom, GEOINTERFACE_CRS_KEY, nothing) # see `metadata.jl`
crs(::AbstractTrait, geom) = _get_dataapi_metadata(geom, GEOINTERFACE_CRS_KEY, nothing) # see `metadata.jl`

# FeatureCollection
getfeature(t::AbstractFeatureCollectionTrait, fc) = (getfeature(t, fc, i) for i in 1:nfeature(t, fc))

# Backwards compatibility
coordinates(t::AbstractPointTrait, geom) = collect(getcoord(t, geom))
coordinates(t::AbstractGeometryTrait, geom) = map(coordinates, getgeom(t, geom))
function coordinates(t::AbstractFeatureTrait, feature)
    geom = geometry(feature)
    isnothing(geom) ? [] : coordinates(geom)
end
coordinates(t::AbstractFeatureCollectionTrait, fc) = map(f -> coordinates(f), getfeature(t, fc))

extent(::Any, x) = Extents.extent(x)
function calc_extent(t::AbstractPointTrait, geom)
    x = GeoInterface.x(t, geom)
    y = GeoInterface.y(t, geom)
    if is3d(geom)
        z = GeoInterface.z(t, geom)
        return Extent(; X=(x, x), Y=(y, y), Z=(z, z))
    else
        return Extent(; X=(x, x), Y=(y, y))
    end
end
function calc_extent(t::AbstractGeometryTrait, geom)
    isempty(t, geom) && return nothing
    points = getpoint(t, geom)
    X = extrema(p -> x(p), points)
    Y = extrema(p -> y(p), points)
    if is3d(geom)
        Z = extrema(p -> z(p), points)
        Extent(; X, Y, Z)
    else
        Extent(; X, Y)
    end
end
calc_extent(t::GeometryCollectionTrait, geom) = reduce(Extents.union, (extent(f) for f in getgeom(t, geom)))
function calc_extent(::AbstractFeatureTrait, feature)
    geom = geometry(feature)
    isnothing(geom) ? nothing : extent(geom)
end
calc_extent(t::AbstractFeatureCollectionTrait, fc) = reduce(Extents.union, filter(!isnothing, collect(extent(f) for f in getfeature(t, fc))))

# Package level `GeoInterface.convert` method
# Packages must implement their own `traittype` method
# that accepts a GeoInterface.jl trait and returns the
# corresponding geometry type
function convert(package::Module, geom)
    t = trait(geom)
    convert(package, t, geom)
end
function convert(package::Module, t::AbstractTrait, geom)
    isdefined(package, :geointerface_geomtype) || throw(ArgumentError("$package does not implement `geointerface_geomtype`. Please request this be implemented in a github issue."))
    convert(package.geointerface_geomtype(t), t, geom)
end

# Subtraits

"""
    subtrait(t::AbstractGeometryTrait)

Gets the expected, possible abstract, (sub)trait for subgeometries (retrieved with
[`getgeom`](@ref)) of trait `t`. This follows the [Type hierarchy](@ref) of Simple Features.

# Examples
```jldoctest; setup = :(using GeoInterface)
julia> GeoInterface.subtrait(LineStringTrait())
AbstractPointTrait
julia> GeoInterface.subtrait(PolygonTrait())  # Any of LineStringTrait, LineTrait, LinearRingTrait
AbstractLineStringTrait
```
```jldoctest; setup = :(using GeoInterface)
# `nothing` is returned when there's no subtrait or when it's not known beforehand
julia> isnothing(GeoInterface.subtrait(PointTrait()))
true
julia> isnothing(GeoInterface.subtrait(GeometryCollectionTrait()))
true
```
"""
subtrait(::AbstractPointTrait) = nothing
subtrait(::AbstractCurveTrait) = AbstractPointTrait
subtrait(::AbstractCurvePolygonTrait) = AbstractCurveTrait
subtrait(::AbstractPolygonTrait) = AbstractLineStringTrait
subtrait(::AbstractPolyhedralSurfaceTrait) = AbstractPolygonTrait
subtrait(::TINTrait) = TriangleTrait
subtrait(::AbstractMultiPointTrait) = AbstractPointTrait
subtrait(::AbstractMultiLineStringTrait) = AbstractLineStringTrait
subtrait(::AbstractMultiPolygonTrait) = AbstractPolygonTrait
subtrait(::AbstractMultiSurfaceTrait) = AbstractSurfaceTrait
subtrait(::AbstractGeometryCollectionTrait) = nothing
subtrait(::AbstractGeometryTrait) = nothing  # fallback

```@meta
CurrentModule = GeoInterface
```

# GeoInterface
[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://juliageo.github.io/GeoInterface.jl/stable)
[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://juliageo.github.io/GeoInterface.jl/dev)
[![Build Status](https://github.com/JuliaGeo/GeoInterface.jl/actions/workflows/CI.yml/badge.svg?branch=main)](https://github.com/JuliaGeo/GeoInterface.jl/actions/workflows/CI.yml?query=branch%3Amain)

*An interface for geospatial vector data in Julia*

This Package describe a set of traits based on the [Simple Features standard (SF)](https://www.opengeospatial.org/standards/sfa)
for geospatial vector data, including the SQL/MM extension with support for circular geometry.
By using these traits, it should be easy to parse, serialize and use different custom geometries in the Julia ecosystem,
without knowing the specifics of each individual package. In that regard it is similar to Tables.jl, but for geometries instead of tables.

Packages which support the GeoInterface.jl interface can be found in [Packages](@ref).

For usage see [Traits interface](@ref), while if you look to implement GeoInterface in your own package, check out [Implementing GeoInterface](@ref).
For background about the interface and Simple Features, see [Changes with respect to SF](@ref).

!!! compat
    This traits interface is new and is a major departure from previous pre-1.0 releases. See [History](@ref) for more information. Feel free to ask questions on Github.

```@meta
CurrentModule = GeoInterface
```

# Simple Features
Simple Features ([SF](https://en.wikipedia.org/wiki/Simple_Features)) are OGC standards describing two dimensional geographic features, such as Points and Polygons and the relations between them.
The standards describe a hierarchy of types (Part 1), a functional interface with SQL (Part II) and an SQL/MM extension with support for circular geometry types, such as `Circularstring`.

## Type hierarchy
All types used here come from the SF. We added `Trait` to all geometry types here to distinguish them from actual geometry structs.

![SF Type hierarchy. From the Simple Feature standard by OGC.](types.png)
`The SF Type hierarchy. From OpenGIS® Implementation Standard for Geographic information - Simple feature access - Part 1: Common architecture at http://www.opengis.net/doc/is/sfa/1.2.1.`


## Changes with respect to SF
While we try to adhere to SF, there are changes and extensions to make it more Julian.

### Function names
All function names are without the `ST_` prefix and are lowercased. In some cases the names have changed as well, to be inline with common Julia functions. `NumX` becomes `nx` and `geomN` becomes `getgeom`:
```julia
GeometryType -> geomtrait
NumGeometries -> ngeom
GeometryN -> getgeom
NumPatches -> npatch
# etc
```

We generalized [`ngeom`](@ref) and [`getgeom`](@ref) to apply to 
all geometries, not just a [`AbstractGeometryCollectionTrait`](@ref)s.

We also simplified the dimension functions. From the three original (`dimension`, `coordinateDimension`, `spatialDimension`) there's now only the coordinate dimension, by using `ncoords`, which represent coordinate dimensions like `X`, `Y`, `Z` and `M`. Topological dimensions (a point is 0-dimensional), and the functions related to it, are not used in this interface to prevent confusion. Similarly, we do not overload the Julia `ndims`, to prevent confusion and possible conflict with custom vector based geometries.

```julia
coordinateDimension -> ncoords  # x, y, z, m
dimension -> unused
spatialDimension -> unused
```

We've generalized the naming of some functions:
```julia
SRID -> crs
envelope -> extent  # also aliased to bbox
```

And added a helper method to clarify the naming of coordinates.
```julia
coordnames = (:X, :Y, :Z, :M)
```

### Coverage
Not all SF functions are implemented, either as a possibly slower fallback or empty descriptor or not at all. The following SF functions are not (yet) available.

```julia
dimension  # topological dimensions
spatialDimension

locateAlong
locateBetween
```

# Packages
Packages currently integrating with GeoInterface.jl:
* [AlgebraOfGraphics](https://github.com/JuliaPlots/AlgebraOfGraphics.jl.git)
* [ArchGDAL](https://github.com/yeesian/ArchGDAL.jl.git)
* [GADM](https://github.com/JuliaGeo/GADM.jl.git)
* [GeoData](https://github.com/rafaqz/GeoData.jl.git)
* [GeoDatasets](https://github.com/JuliaGeo/GeoDatasets.jl.git)
* [GeoJSON](https://github.com/JuliaGeo/GeoJSON.jl.git)
* [GeoMakie](https://github.com/JuliaPlots/GeoMakie.jl.git)
* [GeoTables](https://github.com/JuliaEarth/GeoTables.jl.git)
* [GeometryOps](https://github.com/asinghvi17/GeometryOps.jl.git)
* [LibGEOS](https://github.com/JuliaGeo/LibGEOS.jl.git)
* [Mangal](https://github.com/EcoJulia/Mangal.jl.git)
* [OmniSci](https://github.com/omnisci/OmniSci.jl.git)
* [Rasters](https://github.com/rafaqz/Rasters.jl.git)
* [Shapefile](https://github.com/JuliaGeo/Shapefile.jl.git)
* [SortTileRecursiveTree](https://github.com/maxfreu/SortTileRecursiveTree.jl.git)
* [SpatialDependence](https://github.com/javierbarbero/SpatialDependence.jl.git)
* [Turf](https://github.com/philoez98/Turf.jl.git)

```@meta
CurrentModule = GeoInterface
```

# Defaults
There are *many* function in SF, but most only apply to a single geometry type.
Of note here are the `ngeom` and `getgeom` for each geometry type, which translate to the following function for each type automatically:

|                            | ngeom       | getgeom       |
|----------------------------|-------------|---------------|
| [`AbstractPointTrait`](@ref)              | -           | -             |
| [`AbstractCurveTrait`](@ref), [`MultiPointTrait`](@ref)  | [`npoint(geom)`](@ref)      | [`getpoint(geom)`](@ref)      |
| [`AbstractPolygonTrait`](@ref)            | [`nring(geom)`](@ref)       | [`getring(geom)`](@ref)       |
| [`AbstractMultiLineStringTrait`](@ref)    | [`nlinestring(geom)`](@ref) | [`getlinestring(geom)`](@ref) |
| [`AbstractMultiPolygonTrait`](@ref)       | [`npolygon(geom)`](@ref)    | [`getpolygon(geom)`](@ref)    |
| [`AbstractPolyhedralSurfaceTrait`](@ref)  | [`npatch(geom)`](@ref)      | [`getpatch(geom)`](@ref)      |
| [`AbstractGeometryCollectionTrait`](@ref) | [`ngeom(geom)`](@ref)       | [`getgeom(geom)`](@ref)       |

## Polygons
Of note are `PolygonTrait`s, which can have holes, for which we automatically add the following
functions based on the `ngeom` implemented by package authors. In some cases, the assumptions here
are not correct (most notably Shapefile), where the second ring is not necessarily a hole, but could
be another exterior.

```julia
getexterior(p::AbstractPolygonTrait, geom) = getring(p, geom, 1)
nhole(p::AbstractPolygonTrait, geom) = nring(p, geom) - 1
gethole(p::AbstractPolygonTrait, geom, i) = getring(p, geom, i + 1)
```
## LineStrings
Similarly for `LineStringTrait`s, we have the following
```julia
startpoint(geom) = getpoint(geom, 1)
endpoint(geom) = getpoint(geom, length(geom))
```

## Fallbacks
In some cases, we know the return value of a function for a specific geometry (sub)type beforehand and have implemented them.

```julia
npoint(::LineTrait, geom) = 2
npoint(::TriangleTrait, geom) = 3
npoint(::RectangleTrait, geom) = 4
npoint(::QuadTrait, geom) = 4
npoint(::PentagonTrait, geom) = 5
npoint(::HexagonTrait, geom) = 6
```

# Implementations
GeoInterface is implemented for `NTuple`s, `NamedTuple`s and `AbstractVector`s to behave as Points. Note the `eltype` in all cases should be a `Real`. Only the keys `X`, `Y`, `Z`, and `M` are supported for `NamedTuple`s.

```julia
a = [1, 2, 3]
GeoInterface.x(a) == 1

b = (1, 2, 3)
GeoInterface.y(b) == 2

c = (;X=1, Y=2, Z=3)
GeoInterface.z(c) == 3
```

# Wrapper types

It is common that a package does not implement all objects supported by
GeoInterface.jl, and may lack the ability to define features. It is useful
to define generic objects that can be used in testing and for scripting where
geometries need to be constructed from components. Using generic wrappers 
means this is backend agnostic: the same code will work if geometries come from
GeoJSON.jl, Shapefile.jl, LibGEOS.jl, or other packages defining GeoInterface.jl
traits.

Wrapper types are provided for constructing geometries out of any lower-level
components that implement GeoInterface.jl traits. These wrappers can wrap
objects of the same trait (possibly to add extent data), vectors of child
objects, or nested vectors of lower level children, such as points.

As an example, we can construct a polygon from any GeoInterface.jl compatible 
geometries that return `LinearRingTrait` from `GeoInterface.geomtrait`:

```julia
poly = Polygon([interior, hole1, hole2])
```

See the API documentation for each wrapper for more details.

- [`Point`](@ref)
- [`Line`](@ref)
- [`LineString`](@ref)
- [`LinearRing`](@ref)
- [`Polygon`](@ref)
- [`MultiLineString`](@ref)
- [`MultiPolygon`](@ref)
- [`MultiPoint`](@ref)
- [`PolyhedralSurface`](@ref)
- [`GeometryCollection`](@ref)

Wrappers for Triangle, Hexagon and some other geometries are yet to be implemented.
Please make a GitHub issue if you need them.

Feature and FeatureCollection wrappers are also provided, to add properties,
crs and extents to any GeoInterface.jl compatible geometries.

- [`Feature`](@ref)
- [`FeatureCollection`](@ref)

Wrappers are not exported by default because they are very common names used by
other packages. To use them directly, run `using GeoInterface.Wrappers`.

```@meta
CurrentModule = GeoInterface
```

# Implementing GeoInterface
GeoInterface requires six functions to be defined for a custom geometry. On top of that
it could be useful to also implement some optional methods if they apply or are faster than the [Fallbacks](@ref).

If your package also supports geospatial operations on geometries--such as intersections--, please
also implement those interfaces where applicable.

GeoInterface also has some utility packages, `GeoInterfaceMakie` and `GeoInterfaceRecipes`, 
which provide plotting support through their `@enable` macros.
If you wish to implement plotting support for your geometry, please create a [package extension](https://pkgdocs.julialang.org/v1/creating-packages/#Conditional-loading-of-code-in-packages-(Extensions)) 
that extends either `Makie` (for the Makie.jl ecosystem) or `RecipesBase` (for the Plots.jl ecosystem).
You can find some examples of this pattern in [Shapefile.jl](https://github.com/JuliaGeo/Shapefile.jl/blob/main/ext/ShapefileMakieExt.jl) and [GeoJSON.jl](https://github.com/JuliaGeo/GeoJSON.jl/blob/main/ext/GeoJSONMakieExt.jl).

Last but not least, we also provide an interface for rasters and features--geometries with properties--if applicable.

## Required for Geometry

```julia
GeoInterface.isgeometry(geom::customgeom)::Bool = true
GeoInterface.geomtrait(geom::customgeom)::DataType = XTrait() # <: AbstractGeometryTrait
# for PointTraits
GeoInterface.ncoord(geomtrait(geom), geom::customgeom)::Integer
GeoInterface.getcoord(geomtrait(geom), geom::customgeom, i)::Real
# for non PointTraits
GeoInterface.ngeom(geomtrait(geom), geom::customgeom)::Integer
GeoInterface.getgeom(geomtrait(geom), geom::customgeom, i)
```
Where the `getgeom` and `getcoord` could be an iterator (without the `i`) as well. It will return a new geom with the correct `geomtrait`.
This means that a call to `getgeom` on a geometry that has a `LineStringTrait` should return something that implements the `PointTrait`. This hierarchy can be checked programmatically with [`subtrait`](@ref). You read more about the `geomtrait` in the [Type hierarchy](@ref).

The `ngeom` and `getgeom` are aliases for their geom specific counterparts, such as `npoints` and `getpoint` for `LineStringTrait`s.


## Optional for Geometry

There are also optional generic methods that could help with locating this geometry.
```julia
GeoInterface.crs(trait(geom), geom::customgeom)::GeoFormatTypes.CoordinateReferenceSystem
GeoInterface.extent(trait(geom), geom::customgeom)::Extents.Extent
```

For extents, `Extents.extent(geom::customgeom)` is the fallback method for GeoInterface.extent, 
and can be used instead here for wider interoperability. If neither is defined,
`GeoInterface.extent` will calculate the extent from the points of the geometry.

And lastly, there are many other optional functions for each specific geometry. GeoInterface provides fallback implementations based on the generic functions above, but these are not optimized. These are detailed in [Fallbacks](@ref).

### Conversion
It is useful if others can convert any custom geometry into your
geometry type, if their custom geometry supports GeoInterface as well.
This requires the following methods, where the implementation should be defined in terms
of GeoInterface methods like `ngeom`, `getgeom`, or just `coordinates` calls.

```julia
# This method will get called on GeoInterface.convert(::Type{T}, geom)
# if geomtrait(geom) == LineStringTrait()
GeoInterface.convert(::Type{CustomLineString}, ::LineStringTrait, geom) = ...
GeoInterface.convert(::Type{CustomPolygon}, ::PolygonTrait, geom) = ...
```

## Required for Rasters
A Raster is something that is an AbstractArray
```julia
GeoInterface.israster(raster::customraster)::Bool = true
GeoInterface.trait(::customraster) = RasterTrait()
GeoInterface.extent(::RasterTrait, raster::customraster)::Extents.Extent
GeoInterface.crs(::RasterTrait, raster::customraster)::GeoFormatTypes.CoordinateReferenceSystem
```

## Required for Feature(Collection)s
A Feature is a geometry with properties, and in modern parlance, a row in table.
A FeatureCollection is thus a Vector of Features, often represented as a table.

A Feature implements the following:
```julia
GeoInterface.isfeature(feat::customfeat)::Bool = true
GeoInterface.properties(feat::customfeat)
GeoInterface.geometry(feat::customfeat)
```

While a FeatureCollection implements the following:
```julia
GeoInterface.isfeaturecollection(::Type{customcollection}) = true
GeoInterface.getfeature(trait(::customcollection), ::customcollection, i)
GeoInterface.nfeature(trait(::customcollection), ::customcollection)
GeoInterface.geometrycolumns(::customcollection) = (:geometry,)  # can be multiple!
```

The `geometrycolumns` enables other packages to know which field in a row, or column in a table, contains the geometry or geometries.

It's important to note that the `geometrycolumns` should always return a `Tuple` of `Symbol`s.  However, it does have a fallback method
that uses [DataAPI.jl](https://github.com/JuliaData/DataAPI.jl) metadata, if it exists, to retrieve the geometry columns.  This relies on
the `"GEOINTERFACE:geometrycolumns"` metadata key.  GeoInterface.jl compatible writers may set this metadata key if writing to a format
that does not have its own mechanism to store known geometry columns, like Arrow.

Optionally, the `crs` method can also be implemented:
```julia
GeoInterface.crs(::customcollection)
```

This should return a `GeoFormatTypes.CoordinateReferenceSystem` type, such as `EPSG(code::Int)`, `WellKnownText(GeoFormatTypes.CRS(), wkt::String)`, 
or `ProjString(p4::String)`.  See [GeoFormatTypes.jl](https://github.com/JuliaGeo/GeoFormatTypes.jl) for more information.

The `crs` method also has a fallback that uses [DataAPI.jl](https://github.com/JuliaData/DataAPI.jl) metadata, if it exists, to retrieve the CRS.
GeoInterface searches for the `"GEOINTERFACE:crs"` metadata key to retrieve the CRS.

## Geospatial Operations
```julia
distance(geomtrait(a), geomtrait(b), a, b)
buffer(geomtrait(geom), geom, distance)
convexhull(geomtrait(geom), geom)
```

## Geospatial Relations
These functions are used to describe the relations between geometries as defined in the Dimensionally Extended 9-Intersection Model ([DE-9IM](https://en.wikipedia.org/wiki/DE-9IM)).

```julia
equals(geomtrait(a), geomtrait(b), a, b)
disjoint(geomtrait(a), geomtrait(b), a, b)
intersects(geomtrait(a), geomtrait(b), a, b)
touches(geomtrait(a), geomtrait(b), a, b)
within(geomtrait(a), geomtrait(b), a, b)
contains(geomtrait(a), geomtrait(b), a, b)
overlaps(geomtrait(a), geomtrait(b), a, b)
crosses(geomtrait(a), geomtrait(b), a, b)
relate(geomtrait(a), geomtrait(b), a, b, relationmatrix)
```

## Geospatial Sets
```julia
symdifference(geomtrait(a), geomtrait(b), a, b)
difference(geomtrait(a), geomtrait(b), a, b)
intersection(geomtrait(a), geomtrait(b), a, b)
union(geomtrait(a), geomtrait(b), a, b)
```

## Testing the interface
GeoInterface provides a Testsuite for a geom type to check whether the required functions that have been correctly implemented and work as expected.

```julia
GeoInterface.testgeometry(geom)
GeoInterface.testfeature(geom)
```

## Examples

All custom geometries implement
```julia
GeoInterface.isgeometry(geom::customgeom)::Bool = true
```

A `geom::customgeom` with "Point"-like traits implements
```julia
GeoInterface.geomtrait(geom::customgeom)::DataType = PointTrait()
GeoInterface.ncoord(::PointTrait, geom::customgeom)::Integer
GeoInterface.getcoord(::PointTrait, geom::customgeom, i)::Real

# Defaults
GeoInterface.ngeom(::PointTrait, geom)::Integer = 0
GeoInterface.getgeom(::PointTrait, geom::customgeom, i) = nothing
```

A `geom::customgeom` with "LineString"-like traits implements the following methods:
```julia
GeoInterface.geomtrait(geom::customgeom)::DataType = LineStringTrait()
GeoInterface.ncoord(::LineStringTrait, geom::customgeom)::Integer

# These alias for npoint and getpoint
GeoInterface.ngeom(::LineStringTrait, geom::customgeom)::Integer
GeoInterface.getgeom(::LineStringTrait, geom::customgeom, i) # of geomtrait Point

# Optional
GeoInterface.isclosed(::LineStringTrait, geom::customgeom)::Bool
GeoInterface.issimple(::LineStringTrait, geom::customgeom)::Bool
GeoInterface.length(::LineStringTrait, geom::customgeom)::Real
```
A `geom::customgeom` with "Polygon"-like traits can implement the following methods:
```julia
GeoInterface.geomtrait(geom::customgeom)::DataType = PolygonTrait()
GeoInterface.ncoord(::PolygonTrait, geom::customgeom)::Integer

# These alias for nring and getring
GeoInterface.ngeom(::PolygonTrait, geom::customgeom)::Integer
GeoInterface.getgeom(::PolygonTrait, geom::customgeom, i)::"LineStringTrait"

# Optional
GeoInterface.area(::PolygonTrait, geom::customgeom)::Real
GeoInterface.centroid(::PolygonTrait, geom::customgeom)::"PointTrait"
GeoInterface.pointonsurface(::PolygonTrait, geom::customgeom)::"PointTrait"
GeoInterface.boundary(::PolygonTrait, geom::customgeom)::"LineStringTrait"
```

A `geom::customgeom` with "GeometryCollection"-like traits has to implement the following methods:
```julia
GeoInterface.geomtrait(geom::customgeom) = GeometryCollectionTrait()
GeoInterface.ncoord(::GeometryCollectionTrait, geom::customgeom)::Integer
GeoInterface.ngeom(::GeometryCollectionTrait, geom::customgeom)::Integer
GeoInterface.getgeom(::GeometryCollectionTrait,geom::customgeomm, i)::"GeometryTrait"
```

A `geom::customgeom` with "MultiPoint"-like traits has to implement the following methods:
```julia
GeoInterface.geomtrait(geom::customgeom) = MultiPointTrait()
GeoInterface.ncoord(::MultiPointTrait, geom::customgeom)::Integer

# These alias for npoint and getpoint
GeoInterface.ngeom(::MultiPointTrait, geom::customgeom)::Integer
GeoInterface.getgeom(::MultiPointTrait, geom::customgeom, i)::"PointTrait"
```

A `geom::customgeom` with "MultiLineString"-like traits has to implement the following methods:
```julia
GeoInterface.geomtrait(geom::customgeom) = MultiLineStringTrait()
GeoInterface.ncoord(::MultiLineStringTrait, geom::customgeom)::Integer

# These alias for nlinestring and getlinestring
GeoInterface.ngeom(::MultiLineStringTrait, geom::customgeom)::Integer
GeoInterface.getgeom(::MultiLineStringTrait,geom::customgeomm, i)::"LineStringTrait"
```

A `geom::customgeom` with "MultiPolygon"-like traits has to implement the following methods:
```julia
GeoInterface.geomtrait(geom::customgeom) = MultiPolygonTrait()
GeoInterface.ncoord(::MultiPolygonTrait, geom::customgeom)::Integer

# These alias for npolygon and getpolygon
GeoInterface.ngeom(::MultiPolygonTrait, geom::customgeom)::Integer
GeoInterface.getgeom(::MultiPolygonTrait, geom::customgeom, i)::"PolygonTrait"
```

```@meta
CurrentModule = GeoInterface
```

# API

## Functions
```@autodocs
Modules = [GeoInterface]
Order = [:function]
```

## Types
```@autodocs
Modules = [GeoInterface]
Order = [:type]
```

## Index
```@index
```

```@meta
CurrentModule = GeoInterface
```

# Traits interface
GeoInterface provides a traits interface, not unlike Tables.jl, by a set of functions and types for geospatial data.

## Functions
(a) a set of functions: 
```julia
isgeometry(geom)
geomtrait(geom)
ncoord(geom)
getcoord(geom, i)
ngeom(geom)
getgeom(geom, i)
...
```

## Types
(b) a set of trait-types for dispatching on said functions.

The types tell GeoInterface how to interpret the input object inside a GeoInterface function and are specific for each type of Geometry.

```julia
abstract GeometryTrait
PointTrait <: AbstractPointTrait <: AbstractGeometryTrait
MultiPointTrait <: AbstractMultiPointGeometryTrait <:AbstractGeometryCollectionTrait <: AbstractGeometryTrait
...
```

## Use
For the [Packages](@ref) that implement GeoInterface, instead of needing to write specific methods
to work with their custom geometries, you can just call the above generic functions. For example:

```
julia> using ArchGDAL
julia> geom = createpolygon(...)::ArchGDAL.IGeometry  # no idea about the interface

# Inspect with GeoInterface methods
julia> isgeometry(geom)
True
julia> geomtrait(geom)
PolygonTrait()
julia> ext = exterior(geom);
julia> geomtrait(ext)
LineStringTrait()
julia> getcoords.(getpoint.(Ref(ext), 1:npoint(ext)))
[[1.,2.],[2.,3.],[1.,2.]]
julia> coordinates(geom)  # fallback based on ngeom & npoint above

```
